<?php

namespace Zeedhi\DevOps\Model\Configurationmanager\Repositories;

use Zeedhi\DevOps\Util\Utilities as DevOpsUtilities;

class DeployCustomization extends \Doctrine\ORM\EntityRepository
{
    public function getDeployCustomization($productId, $customerCode, $filters, $limit = null, $offset = null)
    {
        $query = <<<SQL
    SELECT *
      FROM (SELECT DC.ID, DC.PRODUCT_ID, DC.PRODUCT_SERVER_ID, TO_CHAR(DC.DEPLOY_DATE, 'DD/MM/YYYY HH24:MI:SS') AS DEPLOY_DATE,
                   DC.DESCRIPTION, DC.STATUS, DC.VERSION, DC.PREVIOUS_VERSION, SR.ID AS SERVER, SR.NAME AS SERVER_NAME,
                   ZC.ID AS CREATED_BY_ID, OPC.NMOPERADOR AS CREATED_BY, DC.CREATED, NVL(PS.PATH, '-') AS BASE_PATH,
                   ZU.ID AS UPDATED_BY_ID, OPU.NMOPERADOR AS UPDATED_BY, DC.UPDATED, DC.IS_ACTIVE, SR.WSEMAIL,
                   DC.MIG_ERROR_LOG, DC.MIG_FULL_LOG
              FROM DEPLOY_CUSTOMIZATION DC
         LEFT JOIN PRODUCT_SERVER PS ON PS.ID = DC.PRODUCT_SERVER_ID
         LEFT JOIN SERVER SR         ON PS.SERVER_ID = SR.ID
              JOIN RESOURCE_T RT     ON RT.ID = DC.RESOURCE_T_ID AND RT.EXTERNAL_CODE = :EXTERNAL_CODE

         LEFT JOIN ZH_USER ZC     ON ZC.ID = DC.CREATED_BY
         LEFT JOIN RESOURCE_T RTC ON RTC.ID = ZC.EXTERNAL_RES_ID
         LEFT JOIN OPERADOR OPC   ON OPC.CDOPERADOR = RTC.EXTERNAL_CODE

         LEFT JOIN ZH_USER ZU     ON ZU.ID = DC.UPDATED_BY
         LEFT JOIN RESOURCE_T RTU ON RTU.ID = ZU.EXTERNAL_RES_ID
         LEFT JOIN OPERADOR OPU   ON OPU.CDOPERADOR = RTU.EXTERNAL_CODE

             WHERE DC.PRODUCT_ID = :PRODUCT
          ORDER BY DC.DEPLOY_DATE DESC, DC.ID DESC)
     WHERE 1 = 1
           $filters
SQL;
        $params = array(
            'PRODUCT' => $productId,
            'EXTERNAL_CODE' => $customerCode,
        );
        $query = DevOpsUtilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}
