/*! 24-10-2024 */
function ZhPreferences(RepositoryFactory,requestEngine,requestFactory,ZHPromise,Query){var repositoryMap={},userWidgetConfiguration={};this.registerRepository=function(name){var repositoryName=name.split("#").pop();repositoryMap[repositoryName]=RepositoryFactory.factory(name,"MEMORY")},this.savePreferences=function(preferenceType,preferences){return requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType+"/save",requestType:"dataSource",dataSource:preferences})).then(null,function(response){throw new Error(response.data.error)}).then(function(response){var returnedIds=response.dataset[preferenceType];return preferences.map(function(preference,index){return preference.__is_new=!1,preference.changed=!1,preference.ID=returnedIds[index].ID,preference})}).then(function(preferences){return repositoryMap[preferenceType].save(preferences)})},this.deletePreferences=function(preferenceType,preferences){return requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType+"/remove",requestType:"dataSource",dataSource:preferences})).then(null,function(response){throw new Error(response.data.error)}).then(function(response){response=response.dataset[preferenceType].map(function(preference){return preference.ID}),response=Query.build().where("ID").in(response);return repositoryMap[preferenceType].remove(response)})},this.getPreferences=function(preferenceType,query){var filterRequest=requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType,requestType:"filterData",filter:query.where()});return requestEngine.doRequest(filterRequest).then(function(response){var preferences=response.dataset[preferenceType],response=repositoryMap[preferenceType].remove(query),savePreferences=repositoryMap[preferenceType].save(preferences);return ZHPromise.all([response,savePreferences]).then(function(){return preferences})}).catch(function(response){throw new Error(response.data.error)})},this.getWidgetPreferences=function(preferenceType,widgetID){widgetID=Query.build().where("WIDGET_ID").equals(widgetID);return this.getPreferences(preferenceType,widgetID)},this.getDefaultWidgetPreferences=function(widgetID){var query;return void 0===userWidgetConfiguration[widgetID]&&(query=Query.build().where("WIDGET_ID").equals(widgetID),userWidgetConfiguration[widgetID]=requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/default-preferences",requestType:"filterData",filter:query.where()})).then(function(response){var response=response.dataset,preference=response.user_widget.pop()||{__is_new:!0,ID:null,WIDGET_ID:widgetID,DEFAULT_FILTER:null,DEFAULT_LAYOUT:null,DEFAULT_VIEW:null,LAST_MODIFIED_DATE:null};return response.defaultFilter&&response.defaultFilter.length&&(preference.defaultFilter=response.defaultFilter.pop(),preference.defaultFilter.FILTER_ROW=JSON.parse(preference.defaultFilter.FILTER_ROW)),response.defaultLayout&&response.defaultLayout.length&&(preference.defaultLayout=response.defaultLayout.pop()),response.defaultView&&response.defaultView.length&&(preference.defaultView=response.defaultView.pop()),preference})),userWidgetConfiguration[widgetID]},this.changeDefaultPreferences=function(configWidget,property,preference){var widgetID=configWidget.listWidget.id,preferenceID=preference[property]?preference.ID:null;return userWidgetConfiguration[widgetID]=this.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){return defaultPreferences[property]=preferenceID,defaultPreferences.__is_new=defaultPreferences.__is_new||!1,ZHPromise.all([defaultPreferences,requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/default-preferences/save",requestType:"dataSource",dataSource:[defaultPreferences]}))])}).then(function(args){var defaultPreferences=args[0];return defaultPreferences.ID=Util.getNestedProperty(args[1],["dataset","user_widget","0","ID"]),configWidget.dataSource.data.forEach(function(row){row.__is_new=!1,row[property]=row.ID==defaultPreferences[property]}),defaultPreferences}),userWidgetConfiguration[widgetID]},this.validateWidget=function(widget){if(!widget.id)throw new Error('Widget\'s must have "id" to use Preferences. Widget with name "'+widget.name+'" does not have an id.');if(widget.container.id)return!(widget=>{return(-1!==(template=widget.template).indexOf("master_detail/grid.html")||-1!==template.indexOf("master_detail/list.html")||-1!==template.indexOf("master_detail/tree/grid.html"))&&widget.mode==ViewMode.VIEW;var template})(widget);throw new Error('Container\'s must have "id" to use Preferences.')};var userPromise=ZHPromise.defer();this.unsetUser=function(){userPromise=ZHPromise.defer(),userWidgetConfiguration={},Object.keys(repositoryMap).forEach(function(repositoryName){repositoryMap[repositoryName].clearAll()})},this.setUserID=function(userID){userPromise.resolve(userID)},this.getUserID=function(){return userPromise.promise},this.downloadPreferenceFile=function(preference,fileName){var dataStr="data:text/json;charset=utf-8,"+encodeURIComponent(JSON.stringify(preference,!1,4)),linkElement=document.createElement("a");return linkElement.setAttribute("href",dataStr),linkElement.setAttribute("download",fileName),linkElement.click(),linkElement.remove(),ZHPromise.when(preference)}}Configuration(function(ContextRegister){ContextRegister.register("ZhPreferences",ZhPreferences)});var ZeedhiDirectives=angular.module("ZeedhiDirectives");function zhPreferenceFloatingControl(){return{priority:10,link:function($scope){$scope.togglePreferencesCard=function(e){(e=>{var actionTop,widgetTop,floatingControl=(e=$(e.target).closest(".float-action")).parents(".zh-floating-control"),widgetContainer=e.closest(".container");e.hasClass("opened")||(e.removeClass("fix-position-top"),e.removeClass("fix-position-bottom"),actionTop=e.offset().top,widgetContainer=(widgetTop=widgetContainer.offset().top)+widgetContainer.height(),floatingControl.hasClass("pos-top")?(actionTop=actionTop-200+e.height())<widgetTop&&e.addClass("fix-position-top"):widgetContainer<actionTop+200&&e.addClass("fix-position-bottom"))})(e),$scope.toggleAction(e)}}}}function ZhFilterBuilder(Query){var defaultOperators={"field/between-dates.html":Query.BETWEEN,"field/calendar.html":Query.EQ,"field/date.html":Query.EQ,"field/datetime.html":Query.EQ,"field/interval.html":{default:Query.BETWEEN,start:Query.GTE,end:Query.LTE},"field/number-edit.html":Query.EQ,"field/number-keyboard.html":Query.EQ,"field/number.html":Query.EQ,"field/radio.html":Query.EQ,"field/select.html":Query.EQ,"field/select-simple.html":Query.EQ,"field/select-native.html":Query.EQ,"field/select-autocomplete.html":Query.EQ,"field/select-multiple.html":Query.IN,default:Query.LIKE_INSENSITIVE},buildFilterByTemplate={"field/select.html":buildSelectFilter,"field/select-autocomplete.html":buildSelectFilter,"field/select-native.html":function(query,field,currentRow){var operator=getFieldOperator(field);{if(!field.valueField)throw new Error("Invalid select-native configuration on field "+field.name);((query,field,currentRow,operator)=>{field=field.name,existValue(currentRow=currentRow[field])&&buildFilter(query,field,operator,currentRow)})(query,field,currentRow,operator)}},"field/select-multiple.html":function(query,field,currentRow){var operator=getFieldOperator(field);if(field.valueField)((query,field,currentRow,operator)=>{var field=field.name,value=currentRow[field];currentRow[field+"_EXCEPT"]&&(value=currentRow[field+"_EXCEPT"],operator="NOT IN"),existValue(value)&&buildFilter(query,field,operator,value)})(query,field,currentRow,operator);else{if(!field.valueFields)throw new Error("Invalid select-multiple configuration on field "+field.name);(field=>{throw new Error('Filter on field select-multiple with property valuesFields is not supported yet. Field "'+field.name+'"')})(field)}},"field/interval.html":function(query,field,currentRow){var fieldName=field.name,currentRow=currentRow[fieldName],existStartValue=(currentRow=existValue(currentRow)?Util.clone(currentRow):{},!Util.isEmptyOrBlank(currentRow.start)),existEndValue=!Util.isEmptyOrBlank(currentRow.end);(existStartValue||existEndValue)&&(field=getFieldOperator(field),existStartValue&&existEndValue?field=field.default:currentRow=existStartValue?(field=field.start,currentRow.start):(field=field.end,currentRow.end),buildFilter(query,fieldName,field,currentRow))},default:function(query,field,currentRow){var fieldName=field.name,currentRow=currentRow[fieldName];existValue(currentRow)&&(field=getFieldOperator(field),buildFilter(query,fieldName,field,currentRow))}};function getFieldTemplate(field){return field.template.split("#").pop()}this.setDefaultOperator=function(template,operator){defaultOperators[template]=operator},this.setBuildFilterByTemplate=function(template,callback){buildFilterByTemplate[template]=callback},this.buildFilter=function(fields,row){var clearedFilters,query=Query.build();return fields.forEach(function(field){field.skipSearch||(template=>buildFilterByTemplate[template=buildFilterByTemplate[template]?template:"default"])(getFieldTemplate(field))(query,field,row)}),fields=query.where(),clearedFilters=[],fields.forEach(function(filter){clearedFilters.some(function(_filter){return _filter.name===filter.name})||clearedFilters.push(filter)}),clearedFilters};var operatorFlow={BETWEEN:function(query,value){query.between([value.start,value.end])},"NOT BETWEEN":function(query,value){query.notBetween([value.start,value.end])},LIKE:function(query,value){query.like("%"+value+"%")},LIKE_I:function(query,value){query.likeInsensitive("%"+value+"%")},LIKE_BEGINNING:function(query,value){query.likeInsensitive(value+"%")},"NOT LIKE":function(query,value){query.notLike("%"+value+"%")},"LIKE ALL":function(query,value){query.likeAll("%"+value+"%")},"<>":function(query,value){query.notEquals(value)},"=":function(query,value){query.equals(value)},">":function(query,value){query.greater(value)},"<":function(query,value){query.lower(value)},">=":function(query,value){query.greaterOrEqual(value)},"<=":function(query,value){query.lowerOrEqual(value)},IN:function(query,value){query.in(value)},"NOT IN":function(query,value){query.notIn(value)}};function buildFilter(query,fieldName,operator,value){query.where(fieldName),operatorFlow[operator](query,value)}function existValue(value){var isObject="object"==typeof value;{if(isObject){for(var name in isObject=value)return!void 0;return!1}return!Util.isEmptyOrBlank(value)}}function buildSelectFilter(query,field,currentRow){var operator=getFieldOperator(field);if(field.valueField)((query,field,currentRow,operator)=>{field=field.valueField,existValue(currentRow=currentRow[field])&&buildFilter(query,field,operator,currentRow)})(query,field,currentRow,operator);else if(field.valueFields)((query,field,currentRow,operator)=>{field=field.name,existValue(currentRow=currentRow[field])&&buildFilter(query,field,operator,currentRow)})(query,field,currentRow,operator);else{if(!field.outData)throw new Error("Invalid select configuration on field "+field.name);((query,field,currentRow,operator)=>{var outData=field.outData;Object.keys(outData).forEach(function(outDataKey){var outDataKey=outData[outDataKey],value=currentRow[outDataKey];existValue(value)&&buildFilter(query,outDataKey,operator,value)})})(query,field,currentRow,operator)}}function getFieldOperator(field){var template=getFieldTemplate(field);return"field/interval.html"===template&&"string"==typeof field.operator&&(field.operator=defaultOperators[template]),field.operator||defaultOperators[template]||defaultOperators.default}}function ZhFilterDescriptionBuilder(DecodeValueFieldService,ZhUtil,templateManager){this.buildFilterAppliedInfo=function(preferenceName){return[{label:"Filter",filterName:preferenceName}]},this.buildFilterInfo=function(fields,currentRow,searchCriteria,widget){var id,filterInfo=[],filterWidget=(id=widget&&widget.id,templateManager.container.factoredWidgets.filter(function(widget){return widget._filteredWidgetId==id})[0]);return fields.forEach(function(field){((filterInfo,field,currentRow,widget)=>{var condition=!Util.isEmptyOrBlank(currentRow[field.name]),showInfo=(widget=widget&&widget.getField(field.name))&&widget.isVisible;condition&&showInfo&&(condition=widget&&widget.modelValue()||DecodeValueFieldService.model(field,currentRow[field.name]),condition=ZhUtil.evaluate(condition),filterInfo.push({label:field.label,value:condition}))})(filterInfo,field,currentRow,filterWidget)}),((fields,filterInfo,searchCriteria)=>{searchCriteria&&Object.keys(searchCriteria).forEach(function(fieldName){var fieldLabel;""!==searchCriteria[fieldName]&&(fieldLabel="_ALL_MAP"==fieldName?"All fields":((fields,fieldName)=>fields.filter(function(field){return field.name===fieldName}).shift())(fields,fieldName).label,filterInfo.push({label:fieldLabel,value:searchCriteria[fieldName]}))})})(fields,filterInfo,searchCriteria),filterInfo}}function ZhFilterPreferences(ZhPreferences,ZhFilterBuilder,ZhFilterDescriptionBuilder,templateManager,eventAggregator,ZhUtil,eventEngine,metaDataFactory,ZHPromise,MessageService,ScreenService,ZhKeyboardService,ApplicationContext,$timeout){var self=this,originalFilterRows={},originalFilter={ID:"ORIGINAL",USER_ID:0,ORGANIZATION_ID:0,LABEL_TO_PREFERENCE:"Original"};function shouldShowFilterAction(widget){return!1!==Util.get(widget,["floatingControl","searchAction"])||!1!==Util.get(widget,["floatingControl","customizationAction","filter"])}eventAggregator.subscribe("beforeProjectStartup",function(){ZhPreferences.registerRepository("zh-filter-preferences#filter"),templateManager.project.customFloatingActions.push({name:"Filter Action",label:"Search",type:"filter",order:20,icon:"search",template:"zh-filter-preferences#floating-filter-card.html",expandable:!0,isVisible:shouldShowFilterAction})}),eventEngine.registerEvent("FilterBeforeApply","beforeFilterApply"),eventEngine.registerEvent("FilterAfterApply","afterFilterApply");var filterRegisteredDataSources={};function applyFilterInFilterPopup(widget,filterRow){self.createFilterWidget(widget,filterRow)}function applyFilterInDataSource(widget,filters){widget.dataSourceFilter=((widget,filters)=>(filters=(filters=>filters.filter(function(filter){return-1===filter.name.indexOf("SEARCHLIST_")}).map(function(filter){return filter.isCustomFilter=!0,filter}))(filters),widget.dataSourceFilter.filter(function(filter){return!filter.isCustomFilter}).concat(filters).reduce(function(prev,current,index){var replaceIndex,fieldName=current.name;return fieldName in prev.keys?(replaceIndex=prev.keys[fieldName],prev.filters[replaceIndex]=current):(prev.keys[fieldName]=index,prev.filters.push(current)),prev},{filters:[],keys:{}}).filters))(widget,filters);filters=(filters=>Util.clone(filters).filter(function(filter){return~filter.name.indexOf("SEARCHLIST_")}).map(function(filter){return filter.name=filter.name.replace("SEARCHLIST_",""),filter}))(filters);return widget.setSearchCriteria&&widget.setSearchCriteria(filters),filters}function applyFilterInWidget(widget,fields,filterRow,preference){self.updateFilterInfo(widget,fields,filterRow,preference,{}),widget.appliedFilter=preference}function openFilterWidget(widget,rowToBeSet){return createFilterWidget(widget,rowToBeSet).then(function(widgetToBeShown){widget.activate(),ScreenService.openPopup(widgetToBeShown)})}this.registerFilterDataSource=function(widgetID,dataSource){return widgetID&&(filterRegisteredDataSources[widgetID]=dataSource),filterRegisteredDataSources},this.updateFilters=function(widgetID,dataSource){return dataSource=dataSource||filterRegisteredDataSources[widgetID],this.getWidgetFilters(widgetID).then(function(filters){return this.addIsDefaultFilterToFilters(filters,widgetID).then(function(filters){dataSource.data=filters})}.bind(this))},this.addIsDefaultFilterToFilters=function(filters,widgetID){return ZhPreferences.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){defaultPreferences=defaultPreferences.DEFAULT_FILTER;return filters.map(function(defaultFilter,filter){return filter.DEFAULT_FILTER=filter.ID===defaultFilter,filter}.bind(this,defaultPreferences))})},this.getWidgetFilters=function(widgetID){return ZhPreferences.getWidgetPreferences("filter",widgetID).then(function(preferences){return preferences.forEach(function(preference){preference.FILTER_ROW=JSON.parse(preference.FILTER_ROW)}),preferences})},this.getFilters=function(query){return ZhPreferences.getPreferences("filter",query)},this.saveFilters=function(filters){var cloneFilters=filters.map(function(filter){return ZhUtil.clearRow(filter)});return ZhPreferences.savePreferences("filter",cloneFilters).then(function(response){return cloneFilters.forEach(function(clone,index){filters[index].ID=clone.ID,filters[index].__is_new=clone.__is_new,filters[index].changes=clone.changed}),ZHPromise.when(response)})},this.deleteFilters=function(filters){filters=filters.map(function(filter){return ZhUtil.clearRow(filter)});return ZhPreferences.deletePreferences("filter",filters)},this.applyOriginalFilter=function(widget){return((widget,filter)=>{filter.FILTER_ROW=Util.clone(originalFilterRows[widget.id]||{})})(widget,originalFilter),this.applyFilter(widget,originalFilter)},this.setOriginalFilter=function(widgetId,filter){originalFilterRows[widgetId]=Util.clone(filter)},this.getOriginalFilter=function(widgetId,widget){widgetId=ZhUtil.clearRow(originalFilterRows[widgetId]||{});return{ID:"ORIGINAL",LABEL_TO_PREFERENCE:"Original",FILTER_ROW:Util.clone(widgetId)}},this.applyFilter=function(widget,preference,reloadWidget){reloadWidget=!1!==reloadWidget,(preference=>{preference.FILTER_ROW;var filterRow="string"==typeof preference.FILTER_ROW?JSON.parse(preference.FILTER_ROW):preference.FILTER_ROW;preference.FILTER_ROW=filterRow})(preference),reloadWidget&&(event=((widget,preference)=>{if(widget.beforeFilterApply)return widget.beforeFilterApply({preference:preference})})(widget,preference));var event,filterRow=preference.CUSTOM_FILTER_ROW||preference.FILTER_ROW,fields=self.factoryFields(null,widget.fields).filter(function(field){return field.isVisible}),filters=ZhFilterBuilder.buildFilter(fields,filterRow);return reloadWidget?event&&event.isDefaultPrevented()?ZHPromise.reject():(reloadWidget=(conditions=>{var searchCriteria={};return conditions.forEach(function(condition){searchCriteria[condition.name]=(value=>value="%"===(value="%"===value.charAt(0)?value.substr(1):value).charAt(value.length-1)?value.substr(0,value.length-1):value)(condition.value)}),searchCriteria})(applyFilterInDataSource(widget,filters)),widget.reload(ZhUtil.getLikeAllFilter(widget,reloadWidget)).then(function(){return widget.dataSource&&widget.dataSource.clearCheckedRows(),applyFilterInWidget(widget,fields,filterRow,preference),((widget,preference,filters)=>{widget.afterFilterApply&&widget.afterFilterApply({preference:preference,filters:filters})})(widget,preference,filters),applyFilterInFilterPopup(widget,preference.FILTER_ROW),ZHPromise.when()}.bind(this))):(applyFilterInDataSource(widget,filters),applyFilterInWidget(widget,fields,filterRow,preference),applyFilterInFilterPopup(widget,preference.FILTER_ROW),ZHPromise.when())},this.updateFilterInfo=function(widget,fields,filterRow,preference,searchCriteria){var filterName=preference.LABEL_TO_PREFERENCE,preference=("ORIGINAL"===preference.ID||"EDITED"===preference.ID)&&!filterName||preference.forceBuild?ZhFilterDescriptionBuilder.buildFilterInfo(fields,filterRow,searchCriteria,widget):ZhFilterDescriptionBuilder.buildFilterAppliedInfo(filterName);widget._filterInfo=preference},this.factoryFields=function(parentWidget,gridFields,editing){editing=((gridFields,editing)=>gridFields.filter(function(field){return!Util.isUndefined(field.template)}).map(function(field){var fieldClone=self.cloneObj(field);return editing&&(fieldClone.fieldGroup="FILTER_FIELDS"),fieldClone.dataSource=field.dataSource,fieldClone.dataSourceFilter=field.dataSourceFilter,fieldClone}))(gridFields,editing),gridFields=(gridFields=>[{id:"SEARCHLIST__ALL_MAP",label:"All fields",name:"SEARCHLIST__ALL_MAP",class:12,template:"field/text-edit.html",isVisible:!0,showOnList:!0,descending:!0,fieldGroup:"MORE_FIELDS"}].concat(gridFields.filter(function(field){return!field.skipSearch&&Util.isUndefined(field.template)}).map(function(field){field=self.cloneObj(field);return field.id="SEARCHLIST_"+field.id,field.name="SEARCHLIST_"+field.name,field.class=6,field.isVisible=!0,field.readOnly=!1,field.validations={},field.template="field/text-edit.html",field.fieldGroup="MORE_FIELDS",field})))(gridFields);return editing.concat(gridFields).map(function(field){return(field=>{["selectWidget","bindedEvents"].forEach(function(property){delete field[property]})})(field=field.filterProperties?((field,filterProperties)=>(Object.keys(filterProperties).forEach(function(property){field[property]=filterProperties[property]}),!field.dataSource||field.dataSource instanceof DataSource||(field.dataSource=metaDataFactory.factoryDataSource(field.dataSource,field.dataSourceFilter,field)),"field/select-multiple.html"===field.template&&Util.isUndefined(filterProperties.showCheckboxAll)&&templateManager.project.showCheckboxAllFilter&&(field.showCheckboxAll=!0),delete field.filterProperties,field))(field,field.filterProperties):field),((field,eventName,eventIndex)=>{eventIndex=eventEngine.bindEvent(field,eventName),eventEngine.unbindEvent(field,eventName,eventIndex),eventEngine.unbindEvent(field,eventName,--eventIndex)})(field,"FieldOnChange"),metaDataFactory.fieldFactory(field,parentWidget)})},this.downloadPreferenceFile=function(filter){var fileName=filter.LABEL_TO_PREFERENCE.latinise().replace(/[^a-z,0-9 ]/gi,"").replace(/(?:^\w|[A-Z]|\b\w|\s+)/g,function(match,index){return 0==+match?"":0==index?match.toLowerCase():match.toUpperCase()})+".filter",filter={ID:filter.ID,LABEL_TO_PREFERENCE:filter.LABEL_TO_PREFERENCE,WIDGET_ID:filter.WIDGET_ID,FILTER_ROW:ZhUtil.clearRow(filter.FILTER_ROW),LAST_MODIFIED_DATE:filter.LAST_MODIFIED_DATE};return ZhPreferences.downloadPreferenceFile(filter,fileName)},this.validateFilterImport=function(filter,configWidget,filterDataSource){return filterDataSource=filterDataSource||configWidget.dataSource.data,configWidget.listWidget.id!=filter.WIDGET_ID?(MessageService.showMessageByCode("zh-filter-preferences#import_error_widget_id"),!1):0<filterDataSource.filter(function(row){return row.ID==filter.ID}).length?(MessageService.showMessageByCode("zh-filter-preferences#import_error_id_violation"),!1):!(0<filterDataSource.filter(function(row){return row.LABEL_TO_PREFERENCE==filter.LABEL_TO_PREFERENCE}).length&&(MessageService.showMessageByCode("zh-filter-preferences#import_error_name_violation"),1))},this.openFilterWidget=openFilterWidget;var filterWidgets={};function forceFieldDataSourceToLoad(widget){widget.fields.forEach(function(field){((field,row)=>{var data=Util.getNestedProperty(field,["dataSource","data","length"]),fieldName=field.valueField||field.name,row="field/select-autocomplete.html"===field.template.split("#").pop()?row[fieldName]:row[field.name];field.dataSource&&!data&&row&&field.dataSource.load([{name:fieldName,value:row,operator:"IN"}])})(field,widget.currentRow)})}function createFilterWidget(widget,rowToBeSet){return ApplicationContext.ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForFilterPopup(widget).then(function(filterWidget){widget.filterInitialized||((filterWidget.listWidget=widget).filterInitialized=!0),filterWidget.label=ScreenService.i18n("Filter");var currentRow=(currentRow=rowToBeSet||widget.filterRowData)||(widget.appliedFilter?widget.appliedFilter.FILTER_ROW:{});return filterWidget.currentRow=filterWidget.currentRow||{},Object.keys(currentRow).forEach(function(fieldName){filterWidget.currentRow[fieldName]=ZhUtil.evaluate(currentRow[fieldName])}),rowToBeSet&&(widget.appliedFilter||(widget.appliedFilter={ID:"CREATED"}),widget.appliedFilter.FILTER_ROW=filterWidget.currentRow),forceFieldDataSourceToLoad(filterWidget),filterWidget.actions[0].isVisible=!0,filterWidget.actions[1].isVisible=!0,filterWidget.actions[2].isVisible=!1,filterWidget.actions[3].isVisible=!1,filterWidgets[widget.id]=filterWidget,ZHPromise.when(filterWidget)}.bind(this))}function hasPopupOpened(){var isMobiScrollOpen=0<$(".mbsc-mobiscroll").length;return!ScreenService.isSideMenuOpen()&&!isMobiScrollOpen&&!ScreenService.isAlertShown()}function isFilterPreferencesActive(widget){return!1!==Util.get(widget,["floatingControl","customizationAction","filter"])}function openWidgetFilter(){var activeWidget=templateManager.container.getActiveWidget();return hasPopupOpened()&&isFilterPreferencesActive(activeWidget)&&ZhPreferences.validateWidget(activeWidget)&&openFilterWidget(activeWidget),!1}function openWidgetSearch(){var activeWidget=templateManager.container.getActiveWidget();return(isFilterPreferencesActive(activeWidget)||!1!==Util.get(activeWidget,["floatingControl","searchAction"]))&&hasPopupOpened()&&ZhPreferences.validateWidget(activeWidget)&&activeWidget.openSearchAction(),!1}this.createFilterWidget=createFilterWidget,this.cloneObj=function(object){var clone={};return Object.keys(object).forEach(function(property){(object=>{var constr,isCopiable=Util.isUndefinedOrNull(object);return isCopiable||(constr=object.constructor,isCopiable=[String,Number,Array,Object,Boolean].some(function(type){return type().constructor===constr})),isCopiable})(object[property])&&(clone[property]=ZhUtil.clearRow(object[property]))}),clone},templateManager.projectPromise.then(function(){templateManager.project.shortcutKeys=templateManager.project.shortcutKeys||{};var openFilterKey=templateManager.project.shortcutKeys.openWidgetFilter||"mod+l",openSearchKey=templateManager.project.shortcutKeys.openWidgetSearch||"mod+f";ZhKeyboardService.unbind(openFilterKey),ZhKeyboardService.unbind(openSearchKey),ZhKeyboardService.bind(openFilterKey,openWidgetFilter),ZhKeyboardService.bind(openSearchKey,openWidgetSearch)})}ZeedhiDirectives.directive("zhPreferenceFloatingControl",[zhPreferenceFloatingControl]),(()=>{window.metadataUrls=window.metadataUrls||[],window.serviceUrls=window.serviceUrls||[];var hasMetaData=window.metadataUrls.some(function(metadataUrl){return"zh-preferences"===metadataUrl.package}),hasServiceUrl=window.serviceUrls.some(function(serviceUrl){return"zh-preferences"===serviceUrl.package});hasMetaData||window.metadataUrls.push({package:"zh-preferences",baseUrl:"bower_components/zh-preferences/dist/assets/"}),hasServiceUrl||window.serviceUrls.push({package:"zh-preferences",baseUrl:"../backend/service/index.php/zh-preferences"})})(),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterBuilder",ZhFilterBuilder)}),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterDescriptionBuilder",ZhFilterDescriptionBuilder)}),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterPreferences",ZhFilterPreferences)});var ZhFilterWidgetsBuilder=function(restEngine,templateManager,metaDataFactory,ZhFilterPreferences){var widgetsJson={};function getWidgetJSON(widgetName){widgetName="zh-filter-preferences#json/widgets/"+widgetName+".json";return widgetsJson[widgetName]||(widgetsJson[widgetName]=restEngine.requestMetaData(widgetName).then(function(response){return response.data})),widgetsJson[widgetName]}function buildFilterWidgetFieldGroups(filterWidget,widget){var fieldGroups=(filterWidget.fieldGroups||[]).concat((fieldGroups=>(fieldGroups||[]).map(function(fieldGroup){return Util.clone(fieldGroup,["__proto__","rows","widget"])}))(widget.fieldGroups)),moreFieldsFieldGroup=[],fieldGroups=fieldGroups.filter(function(fieldGroup){var isMoreFieldFieldGroup="MORE_FIELDS"===fieldGroup.name;return isMoreFieldFieldGroup&&((moreFieldsFieldGroup=fieldGroup).isVisible=!widget.hideMoreFieldsOnFilter),!isMoreFieldFieldGroup});filterWidget.fieldGroups=fieldGroups.concat(moreFieldsFieldGroup)}this.factoryWidget=function(widgetName){return getWidgetJSON(widgetName).then(function(widget){return widget=Util.clone(widget),metaDataFactory.widgetFactory(widget,templateManager.container)})},this.factoryFilterConfigurationWidget=function(){return this.factoryWidget("config")},this.factoryCreateFilterWidget=function(){return this.factoryWidget("createFilter")},this.factoryImportFilterWidget=function(){return this.factoryWidget("importFilter")},this.factoryBuildFiltersConditionsWidget=function(baseWidget){return getWidgetJSON("createFilterConditions").then(function(widgetJson){(widgetJson=Util.clone(widgetJson)).id=baseWidget.id+"_filter",widgetJson.actions.forEach(function(action){action.id=baseWidget.id+"_filter_action_"+action.name}),buildFilterWidgetFieldGroups(widgetJson,baseWidget);widgetJson=metaDataFactory.widgetFactory(widgetJson,templateManager.container);return widgetJson.fields=widgetJson.fields.concat(ZhFilterPreferences.factoryFields(widgetJson,baseWidget.fields)),widgetJson._filteredWidgetId=baseWidget.id,widgetJson})}},ZhFilterCreateFilterConditionsController=(ZeedhiController.controller("ZhFilterWidgetsBuilder",ZhFilterWidgetsBuilder),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterWidgetsBuilder",ZhFilterWidgetsBuilder)}),function(ZhFilterPreferences,ZhFilterWidgetsBuilder,MessageService,ScreenService,ZHPromise,ZhUtil,templateManager,$timeout){var createFilterConditionsWidgetPromise={};function saveFilterFields(widget){var allowedFields=widget.fields.map(function(field){return ZhFilterPreferences.cloneObj(field)});widget.__originalFilterStatus=allowedFields,widget.__originalCurrentRow=ZhFilterPreferences.cloneObj(ZhUtil.clearRow(widget.currentRow))}this.clearCachedFilterConditionsWidget=function(widget){widget&&widget.id&&(widget.filterInitialized=!1,delete createFilterConditionsWidgetPromise[widget.id])},this.getCreateFilterConditionsWidget=function(widget){var widgetId=widget.id;return createFilterConditionsWidgetPromise[widgetId]||(createFilterConditionsWidgetPromise[widgetId]=ZhFilterWidgetsBuilder.factoryBuildFiltersConditionsWidget(widget)),createFilterConditionsWidgetPromise[widgetId]},this.getCreateFilterConditionsWidgetForFilterPopup=function(widget){return this.getCreateFilterConditionsWidget(widget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.actions[0].isVisible=!0,createFilterConditionsWidget.actions[1].isVisible=!0,createFilterConditionsWidget.actions[2].isVisible=!1,createFilterConditionsWidget.actions[3].isVisible=!1;var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");return labelField&&(labelField.isVisible=!1),saveFilterFields(createFilterConditionsWidget),createFilterConditionsWidget})},this.getCreateFilterConditionsWidgetForEditPreference=function(widget){return this.getCreateFilterConditionsWidget(widget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.actions[0].isVisible=!1,createFilterConditionsWidget.actions[1].isVisible=!1,createFilterConditionsWidget.actions[2].isVisible=!0,createFilterConditionsWidget.actions[3].isVisible=!0;var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");return labelField&&(labelField.isVisible=!0),saveFilterFields(createFilterConditionsWidget),createFilterConditionsWidget})},this.saveAndApplyFilter=function(createFilterConditionsWidget){var currentRow,filter,configWidget,listWidget;return createFilterConditionsWidget.isValid(function(invalidFields){invalidFields.shift(),invalidFields.forEach(function(invalidField){var fieldName;(invalidField=invalidField.filter(function(invalidItem){return fieldName=invalidItem.fieldName,"Required field"!=invalidItem.errorMessage})).length||delete createFilterConditionsWidget.currentRow.$error[fieldName]})})?(currentRow=createFilterConditionsWidget.currentRow,(filter=createFilterConditionsWidget.preference).LABEL_TO_PREFERENCE=currentRow.LABEL_TO_PREFERENCE,filter.FILTER_ROW=ZhUtil.clearRow(currentRow),delete filter.FILTER_ROW.LABEL_TO_PREFERENCE,filter.FILTER_ROW=JSON.stringify(filter.FILTER_ROW),configWidget=createFilterConditionsWidget.configWidget,listWidget=configWidget.listWidget,ZhFilterPreferences.saveFilters([filter]).then(function(){filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW),MessageService.successNotificationByCode("zh-filter-preferences#save_success"),ScreenService.closePopup(!0),createFilterConditionsWidget.isValid()?(filter.forceBuild=!0,listWidget.filterRowData=currentRow,ZhFilterPreferences.applyFilter(listWidget,filter),listWidget.activate()):listWidget.openFilterWidget(createFilterConditionsWidget.currentRow),ZhFilterPreferences.updateFilters(listWidget.id,configWidget.dataSource)}).catch(function(error){MessageService.showMessageByCode("zh-filter-preferences#save_error",{ERROR:error.message})})):ZHPromise.reject("Invalid params")},this.clearFilter=function(widget){widget.fields.filter(function(field){return!field.readOnly}).forEach(function(field){var template=field.template||"";field.clearValue(field),-1!==template.indexOf("field/checkbox.html")?(widget.currentRow[field.name]=field.valueToFalse,field.checked=!1,templateManager.updateTemplate()):-1!==template.indexOf("field/select-native.html")&&$timeout(function(){var dropdown;field.element&&((dropdown=field.element.next()).find(".selected").removeClass("selected"),dropdown.find(".current").text(""))}),field.change&&field.change()})},this.applyFilter=function(createFilterConditionsWidget,filterName){var listWidget,currentRow;return createFilterConditionsWidget.isValid()?(currentRow=createFilterConditionsWidget.currentRow,listWidget=createFilterConditionsWidget.listWidget,delete currentRow.LABEL_TO_PREFERENCE,((widget,currentRow)=>{widget.fields.filter(function(field){return-1!==field.template.indexOf("field/select-multiple.html")}).map(function(field){delete currentRow[field.name+"_CHECKBOX_ALL"],field.allSelected&&(templateManager.project.selectAllCompatibilityMode?currentRow[field.name]="T":delete currentRow[field.name])})})(createFilterConditionsWidget,currentRow),currentRow={ID:"EDITED",FILTER_ROW:((appliedFilter,currentRow)=>{var appliedRow=appliedFilter&&appliedFilter.FILTER_ROW||{},row=ZhUtil.clearRow(currentRow);return Object.keys(appliedRow).forEach(function(key){Util.isString(appliedRow[key])&&0===appliedRow[key].indexOf("@")&&(row[key]=appliedRow[key])}),row})(listWidget.appliedFilter,currentRow)},filterName&&(currentRow.LABEL_TO_PREFERENCE=filterName),filterName=ZhFilterPreferences.applyFilter(listWidget,currentRow).catch(function(){return ScreenService.openPopup(createFilterConditionsWidget),ZHPromise.reject()}),ScreenService.getPopupOpen()==createFilterConditionsWidget&&(ScreenService.closePopup(!0),listWidget.activate()),filterName):(ScreenService.getPopupOpen()!=createFilterConditionsWidget&&ScreenService.openPopup(createFilterConditionsWidget),ZHPromise.reject())},this.closePopup=function(widget){(widget=>{widget.__originalFilterStatus&&(widget.fields.forEach(function(field,index){var __field=widget.__originalFilterStatus.filter(function(fieldOriginal){return fieldOriginal.name===field.name})[0];Object.keys(__field).forEach(function(key){widget.fields[index][key]=__field[key]})}),widget.currentRow=widget.__originalCurrentRow,delete widget.__originalCurrentRow,delete widget.__originalFilterStatus)})(widget),ScreenService.closePopup(),widget.listWidget.activate()}}),ZhFilterImportFilterController=(ZeedhiController.controller("ZhFilterCreateFilterConditionsController",ZhFilterCreateFilterConditionsController),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterCreateFilterConditionsController",ZhFilterCreateFilterConditionsController)}),function(MessageService,ZhFilterPreferences,ZhPreferences,ZhFilterWidgetsBuilder,ZHPromise,ScreenService){var importFilterWidgetPromise=null;this.getImportFilterWidget=function(){return importFilterWidgetPromise=null===importFilterWidgetPromise?ZhFilterWidgetsBuilder.factoryImportFilterWidget():importFilterWidgetPromise},this.importPreference=function(importFilterWidget){var filterFileData,filter,configWidget,listWidget;return importFilterWidget.isValid()?(filterFileData=(filterFileData=importFilterWidget.fields[0].value()[0].b64File).split("base64,")[1],filterFileData=window.atob(filterFileData),filterFileData=decodeURIComponent(escape(filterFileData)),filter=JSON.parse(filterFileData),configWidget=importFilterWidget.configWidget,listWidget=configWidget.listWidget,ZhFilterPreferences.validateFilterImport(filter,configWidget)?(filter.__is_new=!0,filter.__generate_id=!1,filter.FILTER_ROW=JSON.stringify(filter.FILTER_ROW),ZhPreferences.getUserID().then(function(userID){return filter.USER_ID=userID,ZhFilterPreferences.saveFilters([filter]).then(function(){filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW),ScreenService.closePopup(),ZhFilterPreferences.updateFilters(listWidget.id,configWidget.dataSource),configWidget.refreshWidget()}).catch(function(error){MessageService.showMessageByCode("zh-filter-preferences#save_error",{ERROR:error.message})})})):ZHPromise.reject({err:"FILTER_FILE_INVALID"})):ZHPromise.reject({err:"WIDGET_INVALID"})}}),ZhFilterConfigWidgetController=(ZeedhiController.controller("ZhFilterImportFilterController",ZhFilterImportFilterController),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterImportFilterController",ZhFilterImportFilterController)}),function(ZhPreferences,ZhFilterPreferences,ZhFilterWidgetsBuilder,ScreenService,MessageService,ZHPromise,ZhFilterCreateFilterConditionsController,ZhFilterImportFilterController){function hideMoreFields(groups,hide){var moreFieldsFieldGroup=[];return groups.filter(function(fieldGroup){delete fieldGroup.rows;var isMoreFieldFieldGroup="MORE_FIELDS"===fieldGroup.name;return isMoreFieldFieldGroup&&((moreFieldsFieldGroup=fieldGroup).isVisible=!hide),!isMoreFieldFieldGroup}).concat(moreFieldsFieldGroup)}var configWidgetPromise=null;this.getConfigWidget=function(listWidget,dataSource){null===configWidgetPromise&&(configWidgetPromise=ZhFilterWidgetsBuilder.factoryFilterConfigurationWidget());var userID=ZhPreferences.getUserID();return ZHPromise.all([userID,configWidgetPromise]).then(function(args){args[0];args=args[1];return args.listWidget=listWidget,args.dataSourceFilter=[{name:"WIDGET_ID",operator:"=",value:listWidget.id}],dataSource.data.forEach(function(row){row.APPLIED=row.ID==(listWidget.appliedFilter?listWidget.appliedFilter.ID:"ORIGINAL")}),args.dataSource=dataSource,args})};this.openCreateFilterWidget=function(configWidget){var label=configWidget.currentRow.LABEL_TO_PREFERENCE;return ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForEditPreference(configWidget.listWidget).then(function(createFilterConditionsWidget){var fieldGroups,listWidget=configWidget.listWidget;return createFilterConditionsWidget.label=ScreenService.i18n("Filter"),createFilterConditionsWidget.configWidget=configWidget,listWidget.filterInitialized||(fieldGroups=(createFilterConditionsWidget.fieldGroups||[]).concat(listWidget.fieldGroups||[]),createFilterConditionsWidget.fieldGroups=fieldGroups,listWidget.filterInitialized=!0),createFilterConditionsWidget.fieldGroups=hideMoreFields(createFilterConditionsWidget.fieldGroups,listWidget.hideMoreFieldsOnFilter),ZhPreferences.getUserID().then(function(userID){var userID={__is_new:!0,ID:null,USER_ID:userID,LABEL_TO_PREFERENCE:label,WIDGET_ID:listWidget.id,LAST_MODIFIED_DATE:null},userID=(createFilterConditionsWidget.preference=userID,createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE")),fields=ZhFilterPreferences.factoryFields(createFilterConditionsWidget,listWidget.fields,!0);return createFilterConditionsWidget.fields=[userID].concat(fields),userID.isVisible=!0,createFilterConditionsWidget.newRow(),ScreenService.openPopup(createFilterConditionsWidget)})})},this.editFilter=function(configWidget,filter){var listWidget;return"F"===filter.TYPE?(MessageService.alertNotificationByCode("zh-filter-preferences#cannot_edit_fixed_filter"),ZHPromise.when()):(listWidget=configWidget.listWidget,ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForEditPreference(configWidget.listWidget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.preference=filter,createFilterConditionsWidget.label=ScreenService.i18n("Filter")+" - "+filter.LABEL_TO_PREFERENCE,createFilterConditionsWidget.configWidget=configWidget,createFilterConditionsWidget.fieldGroups=hideMoreFields(createFilterConditionsWidget.fieldGroups||[],listWidget.hideMoreFieldsOnFilter);var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE"),fields=ZhFilterPreferences.factoryFields(createFilterConditionsWidget,listWidget.fields,!0);return createFilterConditionsWidget.fields=[labelField].concat(fields),labelField.isVisible=!0,createFilterConditionsWidget.currentRow=filter.FILTER_ROW,createFilterConditionsWidget.currentRow.LABEL_TO_PREFERENCE=filter.LABEL_TO_PREFERENCE,ScreenService.openPopup(createFilterConditionsWidget)}))},this.deleteFilters=function(configWidget){var filtersToDelete=configWidget.getCheckedRows();if(!filtersToDelete.filter(function(filter){return filter.DEFAULT_FILTER}).length)return MessageService.confirmMessageByCode("zh-filter-preferences#delete",{NR_OF_FILTERS:filtersToDelete.length}).then(function(){return ZhFilterPreferences.deleteFilters(filtersToDelete).then(function(){return configWidget.dataSource.clearCheckedRows(),ZhFilterPreferences.updateFilters(configWidget.listWidget.id,configWidget.dataSource)}).catch(function(error){return MessageService.getMessageByCode("zh-filter-preferences#"+error.message).then(function(errorMessage){return MessageService.showMessageByCode("zh-filter-preferences#delete_error",{ERROR:ScreenService.i18n(errorMessage)})})})});MessageService.showMessageByCode("zh-filter-preferences#delete_error_default")},this.updateDefaultFilter=function(configWidget,filter){return ZhPreferences.changeDefaultPreferences(configWidget,"DEFAULT_FILTER",filter)},this.updateAppliedFilter=function(configWidget,filter){var listWidget=configWidget.listWidget;return ZhFilterPreferences.applyFilter(listWidget,filter).then(function(){configWidget.dataSource.data.forEach(function(row){row.APPLIED=row.ID==filter.ID})})},this.downloadPreferenceFile=function(filter){return ZhFilterPreferences.downloadPreferenceFile(filter)},this.importPreferenceFile=function(configWidget){return ZhFilterImportFilterController.getImportFilterWidget().then(function(importFilterWidget){return importFilterWidget.newRow(),importFilterWidget.configWidget=configWidget,ScreenService.openPopup(importFilterWidget)})}}),ZhFilterFloatingCardController=(ZeedhiController.controller("ZhFilterConfigWidgetController",ZhFilterConfigWidgetController),Configuration(function(ContextRegister){ContextRegister.register("ZhFilterConfigWidgetController",ZhFilterConfigWidgetController)}),function($scope,ApplicationContext,templateManager,metaDataFactory,ScreenService,Query,eventEngine,ZHPromise,ZhUtil){var isLazyLoad,widget=$scope.widget,ZhFilterPreferences=ApplicationContext.ZhFilterPreferences,ZhPreferences=ApplicationContext.ZhPreferences,ZhFilterConfigWidgetController=ApplicationContext.ZhFilterConfigWidgetController,dataSource=metaDataFactory.factoryDataSource({name:"zh-filter-preferences#/filter",localStorage:!1,lazyLoad:!0,rest:!0,data:[]});function refreshFilters(){return ZhPreferences.getUserID().then(function(){var query=Query.build().where("WIDGET_ID").equals(widget.id);return dataSource.load(query.where())})}function openFilterWidget(rowToBeSet){return ZhFilterPreferences.openFilterWidget(widget,rowToBeSet)}function applyPreference(filter,reloadWidget){ZhFilterPreferences.applyFilter(widget,filter,reloadWidget)}function initOriginalFilter(){var filterRow,widgetId=widget.id,filter=ZhFilterPreferences.getOriginalFilter(widgetId);Util.isEmptyObject(filter.FILTER_ROW)&&(filterRow=(()=>{var filterRow={};return(widget.dataSourceFilter||[]).filter(function(filter){return!filter.isCustomFilter}).forEach(function(filter){filterRow[filter.name]=filter.value}),filterRow})(),widget.fields.forEach(function(field){var defaultValue=(field.filterProperties&&field.filterProperties.hasOwnProperty("defaultValue")?field.filterProperties:field).defaultValue;Util.isUndefinedOrNull(defaultValue)||(filterRow[field.name]=defaultValue)}),ZhFilterPreferences.setOriginalFilter(widgetId,filterRow))}dataSource.afterLoadDataSource(function(){return ZhFilterPreferences.addIsDefaultFilterToFilters(dataSource.data,widget.id).then(function(filters){dataSource.data=filters.map(function(filter){return filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW),filter})})}),$scope.customizationCard={label:"Filters",type:"filter",openFilterConfiguration:function(){var dataSource=$scope.customizationCard.dataSource;return ZhFilterConfigWidgetController.getConfigWidget(widget,dataSource).then(function(configWidget){return ScreenService.openPopup(configWidget)})},refreshFilters:refreshFilters,openFilterWidget:openFilterWidget,applyOriginalFilter:function(){return ZhFilterPreferences.applyOriginalFilter(widget)},applyFilter:applyPreference,dataSource:dataSource},ZhFilterPreferences.registerFilterDataSource(widget.id,$scope.customizationCard.dataSource),widget.openFilterWidget=openFilterWidget,widget.refreshFilters=refreshFilters,$scope.$watchCollection("widget.searchCriteria",function(searchCriteria){var filterRow;ZhPreferences.validateWidget(widget)&&((filterRow=((filterRow,searchCriteria)=>{var changed=!1;return filterRow=filterRow||{},Object.keys(searchCriteria).forEach(function(key){var name="SEARCHLIST_"+key,filterValue=filterRow[name];Util.isEmptyOrBlank(filterValue)||searchCriteria[key]===filterValue||(changed=!0),filterRow[name]=searchCriteria[key]}),filterRow.changed=changed,filterRow})(filterRow=widget.appliedFilter&&widget.appliedFilter.FILTER_ROW,searchCriteria||{})).changed&&(widget.appliedFilter={ID:"EDITED",FILTER_ROW:filterRow}),delete filterRow.changed,widget.appliedFilter)&&ZhFilterPreferences.updateFilterInfo(widget,widget.fields,filterRow,widget.appliedFilter,searchCriteria)}),$scope.$on("$destroy",function(){delete widget.openFilterWidget,delete widget.refreshFilters,delete dataSource.afterLoadDataSourcelistener}),!1!==Util.get(widget,["floatingControl","customizationAction","filter"])&&ZhPreferences.validateWidget(widget)&&Util.isUndefinedOrNull(widget.appliedFilter)&&!0!==widget.filterInitialized&&!0!==widget.preventDefaultFilter&&(initOriginalFilter(),isLazyLoad=Util.getNestedProperty(widget,["dataSource","lazyLoad"]),ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(defaultPreference){applyPreference(defaultPreference.defaultFilter||ZhFilterPreferences.getOriginalFilter(widget.id),!isLazyLoad)}))});function ZhSearchFloatingControl($timeout,templateManager){return{priority:10,link:function($scope,element,attrs,controller){var defaultOptions,isFilterAppliedWithoutOriginal,widget=$scope.widget;!1!==widget.floatingControl&&(defaultOptions={searchAction:Util.isUndefined(element.parent().attr("data-hide-search"))&&Util.isUndefined(element.parent().attr("hide-search")),openSearch:!1},widget.floatingControl=Util.extend(defaultOptions,widget.floatingControl),widget.floatingControl.addStatus({priority:20,classString:"searching",icon:"more",conditionFunction:isFilterAppliedWithoutOriginal=function(){return widget._filterInfo&&0<widget._filterInfo.length&&widget.appliedFilter&&"ORIGINAL"!=widget.appliedFilter.ID},infoTemplate:function(){var filterInfoValue=templateManager.project.hideFilterValue||widget.hideFilterValue?"</b> {{info.filterName}}":":</b> {{info.value}}";if(widget&&widget.appliedFilter&&0<Object.keys(widget.appliedFilter.FILTER_ROW).length)return widget.floatingControl.statuses[1].icon="search",'<div data-zh-touchstart="'+(method=widget.floatingControl.customizationAction&&widget.floatingControl.customizationAction.filter?(icon="filter","openFilter"):(icon="close-x","clearFilter"))+'()"> <div class="searching-control-info"><span data-zh-icon="'+icon+' no-border icon-white"></span><div class="searching-control-info-details"><span ng-repeat="info in widget._filterInfo"><b>{{info.label|i18n}}'+filterInfoValue+'</span></div></div><div class="searching-control-info-text" data-zh-bind-translate="\'Filter applied\'"></div></div>';widget.floatingControl.statuses[1].icon="more"},scope:$scope}),templateManager.project.showEmptyFilter&&widget.floatingControl.addStatus({priority:30,classString:"emptyFilter",icon:"more",conditionFunction:function(){return!isFilterAppliedWithoutOriginal()},infoTemplate:'<div data-zh-touchstart="openFilter()"> <div class="searching-control-info"><span data-zh-icon="filter no-border icon-white"></span></div><div class="searching-control-info-text"></div></div>',scope:$scope}),$scope.inputInitialized=!1,$scope.openSearchAction=function(){$timeout.cancel($scope._closeTimeout),element.hasClass("opened")||$scope.toggleActionMenu(),$scope.closeOpenedActions();var searchInput,searchAction=element.find(".search-action").closest(".float-action");searchAction&&0<searchAction.length&&(searchAction.find("span.search-action-icon").click(),searchInput=searchAction.find("input"),setTimeout(function(){Util.selectElement(searchInput)},100),$scope.inputInitialized||($scope.inputInitialized=!0,searchInput.on("keydown",function(e){9===e.keyCode&&widget.focusElement&&(widget.focusElement(),e.preventDefault())})))},widget.openSearchAction=$scope.openSearchAction,$scope.$on("$destroy",function(){delete widget.openSearchAction,widget.floatingControl.statuses=[]}),$scope.openFilter=function(){$scope.widget.openFilterWidget()},$scope.clearFilter=function(){$scope.widget.searchCriteria={}},$scope.clearSearch=function(event,fieldName){var filterRow=widget.appliedFilter&&widget.appliedFilter.FILTER_ROW||{};fieldName?(delete filterRow["SEARCHLIST_"+fieldName],delete widget.searchCriteria[fieldName]):widget.searchCriteria={},event&&Util.selectElement($(event.target).closest(".floating-card-input").find("input"))},$scope.toggleSearchFieldsList=function(event){var el=$(event.target).closest(".floating-card").find(".floating-card-search-field-select");el.toggleClass("opened"),el.hasClass("opened")&&($(event.target).closest(".floating-card").find(".floating-card-select-field-options").removeClass("opened"),$(event.target).closest(".floating-card").find(".zh-select-search-floating").removeClass("opened"))},$scope.selectSearchField=function(field){$scope.searchField=field,element.find(".floating-card-search-field-select").removeClass("opened"),element.find("input.zh-input-search-floating").focus()},$scope.filterFields=function(field){return field.aclIsVisible&&!field.skipSearch&&(field.isVisible&&field.showOnList||field.showOnFilter)},$scope.getFields=function(widget){return(widget.fields||[]).filter($scope.filterFields)},widget.floatingControl.defaultSearchField&&($scope.searchField=widget.getField(widget.floatingControl.defaultSearchField)),widget.floatingControl.openSearch)&&$timeout(widget.openSearchAction,0,!1)}}}function ZhFilterFloatingControl(){return{priority:10,link:function($scope){$scope.toggleFilterPreferencesCard=function(e){$(e.target).closest(".float-action").hasClass("opened")||$scope.widget.refreshFilters(),$scope.togglePreferencesCard(e)}}}}function ZhuAclConfig(){var self=this;this.RULE_ALLOW="A",this.RULE_READONLY="R",this.RULE_INVISIBLE="I",this.exportRulesModal="exportRulesModal",this.menuElementsListWidgetName="elementsListWidget",this.containerElementsListWidgetName="containerElementsModal",this.containerElementsTreeWidgetName="containerElementsTree",this.containerType="container",this.getDefaultDataSourceFilter=function(groupIds,projectId,organizationId){var dataFilter=[],groupIds={name:"GROUP_ID",operator:"=",value:groupIds},projectId={name:"PROJECT_ID",operator:"=",value:projectId};return void 0!==organizationId&&dataFilter.push({name:"ORGANIZATION_ID",operator:"=",value:organizationId}),dataFilter.push(groupIds),dataFilter.push(projectId),dataFilter},this.getAclMap=function(type){return{container:{aclTypeCod:"C",childs:["widgets"]},widgets:{aclTypeCod:"W",childs:["widgets","fields","actions"]},fields:{aclTypeCod:"F",childs:[]},actions:{aclTypeCod:"A",childs:[]}}[type]||{}},this.getRuleType=function(isVisible,isEditable){isVisible=isVisible?isEditable?self.RULE_ALLOW:self.RULE_READONLY:self.RULE_INVISIBLE;return isVisible},this.getRuleConfiguration=function(ruleType){return{isVisible:ruleType!=self.RULE_INVISIBLE,isEditable:ruleType==self.RULE_ALLOW}}}ZeedhiController.controller("ZhFilterFloatingCardController",ZhFilterFloatingCardController),(ZeedhiDirectives=angular.module("ZeedhiDirectives")).directive("zhFloatingControl",["$timeout","templateManager",ZhSearchFloatingControl]),ZeedhiDirectives.directive("zhFilterFloatingControl",[ZhFilterFloatingControl]),(()=>{window.templateUrls=window.templateUrls||[],window.metadataUrls=window.metadataUrls||[],window.serviceUrls=window.serviceUrls||[];var PACKAGE_NAME="zh-filter-preferences",hasTemplateUrl=Boolean(window.templateUrls.find(function(value){return value.package===PACKAGE_NAME})),hasMetadataUrl=Boolean(window.metadataUrls.find(function(value){return value.package===PACKAGE_NAME})),hasServiceUrl=Boolean(window.serviceUrls.find(function(value){return value.package===PACKAGE_NAME}));hasTemplateUrl||window.templateUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-filter-preferences/dist/templates/"}),hasMetadataUrl||window.metadataUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-filter-preferences/dist/assets/"}),hasServiceUrl||window.serviceUrls.push({package:PACKAGE_NAME,baseUrl:"../backend/service/index.php/zh-preferences"})})(),Configuration(function(ContextRegister){ContextRegister.register("ZhuAclConfig",ZhuAclConfig)});var ZhuAclMessages={CANCEL:"Cancelar",YES:"Sim",NO:"Não",VISIBLE:"visíveis",EDITABLE:"editáveis",INVISIBLE:"invisíveis"};function ZhuAccessButtonService(){this.insertButtonInProject=function(project){var notification={label:"Access Control",name:"accessControl",icon:"block",isVisible:!1,tooltip:"Access Control",isAclNotification:!0,events:[{name:"NotificationEvent",code:"ZhuAclController.openAclModalWidget();"}]};try{notification=Util.extend(new _Notification,notification),project.notifications=project.notifications||[],project.notifications.push(notification)}catch(e){console.error("O Controle de acesso à elementos só funciona em versões acima da 1.40.x do Zeedhi Framework")}},this.disableButtonInProject=function(project){project.notifications&&(project.notifications=project.notifications.filter(function(notification){return!notification.isAclNotification}))},this.enableButtonInProject=function(project){project.notifications&&project.notifications.forEach(function(notification){notification.isAclNotification&&(notification.isVisible=!0)})}}function ZhuAclService(requestDataSourceEngine,restEngine,ZhuAclConfig){this.getZhuAclRules=function(projectId,groupIds){return requestDataSourceEngine.getDataSource("zhuacl#/acl_zhu_acl_rules",ZhuAclConfig.getDefaultDataSourceFilter(groupIds,projectId),1,void 0,void 0,void 0,12e4).then(function(response){var response=response.dataset||{},rules=response.zhu_access_control_rule_login;if(Util.isArray(rules))return{aclRules:rules,defaultRule:response.zhu_access_control_default_rule.defaultRule};throw{code:ZhuAclMessages.CANNOT_LOAD_RULES}})},this.getWidgetMetadata=function(widgetName){return restEngine.requestMetaData("zhuacl#json/"+widgetName+".json").then(function(metadata){return metadata.data})},this.exportRules=function(profileFrom,profilesTo){return requestDataSourceEngine.setDataSource("zhuacl#/acl_zhu_acl_element_exportRules",[{changed:!0,profileFrom:profileFrom,profilesTo:profilesTo}])}}function ZhuAclController(ScreenService,templateManager,metaDataFactory,ZHPromise,ZhuAclService,ZhuAccessButtonService,ZhuAclConfig,MessageService,ApplicationContext,eventAggregator){var user,self=this,loadedContainers={};function User(userId,projectId,organizationId,defaultRule){var currentGroupId,userDefaultRule=defaultRule||ZhuAclConfig.RULE_INVISIBLE;this.setCurrentGroupId=function(id){currentGroupId=id},this.getDefaultRule=function(){return userDefaultRule},this.getCurrentGroupId=function(){return currentGroupId},this.getProjectId=function(){return projectId},this.getUserId=function(){return userId},this.getOrganizationId=function(){return organizationId}}this.getDefaultRule=function(){return user.getDefaultRule()},this.getCurrentGroupId=function(){return user.getCurrentGroupId()},this.getProjectId=function(){return user.getProjectId()};function updateProjectAcl(loginRules,defaultRule,groupIds){var rules={},userId=user.getUserId();Util.isObject(loginRules)?loginRules=((userId,objRules)=>{var arrayRules=[];return Object.keys(objRules).forEach(function(ruleId){var objRule=objRules[ruleId],userRule=objRule.userGroups[userId];userRule&&(ruleId={UNIQUE_ID:ruleId,NAME:objRule.itemName,RULE:userRule.rule},arrayRules.push(ruleId))}),arrayRules})(userId,rules=loginRules):Util.isArray(loginRules)&&(rules=((userId,arrayRules)=>{var objRules={};return arrayRules.forEach(function(rule){var profileObjects={};profileObjects[userId]={rule:rule.RULE,undefinedGroups:rule.GROUP_ID||[]},objRules[rule.UNIQUE_ID]={itemName:rule.NAME,userGroups:profileObjects}}),objRules})(userId,loginRules)),templateManager.project.aclDefaultRule=defaultRule||ZhuAclConfig.RULE_INVISIBLE,templateManager.userId=userId,updateContainerAcl(templateManager.aclRules=rules,groupIds,userId),((rules,groupIds,userId)=>{eventAggregator.subscribe(EventAggregator.ON_CONTAINER_OPEN,function(){var containerId=templateManager.container.id;loadedContainers[containerId]||updateContainerAcl(rules,groupIds,userId)})})(rules,groupIds,userId)}function createUser(userId,projectId,organizationId,defaultRule){user=new User(userId,projectId,organizationId,defaultRule)}this.getRulesFromDatasource=function(rulesData){var userId=user.getUserId(),rules={};return rulesData.forEach(function(row){var obj={ruleRow:row,userGroups:{}};obj.userGroups[userId]={rule:row.RULE},rules[row.ELEMENT_UNIQUE_ID]=obj}),rules},this.getElementRule=function(rules,itemId){var itemRule={};return itemRule=rules[itemId]?rules[itemId].ruleRow:itemRule},this.getPlannedItemToInsertInDataSet=function(rules,item,itemType,parentId){var uniqueId=item.id,rules=self.getElementRule(rules,uniqueId),uniqueId={UNIQUE_ID:uniqueId,NAME:item.name||item.label.toLowerCase().replace(/\ /g,"_").replace(/[^\w\s]/gi,""),LABEL:(label=>ScreenService.i18n(label))(item.label||item.name),TYPE:itemType,RULE:rules.RULE||this.getDefaultRule(),RULE_ID:rules.ID,PARENT_ID:parentId,USER_ID:user.getUserId(),PROJECT_ID:user.getProjectId(),ORGANIZATION_ID:user.getOrganizationId()};return uniqueId.isVisible=item.aclIsVisible||checkChildrenVisible(item,!0),uniqueId.isEditable=!(item.aclReadOnly||!item.aclIsVisible)||checkChildrenVisible(item),uniqueId};var checkChildrenVisible=function(component,isVisibleHandle){var control=!1,childrenTypes=["widgets","fields","notifications"];return component instanceof Container||childrenTypes.push("actions"),childrenTypes.forEach(function(type){component[type]&&component[type].forEach(function(children){children&&children.aclIsVisible&&isVisibleHandle&&(control=!0),children&&children.aclIsVisible&&!children.aclReadOnly&&(control=!0)})}),control},redirectToMainWindow=(this.openAclModalWidget=function(){var container;container=templateManager.container,getFactoredWidget(container,ZhuAclConfig.containerElementsListWidgetName,!0).then(function(factoredWidget){return container.actions=container.actions||[],factoredWidget}).then(function(widget){ScreenService.openPopup(widget)})},function(){var dashboardMenu=templateManager.project.getMenu("dashboard"),openLinkByMenu=ApplicationContext.LibUtilities&&ApplicationContext.LibUtilities.openLinkByMenu;dashboardMenu&&openLinkByMenu?openLinkByMenu(dashboardMenu):openWindow(templateManager.project.mainWindow)}),verifyContainerRule=function(rule){var actions,rule=rule===ZhuAclConfig.RULE_INVISIBLE;return rule&&(actions=[{label:ScreenService.i18n("Ok"),code:redirectToMainWindow}],MessageService.showCustomDialogByCode(ZhuAclMessages.ACCESS_DENIED,{},{type:"ALERT",icon:"exclamation",actions:actions})),!rule},mergeUndefinedRules=function(groupIds,itemRule,parentRules){var undefinedGroups,definedRule=itemRule.rule,groupRules=(parentRules=parentRules||{}).groupRules||{};return definedRule?(undefinedGroups=itemRule.undefinedGroups||[],groupIds.forEach(function(groupId){var parentRule=groupRules[groupId]||templateManager.project.aclDefaultRule,parentRule=-1!==undefinedGroups.indexOf(groupId)?parentRule:definedRule;groupRules[groupId]=parentRule,definedRule!==ZhuAclConfig.RULE_ALLOW&&parentRule!==ZhuAclConfig.RULE_INVISIBLE&&(definedRule=parentRule)}),itemRule.rule=definedRule):definedRule=parentRules.rule||templateManager.project.aclDefaultRule,{rule:definedRule,groupRules:groupRules}},getUserRule=function(rules,userId,elementId){return Util.getNestedProperty(rules,[elementId,"userGroups",userId])},initObject=function(obj,objKeys,lastKeyValue){var objKeysLength=objKeys.length;objKeys.reduce(function(prev,next,index){return prev[next]=index==objKeysLength-1?lastKeyValue:prev[next]||{},prev[next]},obj)},updateContainerAcl=function(rules,groupIds,userId){function applyRule(item,parentRules){var id=item.id,id=getUserRule(rules,userId,id)||{},parentRules=(id=mergeUndefinedRules(groupIds,id,parentRules)).rule;return item.aclIsVisible=parentRules!=ZhuAclConfig.RULE_INVISIBLE,item.aclReadOnly=parentRules!=ZhuAclConfig.RULE_ALLOW,id}function updateItemAcl(item,type,parentRules){var mergedItem=applyRule(item,parentRules);ZhuAclConfig.getAclMap(type).childs.forEach(function(type){Util.isArray(item[type])&&item[type].forEach(function(child){updateItemAcl(child,type,mergedItem)})})}var isVisible,container=templateManager.container,aclEnable=container.aclEnable;isVisible=aclEnable=void 0===aclEnable||aclEnable,templateManager.project.notifications.some(function(notification){var isAclNotification="accessControl"===notification.name;return isAclNotification&&(notification.isVisible=isVisible),isAclNotification}),aclEnable&&((container=>{var containerId=container.id,container=container.parentMenuId;!getUserRule(rules,userId,containerId)&&container&&(container=getUserRule(rules,userId,container))&&initObject(rules,[containerId,"userGroups",userId],container)})(container),aclEnable=applyRule(container),verifyContainerRule(aclEnable.rule)&&updateItemAcl(container,ZhuAclConfig.containerType),loadedContainers[container.id]=!0)},getFactoredWidget=(this.setUserRules=function(groupIds,projectId,userId,organizationId,options){return loadedContainers={},(options=options||{}).canConfigureAcl?ZhuAccessButtonService.enableButtonInProject(templateManager.project):ZhuAccessButtonService.disableButtonInProject(templateManager.project),templateManager.updateTemplate(),options.rules?(createUser(userId,projectId,organizationId,options.defaultRule),updateProjectAcl(options.rules,options.defaultRule,groupIds),ZHPromise.when(templateManager.aclRules)):ZhuAclService.getZhuAclRules(projectId,groupIds).then(function(response){return createUser(userId,projectId,organizationId,response.defaultRule),updateProjectAcl(response.aclRules,response.defaultRule,groupIds),templateManager.aclRules}).catch(function(err){MessageService.showMessageByCode(err.code)})},this.setElementsListFilter=function(container,groupId,widgetName){widgetName=widgetName||ZhuAclConfig.menuElementsListWidgetName,container.getWidget(widgetName).dataSourceFilter=ZhuAclConfig.getDefaultDataSourceFilter(groupId,user.getProjectId(),user.getOrganizationId()),user.setCurrentGroupId(groupId)},function(container,widgetName,pushInContainer){var widget=container.getWidget(widgetName);return widget?ZHPromise.when(widget):ZhuAclService.getWidgetMetadata(widgetName).then(function(metadata){metadata=metaDataFactory.widgetFactory(metadata,container);return pushInContainer&&container.widgets.push(metadata),metadata})});this.getFactoredWidget=getFactoredWidget,this.insertElementsListWidget=function(container,parentWidget,extraElementsPath){getFactoredWidget(container,ZhuAclConfig.menuElementsListWidgetName).then(function(factoredWidget){parentWidget&&!factoredWidget.parent&&((factoredWidget.parent=parentWidget).widgets=parentWidget.widgets||[],parentWidget.widgets.push(factoredWidget),factoredWidget.extraElementsPath=extraElementsPath)})}}function ZhuAclCRUDController(ScreenService,ZHPromise,ZhuAclConfig,ZhuAclController,MessageService){function confirmChildsVisibility(elementsWidget,ruleType,messageConfig){var currentRow,defer,message,actions,returnPromise=ZHPromise.when();return elementsWidget.currentRow._childCount&&(currentRow=elementsWidget.currentRow,defer=ZHPromise.defer(),actions=[{label:ScreenService.i18n(ZhuAclMessages.YES),code:function(){currentRow.changed=!0,function deleteChildrensRules(elementsWidget,parentRow,groupId,parentRule){parentRow._childCount&&elementsWidget.dataSource.data.forEach(function(row){row._parent==parentRow&&(row.extraElement?row.RULE=parentRule:(row.__isDeleted=!0,row.RULE_SAVE_CONTAINER=parentRule),row.changed=!0,row.GROUP_ID=groupId,deleteChildrensRules(elementsWidget,row,groupId,parentRule))})}(elementsWidget,currentRow,currentRow.GROUP_ID,currentRow.RULE),defer.resolve()}},{label:ScreenService.i18n(ZhuAclMessages.NO),code:function(){MessageService.showMessageByCode(ZhuAclMessages.CONFIRMATION_MESSAGE,{},{type:"confirmation",icon:"question"}),defer.reject()}}],message=ZhuAclMessages.CONFIRM_CHILDS_QUESTION,actions={type:"confirmation",icon:"question",actions:actions},MessageService.showCustomDialogByCode(message,((rule,messageConfig)=>{var question=ZhuAclMessages.VISIBLE;return rule==ZhuAclConfig.RULE_INVISIBLE?question=ZhuAclMessages.INVISIBLE:rule==ZhuAclConfig.RULE_ALLOW&&(question=ZhuAclMessages.EDITABLE),messageConfig.newVisibility=ScreenService.i18n(question),messageConfig})(ruleType,messageConfig),actions),returnPromise=defer.promise),returnPromise}function cancelSave(widget){widget.reload()}function saveRule(widget,isEditable,isVisible,messageConfig){var currentRow=widget.currentRow,ruleType=ZhuAclConfig.getRuleType(isVisible,isEditable);delete currentRow.changed_isEditable,((currentRow,isVisible,isEditable)=>{currentRow.RULE=ZhuAclConfig.getRuleType(isVisible,isEditable),currentRow.isVisible=isVisible,currentRow.isEditable=isEditable,currentRow.GROUP_ID=currentRow.GROUP_ID||ZhuAclController.getCurrentGroupId()})(currentRow,isVisible,isEditable),confirmChildsVisibility(widget,ruleType,messageConfig).then(function(){widget.saveRow().then(function(response){widget.reload(),MessageService.successNotificationByCode(ZhuAclMessages.SUC_RULE_INSERTED)}).catch(function(){cancelSave(widget),MessageService.notificationMessageByCode(ZhuAclMessages.ERR_RULE_INSERTED,{},{type:"alert"})})}).catch(function(){cancelSave(widget),MessageService.notificationMessageByCode(ZhuAclMessages.RULE_NOT_SAVED,{},{type:"alert"})})}this.changeIsEditable=function(widget,row,messageConfig){var isEditable=row.isEditable;saveRule(widget,isEditable,isEditable||row.isVisible,messageConfig)},this.changeIsVisible=function(widget,row,messageConfig){var isVisible=row.isVisible;saveRule(widget,isVisible&&row.isEditable,isVisible,messageConfig)}}function ZhuAclExportRulesController(templateManager,MessageService,ScreenService,ZhuAclConfig,ZhuAclController,ZhuAclService){var self=this;this.exportRules=function(){var currentRow,exportRulesWidget=templateManager.container.getWidget(ZhuAclConfig.exportRulesModal);exportRulesWidget.isValid()&&(currentRow=exportRulesWidget.currentRow,exportRulesWidget={type:"CONFIRMATION",actions:[{label:ScreenService.i18n(ZhuAclMessages.YES),code:function(){var profileFrom,profilesToExport;profileFrom=currentRow.profileFrom,profilesToExport=currentRow.profilesToExport,ZhuAclService.exportRules(profileFrom,profilesToExport).then(self.closeExportRulesPopup).catch(function(response){response=response&&(response.errorCode||response.error)||ZhuAclMessages.ERR_RULES_EXPORTED;MessageService.errorNotificationByCode(response)})}},{label:ScreenService.i18n(ZhuAclMessages.NO)}]},MessageService.showCustomDialogByCode(ZhuAclMessages.CONFIRM_EXPORT,{},exportRulesWidget))},this.profileActionEventExportRules=function(groupId){var container=templateManager.container;return ZhuAclController.getFactoredWidget(container,ZhuAclConfig.exportRulesModal,!0).then(function(exportRulesWidget){ScreenService.openPopup(exportRulesWidget),exportRulesWidget.isVisible=!0,exportRulesWidget.currentRow={profileFrom:groupId},exportRulesWidget.fields[0].dataSourceFilter=[{name:"ID",operator:"<>",value:groupId}]})},this.closeExportRulesPopup=function(){ScreenService.closePopup()}}function ZhuContainerElementsController(templateManager,ZhuAclController,ZhuAclConfig,aclEngine,ZhuAclCRUDController,MessageService){function getContainerElementsTreeWidget(){return templateManager.container.getWidget(ZhuAclConfig.containerElementsTreeWidgetName)}function getContainerElementsListWidget(){return templateManager.container.getWidget(ZhuAclConfig.containerElementsListWidgetName)}function getPlannedContainer(rules,item,itemType,parentId){var uniqueId,plannedItems=[];return itemType=itemType||ZhuAclConfig.containerType,item&&!item.isZhuAclElement&&(item.label||["container","widgets"].includes(itemType))&&((uniqueId=item.id)?(itemType=ZhuAclConfig.getAclMap(itemType),parentId=ZhuAclController.getPlannedItemToInsertInDataSet(rules,item,itemType.aclTypeCod,parentId),((rules,item,itemToInsert)=>{var parentMenuId=item.parentMenuId,parentMenuLabel=item.parentMenuLabel||item.parentMenuName;parentMenuId&&parentMenuLabel&&(rules=ZhuAclController.getElementRule(rules,parentMenuId),itemToInsert.PARENT_MENU_ID=parentMenuId,itemToInsert.PARENT_MENU_NAME=item.parentMenuName||ZhuAclController.prepareLabelToName(parentMenuLabel),itemToInsert.PARENT_MENU_LABEL=parentMenuLabel,itemToInsert.PARENT_MENU_RULE_ID=rules.ID)})(rules,item,parentId),plannedItems.push(parentId),itemType.childs.forEach(function(type){Util.isArray(item[type])&&item[type].forEach(function(child){plannedItems=plannedItems.concat(getPlannedContainer(rules,child,type,uniqueId))})})):(parentId=item.label||item.name,idErrorMessages+="<br> "+parentId+";")),plannedItems}function copyItem(itemToCopy,itemType,parentId){var uniqueId,item;return!itemToCopy||itemToCopy.isZhuAclElement||itemToCopy.ignoreAclElementsConfig||(uniqueId=itemToCopy.id,item={id:uniqueId,name:itemToCopy.name,label:itemToCopy.label,parentMenuId:itemToCopy.parentMenuId,parentMenuName:itemToCopy.parentMenuName,parentMenuLabel:itemToCopy.parentMenuLabel},itemType=itemType||ZhuAclConfig.containerType,ZhuAclConfig.getAclMap(itemType).childs.forEach(function(type){Util.isArray(itemToCopy[type])&&(item[type]=itemToCopy[type].map(function(child){return copyItem(child,type)}).filter(function(copiedChild){return copiedChild}))})),item}var self=this,idErrorMessages="";this.reloadContainerElementsModal=function(){getContainerElementsListWidget().reload()},this.reloadContainerElementsTree=function(){getContainerElementsTreeWidget().reload()},this.selectAccessOnChange=function(selectedRow){selectedRow&&selectedRow.SELECT_ACCESS&&ZhuAclController.setElementsListFilter(templateManager.container,selectedRow.ID,ZhuAclConfig.containerElementsTreeWidgetName),self.reloadContainerElementsTree()};this.containerElementsTreeAfterLoadDataSource=function(){idErrorMessages="";var widget=getContainerElementsTreeWidget(),elementsListWidget=getContainerElementsListWidget(),elementsListRow=elementsListWidget&&elementsListWidget.currentRow,rulesData=Util.clone(widget.dataSource.data);widget.dataSource.data=[],elementsListWidget.getField("disableDescription").isVisible=!1,elementsListRow&&elementsListRow.SELECT_ACCESS&&(elementsListRow=ZhuAclController.getRulesFromDatasource(rulesData),rulesData=copyItem(templateManager.container))&&(aclEngine.processAcl(rulesData,elementsListRow,templateManager.userId,templateManager.project.elementListDefaultRule||ZhuAclController.getDefaultRule(),!0),widget.dataSource.data=getPlannedContainer(elementsListRow,rulesData),idErrorMessages&&MessageService.showMessageByCode(ZhuAclMessages.NSHOW_WITHOUT_ID,{elementsIds:idErrorMessages},{type:"alert",icon:"exclamation"}),checkEditContainerRules(rulesData,elementsListRow,widget,elementsListWidget))},checkEditContainerRules=function(container,rules,widget,elementsListWidget){var isVisibleField=widget.getField("isVisible"),widget=widget.getField("isEditable"),elementsListWidget=elementsListWidget.getField("disableDescription");rules.hasOwnProperty(container.id)&&rules[container.id].ruleRow&&"A"==rules[container.id].ruleRow.RULE?(isVisibleField.readOnly=!1,widget.readOnly=!1,elementsListWidget.isVisible=!1):(isVisibleField.readOnly=!0,widget.readOnly=!0,elementsListWidget.isVisible=!0)},this.isEditableOnChange=function(currentRow){var widget=getContainerElementsTreeWidget();ZhuAclCRUDController.changeIsEditable(widget,currentRow,{type:"container",subType:"elementos filhos"})},this.isVisibleOnChange=function(currentRow){var widget=getContainerElementsTreeWidget();ZhuAclCRUDController.changeIsVisible(widget,currentRow,{type:"container",subType:"elementos filhos"})}}function ZhuMenuElementsController(ScreenService,templateManager,ZhuAclController,ZhuAclConfig,aclEngine,ZhuAclCRUDController,MessageService,restEngine,ZHPromise){function getWidgetElements(){return templateManager.container.getWidget(ZhuAclConfig.menuElementsListWidgetName)}function addMenusInDataSource(widget,rules,menus,parentMenu){menus.forEach(function(menu,index){var item=((menuItem,parentMenuItem,rules)=>{var item;return menuItem.id?(parentMenuItem=parentMenuItem&&parentMenuItem.id,(item=ZhuAclController.getPlannedItemToInsertInDataSet(rules,menuItem,parentMenuItem?MENU:GROUP_MENU,parentMenuItem)).buildedMenu=menuItem.buildedMenu,addContainerProperties(item,menuItem,rules)):addErrorMenuId(menuItem),item})(menu,parentMenu,rules);item&&(widget.dataSource.data.push(item),menu.menus)&&0<menu.menus.length&&addMenusInDataSource(widget,rules,menu.menus,menu)})}function addExtraElements(widget,projectRules,defaultRule){extraRulesPromise.then(function(response){response&&response.data&&(response.data.forEach(function(row){id=row.UNIQUE_ID;var id=projectRules[id]&&projectRules[id].ruleRow||{};row.RULE=id.RULE,row.RULE_ID=id.ID,row.isVisible="I"!==(id.RULE||defaultRule),row.extraElement=!0}),widget.dataSource.data=widget.dataSource.data.concat(response.data))})}var extraRulesPromise,MENU="M",GROUP_MENU="G",IGNORED_MENUS=["zhHistory"],idErrorMessages={errorMenus:"",errorContainers:""},addErrorMenuId=function(item){item=item.label||item.name;idErrorMessages.errorMenus+="<br> "+item+";"},addErrorContainerId=function(item){item=item.label||item.name;idErrorMessages.errorContainers+="<br> "+item+";"},addContainerProperties=(this.elementsActionEventEdit=function(currentRow){var elementsWidget;currentRow.buildedMenu||(elementsWidget=getWidgetElements(),currentRow.isEditable=!currentRow.isEditable,ZhuAclCRUDController.changeIsEditable(elementsWidget,currentRow,{type:"menu",subType:"submenus"}))},this.elementsActionEventView=function(currentRow){var elementsWidget;currentRow.buildedMenu||(elementsWidget=getWidgetElements(),currentRow.isVisible=!currentRow.isVisible,currentRow.isEditable=currentRow.isVisible,ZhuAclCRUDController.changeIsVisible(elementsWidget,currentRow,{type:"menu",subType:"submenus"}))},this.elementsActionEventBack=function(){var elementsWidgetParent=getWidgetElements().parent;return ScreenService.closeSwipe().then(function(){elementsWidgetParent.list(),elementsWidgetParent.activate()})},function(item,menuItem,rules){var containerId=menuItem.containerId,containerLabel=menuItem.containerLabel||menuItem.containerName;containerId&&containerLabel?(rules=ZhuAclController.getElementRule(rules,containerId),item.CONTAINER_ID=containerId,item.CONTAINER_NAME=menuItem.containerName||ZhuAclController.prepareLabelToName(containerLabel),item.CONTAINER_LABEL=containerLabel,item.CONTAINER_RULE_ID=rules.RULE_ID):menuItem.windowName&&!menuItem.buildedMenu&&addErrorContainerId(menuItem)});this.loadPlanningTree=function(){var messageCode,extraElementsPath,elementsWidget=getWidgetElements(),userId=templateManager.userId,defautRule=templateManager.project.elementListDefaultRule||ZhuAclController.getDefaultRule(),rules=ZhuAclController.getRulesFromDatasource(elementsWidget.dataSource.data),newMenu=Util.clone(templateManager.project.groupMenu).filter(function(menu){return-1==IGNORED_MENUS.indexOf(menu.name)});idErrorMessages={errorMenus:"",errorContainers:""},extraElementsPath=elementsWidget.extraElementsPath,extraRulesPromise=extraRulesPromise||(extraElementsPath?restEngine.requestMetaData(Util.getRightPath(extraElementsPath),{}):ZHPromise.when()),aclEngine.processMenuAcl(newMenu,rules,templateManager.containers,userId,defautRule),elementsWidget.dataSource.data=[],addMenusInDataSource(elementsWidget,rules,newMenu),addExtraElements(elementsWidget,rules,defautRule),extraElementsPath=idErrorMessages.errorMenus,userId=idErrorMessages.errorContainers,extraElementsPath&&userId?messageCode=ZhuAclMessages.NSHOW_WITHOUT_ID_AND_CONTAINER_CONFIG:extraElementsPath?messageCode=ZhuAclMessages.NSHOW_WITHOUT_ID:userId&&(messageCode=ZhuAclMessages.NSHOW_WITHOUT_CONTAINER_CONFIG),messageCode&&MessageService.showMessageByCode(messageCode,{elementsIds:extraElementsPath,elementsWithoutContainer:userId},{type:"alert"})},this.reloadElementsWidget=function(){getWidgetElements().reload()}}function ZhuLogService(){function createRows(data,value,parent){Object.keys(value).forEach(function(key){((data,key,value,parent)=>{(Util.isObject(value)?factoryCreateObjectRows(": {}"):Array.isArray(value)?factoryCreateObjectRows(": []"):createSimpleRow)(data,key,value,parent)})(data,key,value[key],parent)})}function createSimpleRow(data,key,value,parent){addData(key,value=key+": "+(value="string"==typeof value?'"'+value+'"':value),parent,data)}function addData(key,value,parent,data){key=parent+"#"+key;return data.push({ID:key,VALUE:value,PARENT:parent}),key}function factoryCreateObjectRows(emptySufix){return function(data,key,rowContent,parent){var rowValue=key;0===Object.keys(rowContent).length&&(rowValue+=emptySufix),createRows(data,rowContent,addData(key,rowValue,parent,data))}}this.getPlainContentRows=function(value){var data=[];return createRows(data,JSON.parse(value)),data}}function ZhuLogController(ZhuLogService,ScreenService,templateManager,metaDataFactory,ZhPreferences,ZhFilterPreferences,$timeout,requestEngine,requestFactory){var self=this;function uniqid(){return Math.random().toString(10).substring(2,15)+Math.random().toString(10).substring(2,15)}function getZhuLogWidget(){return templateManager.container.getWidget("zhuLog")}this.closeSwipe=function(widget){ScreenService.closeSwipe(),widget.container.getWidget("zhuLog").activate()},this.showActiveAll=function(widget){requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/areAllActive",requestType:"filterData"})).then(function(response){response=response.dataset.status[0];widget.getAction("allowAll").isVisible=!response,widget.noMatchText=response?"All users allowed!":"No user allowed!",widget.activate()})},this.openPopUp=function(widget){var popUpDefaults={id:uniqid(),name:"controlPopUp",showDescriptionOrder:!1,label:"Allow User's Log",template:"widget/grid.html",showCheckbox:!0,isVisible:!0,itemsPerPage:30,events:[{name:"WidgetAfterSelectRow",code:"ZhuLogController.setPopUpAllowActionVisiblity(args.owner, true)"},{name:"WidgetAfterUnselectRow",code:"ZhuLogController.setPopUpAllowActionVisiblity(args.owner, false)"}],parent:widget,floatingControl:{searchAction:!0,customizationAction:{filter:!0,layout:!1,view:!1},xlsAction:!1,pdfAction:!1,csvAction:!1},dataSource:{rest:!0,localStorage:!1,data:[],name:"/operador",itemsPerPage:30},dataSourceFilter:[{name:"IDATIVO",operator:"=",value:"S"}],fields:[{id:uniqid(),name:"CDOPERADOR",label:"ID",operator:"NOT IN",template:"field/text.html",isVisible:!0,showOnList:!0},{id:uniqid(),name:"NMOPERADOR",label:"Name",template:"field/text.html",isVisible:!0,showOnList:!0},{id:uniqid(),name:"DSEMAILOPER",label:"Email",template:"field/text.html",isVisible:!0,showOnList:!0},{id:uniqid(),name:"NRORG",label:"Organization",template:"field/select.html",dataSource:{name:"/organization",rest:!0,localStorage:!1,data:[]},dataSourceFilter:[],valueField:"ID",descriptionField:"NAME",isVisible:!0,showOnList:!0}],actions:[{id:uniqid(),name:"allow",label:"Allow",isVisible:!1,showAsAction:"never",events:[{name:"ActionEvent",code:"ZhuLogController.setZhuLogConfiguration(args.owner.widget,allow)"}]},{id:uniqid(),name:"back",label:"Cancel",isVisible:!0,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup()"}]}]},popUpDefaults=(widget.dataSource.data.length&&popUpDefaults.dataSourceFilter.push({name:"CDOPERADOR",operator:"NOT_IN",value:widget.dataSource.data.map(function(user){return user.USER_ID})}),metaDataFactory.widgetFactory(popUpDefaults,widget.container));ScreenService.openPopup(popUpDefaults)},this.setPopUpAllowActionVisiblity=function(widget,isVisible){widget.getAction("allow").isVisible=isVisible,widget.activate()},this.switchLogStatus=function(widget){requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/switch",requestType:"dataSource",dataSource:{}})).then(function(response){widget.container.label=response.dataset.status[0]?"Log - Active":"Log - Inactive",widget.activate()})},this.setZhuLogConfiguration=function(widget,method){var checkedUsers=widget.getCheckedRows(),params={all:!1,deny:!1,allow:!1};switch(method){case"remove":params.deny=!0;break;case"all":params.all=!0}params.users=params.all?[]:checkedUsers,requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/update",requestType:"dataSource",dataSource:params})).then(function(){ScreenService.closePopup(!0),parentWidget=widget.container.getWidget("logConfigurationWidget"),self.showActiveAll(parentWidget),parentWidget.reload()})},this.openContent=function(widget){templateManager.container.getWidget("contentForm").currentRow=widget.currentRow;widget=ZhuLogService.getPlainContentRows(widget.currentRow.CONTENT);templateManager.container.getWidget("contentGrid").dataSource.data=widget,ScreenService.openSwipe(templateManager.container.getWidget("content"))};this.zhuLogWidgetOnEnter=function(){var widget=getZhuLogWidget();$timeout(function(){var currentRow;widget.inListMode()&&(widget.zhuLogAppliedFilter?widget.reload():(currentRow=widget.currentRowDefaultFilter||widget.currentRow,ZhFilterPreferences.setOriginalFilter(widget.id,currentRow),((widget,currentRow)=>{ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result){result&&ZhFilterPreferences.openFilterWidget(widget,currentRow)})})(widget,currentRow))),(widget=>{requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/status",requestType:"filterData"})).then(function(response){widget.container.label=response.dataset.status[0]?"Log - Active":"Log - Inactive",widget.activate()})})(widget)},500,!1)},this.zhuLogFilterAfterApply=function(){getZhuLogWidget().zhuLogAppliedFilter=!0},this.openFilterPopUp=function(){ScreenService.openPopup(templateManager.container.getWidget("select"))},this.setSelectValues=function(){var selectWidget=templateManager.container.getWidget("select"),select2=templateManager.container.getWidget("select").fields[1];"REQUEST"===selectWidget.currentRow.SNATIVE?(select2.label="Resquest type",select2.readOnly=!1,select2.dataSource.data=[],select2.dataSource.data.push({value:"Dataset"},{value:"Row"},{value:"Empty"},{value:"Filter"})):"RESPONSE"===selectWidget.currentRow.SNATIVE?(select2.label="Response type",select2.readOnly=!1,select2.dataSource.data=[],select2.dataSource.data.push({value:"Dataset"},{value:"Message"})):(select2.dataSource.data=[],this.clearFieldsValue(1),select2.readOnly=!0)},this.setTextEdit=function(){var selectWidget=templateManager.container.getWidget("select");selectWidget.actions[2].isVisible=!0,selectWidget.actions[3].isVisible=!0,"REQUEST"===selectWidget.currentRow.SNATIVE?("Dataset"!==selectWidget.currentRow.SNATIVE2&&"Row"!==selectWidget.currentRow.SNATIVE2||(selectWidget.fields[2].label="Column name",selectWidget.fields[3].label="Operator",selectWidget.fields[3].template="field/select-native.html",selectWidget.fields[4].label="Value",this.addFields()),"Empty"===selectWidget.currentRow.SNATIVE2&&(selectWidget.fields[2].label="Parameter",selectWidget.fields[3].label="Operator",selectWidget.fields[3].template="field/select-native.html",selectWidget.fields[4].label="Value",this.addFields()),"Filter"===selectWidget.currentRow.SNATIVE2&&(selectWidget.fields[2].label="Column name",selectWidget.fields[3].label="Column value",selectWidget.fields[3].template="field/text-edit.html",selectWidget.fields[4].label="Value",this.addFields()),null===selectWidget.currentRow.SNATIVE2&&this.removeExtraFields()):"RESPONSE"===selectWidget.currentRow.SNATIVE&&("Dataset"===selectWidget.currentRow.SNATIVE2&&(selectWidget.fields[2].label="Column name",selectWidget.fields[3].label="Operator",selectWidget.fields[3].template="field/select-native.html",selectWidget.fields[4].label="Value",this.addFields()),"Message"==selectWidget.currentRow.SNATIVE2&&(selectWidget.fields[2].label="Column name",selectWidget.fields[3].label="Operator",selectWidget.fields[3].template="field/select-native.html",selectWidget.fields[4].label="Value",this.addFields()),null===selectWidget.currentRow.SNATIVE2)&&this.removeExtraFields()},this.removeExtraFields=function(){for(var selectWidget=templateManager.container.getWidget("select"),fields=selectWidget.fields,i=fields.length-1;6<i;i--)Util.isUndefined(fields[i])||(delete selectWidget.currentRow[fields[i].name],delete fields[i])},this.addFields=function(){for(var dataSource,selectWidget=templateManager.container.getWidget("select"),fields=templateManager.container.getWidget("select").fields,i=2;i<=6;i++){var field=5!==i?(Util.isUndefined(fields[i].dataSource)||(dataSource={data:fields[i].dataSource.data}),{label:fields[i].label,template:fields[i].template,name:"extraField"+fields.length,class:fields[i].class,events:fields[i].events,dataSource:dataSource,valueField:fields[i].valueField,descriptionField:fields[i].descriptionField,isVisible:!0,breakline:fields[i].breakline}):{label:fields[i].label,template:fields[i].template,name:"extraField"+fields.length,class:fields[i].class,events:fields[i].events,dataSource:dataSource,valueField:fields[i].valueField,descriptionField:fields[i].descriptionField,isVisible:!1,breakline:fields[i].breakline};metaDataFactory.fieldFactory(field,selectWidget,selectWidget)}},this.clearAllFields=function(){this.removeExtraFields(),this.clearFieldsValue(0)},this.clearFieldsValue=function(startingValue){for(var selectWidget=templateManager.container.getWidget("select"),i=startingValue;i<selectWidget.fields.length;i++)Util.isUndefined(selectWidget.fields[i])||""!==selectWidget.fields[i].value&&selectWidget.fields[i].value("");selectWidget.fields[1].readOnly=!0},this.clearFields=function(args){for(var fieldIndex=args.owner.field.sequenceInList,selectWidget=(fieldIndex--,templateManager.container.getWidget("select")),fields=selectWidget.fields,i=fieldIndex;fieldIndex-4<=i;i--)delete selectWidget.currentRow[fields[i].name],delete fields[i];templateManager.updateTemplate()},this.manageFields=function(args){var args=args.owner.field.sequenceInList,selectWidget=(args--,templateManager.container.getWidget("select")),selectedValue=selectWidget.fields[args].value();"IS_NULL"===selectedValue||"IS_NOT_NULL"===selectedValue?(selectWidget.fields[1+args].readOnly=!1,selectWidget.fields[1+args].class=4,selectWidget.fields[2+args].isVisible=!1,selectWidget.fields[1+args].readOnly=!0):"BETWEEN"===selectedValue||"NOT_BETWEEN"===selectedValue?(selectWidget.fields[1+args].class=2,selectWidget.fields[1+args].label="Begin",selectWidget.fields[2+args].isVisible=!0):(selectWidget.fields[1+args].readOnly=!1,selectWidget.fields[1+args].class=4,selectWidget.fields[1+args].label="Value",selectWidget.fields[2+args].isVisible=!1)},this.startFiltering=function(){for(var name,operator,value,fields=templateManager.container.getWidget("select").fields,i=9,j=0;i<fields.length;)Util.isUndefined(fields[i])?i+=5:(name=fields[i].value(),operator=fields[++i].value(),i++,"IS_NULL"===operator||"IS_NOT_NULL"===operator?(value="",i+=3):"BETWEEN"===operator||"NOT_BETWEEN"===operator?((value=[])[0]=fields[i].value(),i++,value[1]=fields[i].value(),i+=2):(value=fields[i].value(),i+=3),j++)}}function ZhuLogDecorator(ApplicationContext,templateManager){var logDecorator;function getLogDecorator(){return logDecorator=void 0===logDecorator?templateManager.projectPromise.then(function(){var decoratorServiceName=templateManager.project.zhuLogDecoratorService;return ApplicationContext[decoratorServiceName]}):logDecorator}this.afterLoadDataSource=function(args){getLogDecorator().then(function(logDecorator){var dataSource;logDecorator&&((dataSource=args.owner.dataSource).data=logDecorator.normalizeRows(dataSource.data))})},this.beforeGridFilterApply=function(args){getLogDecorator().then(function(logDecorator){var _event;logDecorator&&((_event=args.e).filters=logDecorator.normalizeFilters(_event.preference.FILTER_ROW))})},this.apply=function(containerName,container){return getLogDecorator().then(function(logDecorator){var logWidget;return logDecorator&&"zhulog#log"===containerName&&((logWidget=container.widgets[0]).events.push({name:"WidgetAfterLoadDataSource",code:"ZhuLogDecorator.afterLoadDataSource(args);"}),logWidget.events.push({name:"FilterBeforeApply",code:"ZhuLogDecorator.beforeGridFilterApply(args);"}),logDecorator.decorateWidget(logWidget)),container})}}function ZhuLogHelper(){this.moveField=function(widget,fieldName,position){var index=-1;widget.fields.find(function(field){return index++,field.name===fieldName}),widget.fields.splice(position-1,0,widget.fields.splice(index,1)[0])},this.getField=function(widget,fieldName){widget=widget.fields.find(function(field){return field.name===fieldName});if(null===widget)throw'Field "'+fieldName+'" not found';return widget},this.addField=function(widget,field,position){position=(position||widget.fields.length)-1,widget.fields.splice(position,0,field)},this.removeField=function(widget,fieldName){widget.fields=widget.fields.filter(function(field){return field.name!==fieldName})},this.editField=function(widget,fieldName,editings){widget=this.getField(widget,fieldName);Util.extend(widget,editings)},this.getFilters=function(filters,filterName){return filters.filter(function(filter){return filter.name===filterName})},this.addFilter=function(filters,filter){filters.push(filter)},this.removeFilter=function(filters,filterName){filters.filter(function(filter){return filter.name!==filterName})}}function Colors(){this.TColorToHex=function(TColor){TColor=this.TColorToRGB(TColor);return this.rgbToHex(TColor)},this.TColorToRGB=function(TColor){return[255&TColor,TColor>>8&255,TColor>>16&255]},this.rgbToHex=function(rgb){return"#"+((1<<24)+(rgb[0]<<16)+(rgb[1]<<8)+rgb[2]).toString(16).slice(1)},this.RGBToTColor=function(r,g,b){return r|g<<8|b<<16}}["ACCESS_DENIED","RULE_NOT_SAVED","SUC_RULE_INSERTED","ERR_RULE_INSERTED","SUC_RULES_EXPORTED","ERR_RULES_EXPORTED","CANNOT_LOAD_RULES","CONFIRMATION_MESSAGE","CONFIRM_CHILDS_QUESTION","CONFIRM_EXPORT","NSHOW_WITHOUT_ID","NSHOW_WITHOUT_CONTAINER_CONFIG","NSHOW_WITHOUT_ID_AND_CONTAINER_CONFIG"].forEach(function(code){ZhuAclMessages[code]="zhuacl#"+code}),ZeedhiServices.service("ZhuAccessButtonService",function(ApplicationContext){var instance=new ZhuAccessButtonService;return ApplicationContext.registerInstance("ZhuAccessButtonService",instance),instance}),Configuration(function(ContextRegister){ContextRegister.register("ZhuAclService",ZhuAclService)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuAclController",ZhuAclController)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuAclCRUDController",ZhuAclCRUDController)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuAclExportRulesController",ZhuAclExportRulesController)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuContainerElementsController",ZhuContainerElementsController)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuMenuElementsController",ZhuMenuElementsController)}),ZeedhiApp.run(function(templateManager,ZhuAccessButtonService){templateManager.projectPromise.then(function(project){templateManager.project.aclEnable&&ZhuAccessButtonService.insertButtonInProject(templateManager.project)})}),Configuration(function(ContextRegister){ContextRegister.register("ZhuLogService",ZhuLogService)}),Configuration(function(ContextRegister){ContextRegister.register("ZhuLogController",ZhuLogController)}),Configuration(function(ContainerDecoratorProvider,ContextRegister,ApplicationContext,templateManager){ContextRegister.register("ZhuLogDecorator",ZhuLogDecorator),ContainerDecoratorProvider.registerProvider(new ZhuLogDecorator(ApplicationContext,templateManager))}),Configuration(function(ContextRegister){ContextRegister.register("ZhuLogHelper",ZhuLogHelper)}),Configuration(function(ContextRegister){ContextRegister.register("Colors",Colors)});var Endereco=function(restEngine,ScreenService,MessageService,ZHPromise){var self=this;self.buscarCep=function(CEP){if(8==(CEP=CEP.replace(/[\D]+/g,"")).length)return restEngine.post("/lib_findAddress",{requestType:"Row",row:{CEP:CEP}});ScreenService.showMessage("CEP Inválido.")},self.validarCep=function(widget,CEP){self.buscarCep(CEP).then(function(response){response=response.dataset.ENDERECO;response?(widget.currentRow.CEP=CEP,widget.currentRow.CDPAIS=response.CDPAIS||"",widget.currentRow.NMPAIS=response.NMPAIS||"",widget.currentRow.SGESTADO=response.SGESTADO||"",widget.currentRow.NMESTADO=response.NMESTADO||"",widget.currentRow.CDMUNICIPIO=response.CDMUNICIPIO||"",widget.currentRow.NMMUNICIPIO=response.NMMUNICIPIO||"",widget.currentRow.CDBAIRRO=response.CDBAIRRO||"",widget.currentRow.NMBAIRRO=response.NMBAIRRO||"",widget.currentRow.CDLOGRADOURO=response.CDLOGRADOURO||"",widget.currentRow.DSLOGRADOURO=response.DSLOGRADOURO||"",widget.currentRow.DSENDERECO=response.DSENDERECO||""):widget.currentRow.CEP=""},function(error){MessageService.getMessageByCode("PROXY_CONNECTION_FAIL").then(function(errorMessage){var row={CEP:CEP,errorMessage:errorMessage};widget.currentRow.CEP="",error.data&&(errorMessage=error.data.error),ScreenService.showMessageByCode("REQUEST_CEP_ERROR",row,Constants.errorMessage)})})}},General=(Configuration(function(ContextRegister){ContextRegister.register("Endereco",Endereco)}),function(ScreenService,templateManager,localStorageEngine,restEngine,maskEngine,ZhUtil,ZHPromise,ValidationEngine,metaDataFactory,MessageService){function _getWidget(widgetName){if(templateManager.container){var widget=arguments[1]||null?(widget=templateManager.container.getWidget(widgetName))&&(widget.hasOwnProperty("__filterPopup")?widget.__filterPopup:widget.appliedFilter):templateManager.container.getWidget(widgetName);if(widget)return widget}return null}function _getField(name,widgetName){return(widgetName=_getWidget(widgetName).getField(name))||null}function _getAction(name,widgetName){return(widgetName=_getWidget(widgetName).getAction(name))||null}var searchListDeleted,currentIdgrupoper,currentCallback,currentParameters,reportCallback,reportParameters,reportWidgetParentName,parent=this,cacheLoaded=!1,changeDependetFieldFilter=(this.onClickDependentField=function(dependentField,parameters){var dataSourceFilterNew=this.buildDataSourceFilter(angular.copy(dependentField.dataSourceFilter),parameters),parameters=compareDataSourceFilters(dependentField.selectWidget,dataSourceFilterNew,parameters);parameters&&changeDependetFieldFilter(dependentField,dataSourceFilterNew),(dependentField.selectWidget&&parameters||!dependentField.dataSource.data||!dependentField.dataSource.data.length||searchListDeleted)&&dependentField.reload()},this.buildDataSourceFilter=function(dataSourceFilter,parameters){if(!dataSourceFilter)throw"DataSourceFilter is not defined!";for(var position in dataSourceFilter)parameters.hasOwnProperty(dataSourceFilter[position].name)&&(dataSourceFilter[position].value=parameters[dataSourceFilter[position].name]);return dataSourceFilter},function(dependentField,dataSourceFilterNew){dependentField.dataSourceFilter=dataSourceFilterNew,dependentField.dataSource.lazyLoad=!1,dependentField.selectWidget&&(dependentField.selectWidget.dataSourceFilter=dataSourceFilterNew),dependentField.selectWidget&&dependentField.selectWidget.searchList?(searchListDeleted=!0,delete dependentField.selectWidget.searchList):dependentField.selectWidget&&(searchListDeleted=!1)}),compareDataSourceFilters=function(selectWidget,dataSourceFilterNew,parameters){var changedDataSourceFilter=!1;if(selectWidget)for(var selectWidgetDataSourceFilter=selectWidget.dataSourceFilter,position=0;position<dataSourceFilterNew.length;position++)parameters.hasOwnProperty(dataSourceFilterNew[position].name)&&selectWidgetDataSourceFilter[position].value!=dataSourceFilterNew[position].value&&(changedDataSourceFilter=!0);else changedDataSourceFilter=!0;return changedDataSourceFilter},toNumber=(this.getLevelByMask=function(maskName,firstLevel){firstLevel=toNumber(firstLevel);for(var splitMask=getLocalVar(maskName).split("."),biggestLevel=splitMask.length,level=[],objLevel={},i=0;i<biggestLevel;i++)(objLevel={nivel:i+firstLevel,caracteres:0<i?parseInt(level[i-1].caracteres)+parseInt(splitMask[i].length):parseInt(splitMask[i].length)}).nivel=objLevel.nivel.toString(),objLevel.caracteres=objLevel.caracteres.toString(),level.push(objLevel);return level},function(value){if(!value&&0!==value)throw"firstLevel is not defined";if("number"!=typeof value&&value&&(value=parseInt(value),isNaN(parseInt(value))))throw"Invalid firstLevel";return value}),gruposDeOperador=(this.toggleReadOnlySelect=function(checkboxField,selectField){checkboxField.checked?(selectField.readOnly=!0,selectField.validations={},selectField.setValue("")):(selectField.readOnly=!1,selectField.validations={required:!0}),templateManager.updateTemplate()},this.setLoggedUnit=function(widget){widget.currentRow.CDFILIAL=getLocalVar("CDFILIAL"),widget.currentRow.NMFILIAL=getLocalVar("NMFILIAL")},{LCMR:"A liberação de cardápio fora da meta dependente de autorização"}),fields=[{name:"email",label:"E-mail",class:12,isVisible:!0,readOnly:!1,template:"field/text-edit.html",events:[],fieldGroup:"AUTH",validations:{required:!0,mail:!0}},{name:"senha",label:"Senha",class:12,isVisible:!0,readOnly:!1,fieldGroup:"AUTH",template:"field/password-edit.html",events:[],validations:{required:!0}}],actions=[{name:"cancelar",label:"Cancelar",idVisible:!0,hideIcon:!0,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"confirmar",label:"Confirmar",idVisible:!0,hideIcon:!0,showAsAction:"never",events:[{name:"ActionEvent",code:"General.validateUser(args.owner.widget);"}]}],initAuthVariables=(this.openAuthPopup=function(idgrupoper,message,callback,parameters){if(!idgrupoper)throw"idgrupoper is not defined";initAuthVariables(idgrupoper,callback,parameters),message=message||gruposDeOperador[currentIdgrupoper]||"";idgrupoper=metaDataFactory.widgetFactory({id:0,name:"authWidget",label:"Autenticação",template:"widget/form.html",container:templateManager.container,isVisible:!0,popupNoBlock:!1,fieldGroups:[{id:1e5,name:"AUTH",opened:!0,collapsible:!1,label:message}],fields:fields,actions:actions,events:[]});ScreenService.openPopup(idgrupoper)},function(idgrupoper,callback,parameters){currentIdgrupoper=idgrupoper,currentCallback=callback||null,currentParameters=parameters||[]}),autenticar=(this.validateUser=function(widget){var email,self=this;widget.isValid()&&(email=widget.currentRow.email,widget=widget.currentRow.senha,autenticar(email,widget).then(function(callback){getPermission(callback.dataset.user.cdoperador).then(function(permission){if(permission){if("function"!=typeof currentCallback)throw"callback is not a function";ScreenService.closePopup(),currentCallback.apply(null,currentParameters)}else MessageService.showMessageByCode("lib#GEN_INVALID_OPERGROUP",null,{type:"ERROR"})},function(callback){this.callbackError(callback)}.bind(self))},function(callback){this.callbackError(callback)}.bind(self)))},function(email,senha){return restEngine.request("/Autenticar",{requestType:"FilterData",filter:[{name:"email",operator:"=",value:email},{name:"senha",operator:"=",value:senha}]})}),getPermission=function(cdoperador){return restEngine.request("/validateUserGroup",{requestType:"Row",row:{idgrupoper:currentIdgrupoper,cdoperador:cdoperador}}).then(function(callback){return callback.dataset.permission.isValid})},reportWidget=(this.callbackError=function(callback){callback.data?ScreenService.showMessage(ScreenService.i18n(callback.data.error)):MessageService.showMessageByCode("lib#GEN_TIMEOUT",null,{type:"ERROR"})},{id:0,name:"reportWidget",label:"Tipo de Relatório",template:"widget/form.html",container:{},isVisible:!0,popupNoBlock:!(this.comparaPratoProduto=function(pinicial,pfinal,mascara){for(var mascara={type:"fix",params:{mask:mascara}},mascara=(pinicial=Util.applyMask(pinicial,mascara,maskEngine,ZhUtil).split("."),pfinal=Util.applyMask(pfinal,mascara,maskEngine,ZhUtil).split("."),pinicial.length),nvfinal=pfinal.length,menornv=nvfinal<mascara?nvfinal:mascara,i=0;pinicial[i]==pfinal[i]&&i<menornv;)i++;return!(pinicial.hasOwnProperty(i)&&!pfinal.hasOwnProperty(i)||pinicial[i]>pfinal[i])}),fields:[],actions:[],events:[]}),reportFields=[{id:99999999,name:"QR2TYPE",label:"",class:12,readOnly:!1,isVisible:!0,isVisibleForm:!0,isVisibleGrid:!1,template:"field/radio-group.html",events:[],valueField:"value",descriptionField:"name",defaultOption:0,dataSource:{data:[{name:"pdf",value:"PDF"},{name:"xls",value:"XLS"},{name:"rtf",value:"RTF"},{name:"txt",value:"TXT"}]}}],reportActions=[{name:"cancelar",label:"Cancelar",idVisible:!0,hideIcon:!0,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"confirmar",label:"Confirmar",idVisible:!0,hideIcon:!0,showAsAction:"never",events:[{name:"ActionEvent",code:"General.generateReport(args.owner.widget, args);"}]}],updateReportWidgetFormats=(this.openReportPopup=function(widget,callback,parameters,reportFormats){reportCallback=callback,reportParameters=parameters||[],reportWidgetParentName=widget.name,reportWidget.container=widget.container,reportWidget.fields=reportFields,reportWidget.actions=reportActions;callback=metaDataFactory.widgetFactory(reportWidget);updateReportWidgetFormats(callback,reportFormats),ScreenService.openPopup(callback)},function(reportWidget,reportFormats){Array.isArray(reportFormats)&&reportFormats.length&&(reportWidget.getField("QR2TYPE").dataSource.data=reportFormats)}),setDuplicationValidateParamsToCurrentRow=(this.generateReport=function(widget,args){var reportWidgetParentCurrentRow=widget.container.getWidget(reportWidgetParentName).currentRow;reportWidgetParentCurrentRow.QR2TYPE=widget.currentRow.QR2TYPE,args.row=reportWidgetParentCurrentRow,"function"==typeof reportCallback&&reportCallback.apply(null,reportParameters),ScreenService.closePopup()},this.saveRow=function(args,closeSwipe){args.owner.widget.saveRow().then(function(){var currentRow=args.owner.widget.currentRow;currentRow.__is_new=!1,currentRow.changed=!1,args.owner.widget.reload(),closeSwipe&&ScreenService.closeSwipe()})},this.openSelectionOnce=function(name){name=templateManager.container.getWidget(name+"_FILTER");name.wasOpened||(name.edit(),ScreenService.openPopup(name),name.wasOpened=!0)},this.openSelection=function(name){name=templateManager.container.getWidget(name+"_FILTER");name.edit(),ScreenService.openPopup(name)},this.getContainerName=function(){return templateManager.container.name},this.backOrCancel=function(args){var deferred=ZHPromise.defer();if(args.row.__is_new)args.owner.widget.list(!0),args.owner.widget.dataSource.data.pop(),args.owner.widget.currentRow={},deferred.resolve();else if("edit"===args.owner.widget.mode){for(var i in args.owner.widget.view(),args.owner.widget.backupRow)args.owner.widget.currentRow[i]=args.owner.widget.backupRow[i];return deferred.resolve(),deferred.promise}return ScreenService.goBack(),deferred.promise},this.edit=function(widget){widget.backupRow=Object.assign({},widget.currentRow),widget.edit()},this.modEdit=function(widget){parent.edit(widget);var widgetParent=widget.widgets;widgetParent.length&&parent.setVisibleforTabbed(widgetParent,!1,widget)},this.cancelModEdit=function(args,widgetParent){parent.backOrCancel(args).then(function(success){var widgetParent=args.owner.widget.widgets;widgetParent.length&&parent.setVisibleforTabbed(widgetParent,!0)})},this.setVisibleforTabbed=function(widgets,isVisible,exception){widgets.forEach(function(widget){(!exception||exception.name!=widget.name)&&(widget.isVisible=isVisible)})},this.setContextVar=function(name,containerName,value){localStorageEngine.setLocalVar(containerName+"_"+name,value)},this.getContextVar=function(name,containerName){return localStorageEngine.getLocalVar(containerName+"_"+name)},this.getFieldValue=function(name,widgetName){widgetName=_getWidget(widgetName,arguments[2]||null);return widgetName&&widgetName.currentRow?widgetName.currentRow[name]:""},this.setEnableField=function(name,widgetName){_getField(name,widgetName).readOnly=!1},this.setDisableField=function(name,widgetName){_getField(name,widgetName).readOnly=!0},this.setVisibleField=function(name,widgetName){_getField(name,widgetName).isVisible=!0},this.setInvisibleField=function(name,widgetName){_getField(name,widgetName).isVisible=!1},this.setEnableAction=function(name,widgetName){_getAction(name,widgetName).readOnly=!1},this.setDisableAction=function(name,widgetName){_getAction(name,widgetName).readOnly=!0},this.setVisibleAction=function(name,widgetName){_getAction(name,widgetName).isVisible=!0},this.setInvisibleAction=function(name,widgetName){_getAction(name,widgetName).isVisible=!1},this.now=function(){return moment(new Date).format("DD/MM/YYYY HH:mm:ss")},this.today=function(){return moment(new Date).format("DD/MM/YYYY")},this.openReport=function(route,reportName,params,isUrl){isUrl=!!isUrl,params.__report_name=reportName;var lastActiveWidget=templateManager.container.getActiveWidget().lastActiveWidget;return lastActiveWidget&&lastActiveWidget.beforeOpenReport&&lastActiveWidget.beforeOpenReport({reportParams:params}),restEngine.post(route,{requestType:"Row",row:params},null,null,null,null,3e6).then(function(response){var url,isLibOpenReport;response&&response.messages&&(isLibOpenReport=(response=response.messages.pop()).message.includes("lib_openReport"),isUrl||isLibOpenReport?(url=response.message,isLibOpenReport&&(url=(isLibOpenReport=(isLibOpenReport=window.serviceUrls.find(function(item){return item.package==(item=(item=window.location.hash.split("/").filter(function(_){return _.length}).pop())&&0<item.length?item.split(/_|#/)[0]:item)}).baseUrl).includes("http")?isLibOpenReport:window.location.origin+window.location.pathname.replace("//","/")+isLibOpenReport)+url),window.open(url)||MessageService.showMessageByCode("lib#GEN_POPUP_BLOCKER",null,{type:"ERROR"})):(params.QR2TYPE&&(params.__FORMAT=params.QR2TYPE),isLibOpenReport=params.__FORMAT||"pdf",(url=response.message).includes("&format=")&&(url=(response=url.split("&format="))[0],isLibOpenReport=response[1]),response=document.createElement("a"),document.body.appendChild(response),response.style="display: none",response.href="data:application/octet-stream;base64,"+url,response.download=reportName+"."+isLibOpenReport,response.click()))}).catch(function(response){response.data&&response.data.error&&ScreenService.showMessage(ScreenService.i18n(response.data.error),"E")})},this.saveCrud=function(widget,afterValid){var deferred=ZHPromise.defer();return widget.isValid()?(afterValid&&angular.isObject(afterValid)&&angular.isFunction(afterValid.callback)&&afterValid.callback.apply(null,afterValid.params),(afterValid=widget.paramsNewCode)&&afterValid.__is_new_code&&(widget.currentRow.__using_unit=afterValid.__using_unit||!1,widget.currentRow.__new_code_pk=afterValid.__new_code_pk,widget.currentRow.__table_pk=afterValid.__table_pk,widget.currentRow.__new_code_interval=afterValid.__new_code_interval||1,widget.currentRow.__new_code_length=afterValid.__new_code_length||5,widget.currentRow.__new_code_column_size=afterValid.__new_code_column_size||10,widget.currentRow.__cast_number=afterValid.__cast_number||!1),(afterValid=widget.fieldsToValidateDuplication)&&afterValid.length&&setDuplicationValidateParamsToCurrentRow(widget),widget.saveRow().then(function(success){widget.activate(),widget.currentRow.__is_new?(widget.list(!0),ScreenService.goBack(),widget.reload().then(function(){deferred.resolve(success)})):(widget.computeDescriptionOrder(),widget.view(),deferred.resolve(success))},function(error){var errorMessage="Timeout";error.data&&(errorMessage=error.data.error),ScreenService.showMessage(errorMessage),deferred.reject(errorMessage)})):deferred.reject("Preencha todos os campos corretamente!"),deferred.promise},function(widget){try{var index,fieldsToValidate=widget.fieldsToValidateDuplication,validationArray=[];for(index in checkValidateFieldsArray(fieldsToValidate),fieldsToValidate){var warningMsg,field=fieldsToValidate[index];field.description||(field.description=field.name,warningMsg="Missing description for "+field.name+" field in 'fieldsToValidateDuplication' of "+widget.name,console.warn(warningMsg)),field.description=field.description.toLowerCase(),validationArray.push(field)}validationArray.length&&(widget.currentRow.__fieldsToValidateDuplication=validationArray)}catch(e){ScreenService.showMessage(e)}}),checkValidateFieldsArray=function(arrayToCheck){for(var index in arrayToCheck){index=arrayToCheck[index];if("object"!=typeof index)throw"Error in data save. Property 'fieldsToValidateDuplication' of widget has non-object elements.";if(!index.name)throw"Error in data save. Property 'fieldsToValidateDuplication' of widget has elements without name."}};function avoidNonInteger(e){var numberCode=e.which;[48,49,50,51,52,53,54,55,56,57].indexOf(numberCode)<0&&preventEvent(e)}function preventEvent(e){e.preventDefault()}this.deleteCrud=function(widget){var deferred=ZHPromise.defer();return MessageService.confirmMessageByCode("lib#GEN_DELETE_REG").then(function(success){widget.removeRow().then(function(){ScreenService.closeSwipe().then(function(){widget.activate(),deferred.resolve()})},function(error){error.data&&-1!==error.data.error.indexOf("ORA-02292")?MessageService.showMessageByCode("lib#GEN_DELETE_BLOCK",null,{type:"ERROR"}):ScreenService.showMessage(error.data.error),deferred.reject()})}),deferred.promise},this.deleteCrudCheckedRows=function(widget){var deferred=ZHPromise.defer();return MessageService.confirmMessageByCode("lib#GEN_DELETE_REG").then(function(success){widget.removeCheckedRows().then(function(){widget.reload(),widget.unSelectAll(),deferred.resolve()},function(error){error.data&&-1!==error.data.error.indexOf("ORA-02292")?MessageService.showMessageByCode("lib#GEN_DELETE_BLOCK",null,{type:"ERROR"}):ScreenService.showMessage(error.data.error),deferred.reject()})}),deferred.promise},this.justInteger=function(selector,retryCount){if((!retryCount||5<retryCount)&&(retryCount=5),!selector)throw{message:"Selector is not defined!"};setTimeout(function(){var elem=$(selector);if(elem[0])for(var length=selector.split(",").length,i=0;i<length;i++)elem.hasOwnProperty(i)&&(elem[i].onkeypress=avoidNonInteger,elem[i].onpaste=preventEvent);else retryCount?(retryCount--,this.justInteger(selector,retryCount)):console.error("Selector not found!")}.bind(this),500)},this.getCurrentDate=function(format){return moment().format(format)},this.setDateAttrToVarcharOnCurrentRow=function(currentRow,attrName){this.setAttrOnCurrentRow(currentRow,attrName,currentRow[attrName].replace(":",""))},this.setAttrOnCurrentRow=function(currentRow,attrName,value){currentRow[attrName]=value},this.setFloatAttrOnCurrentRow=function(currentRow,attrName){this.setAttrOnCurrentRow(currentRow,attrName,this.valueToFloat(currentRow[attrName]))},this.valueToFloat=function(value){return"string"!=typeof value||Util.isEmptyOrBlank(value)?value:-1==value.indexOf(",")&&-1==value.indexOf(".")?parseFloat(value):value.indexOf(",")>value.indexOf(".")?parseFloat(value.replace(/\./g,"").replace(/\,/g,".")):value.indexOf(",")<value.indexOf(".")?parseFloat(value.replace(/\,/g,"")):void 0},this.toLocalDate=function(element,viewValue,params,callBack){element.val(viewValue||""),params.callback=callBack,$.currency.setMask(params,element)},this.toLocalDateFormat=function(value,params){return value=value&&moment(value,params.format).format(params.toFormat)},maskEngine.registerMask("dateFormat",this.toLocalDate,this.toLocalDateFormat);maskEngine.registerMask("CPFCNPJ",function(element,viewValue,params,callBack){},function(value,params){var length;if(value)return 11===(length=value.length)?value=value.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/,"$1.$2.$3-$4"):14===length&&(value=value.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/,"$1.$2.$3/$4-$5")),value}),this.setVisibilityByProjectID=function(widgets){1<widgets.length&&widgets.forEach(function(childWidget){parent.setVisibilityByProjectID(childWidget.widgets),childWidget.projects&&childWidget.projects.forEach(function(proj){childWidget.isVisible=proj.projectID==templateManager.project.id||"allProjects"==proj.projectID})})},this.validateFilterPopup=function(args){args.owner.hasOwnProperty("__filterPopup")&&!args.owner.__filterPopup.isValid()&&args.e.preventDefault()};var timeFormats={hh:isValidHour,mm:isValidMinutesOrSeconds,ss:isValidMinutesOrSeconds,"hh:mm":function(hourAndMinute){if(hourAndMinute)return isValidHour((hourAndMinute=hourAndMinute.split(":"))[0])&&isValidMinutesOrSeconds(hourAndMinute[1]);return!0},"mm:ss":function(minutesAndSeconds){if(minutesAndSeconds)return isValidMinutesOrSeconds((minutesAndSeconds=minutesAndSeconds.split(":"))[0])&&isValidMinutesOrSeconds(minutesAndSeconds[1]);return!0},"hh:mm:ss":function(time){if(time)return isValidHour((time=time.split(":"))[0])&&isValidMinutesOrSeconds(time[1])&&isValidMinutesOrSeconds(time[2]);return!0}};function isValidHour(hour){return!(23<parseInt(hour)||parseInt(hour)<0)}function isValidMinutesOrSeconds(minuteOrSecond){return!(59<parseInt(minuteOrSecond)||parseInt(minuteOrSecond)<0)}function validCNPJ(CNPJ){if(null==CNPJ)return!1;if(14!=(CNPJ=CNPJ.toString().replace(/[\D]+/g,"")).length)return!1;if("00000000000000"==CNPJ||"11111111111111"==CNPJ||"22222222222222"==CNPJ||"33333333333333"==CNPJ||"44444444444444"==CNPJ||"55555555555555"==CNPJ||"66666666666666"==CNPJ||"77777777777777"==CNPJ||"88888888888888"==CNPJ||"99999999999999"==CNPJ)return!1;for(var tamanho=CNPJ.length-2,numeros=CNPJ.substring(0,tamanho),digitos=CNPJ.substring(tamanho),soma=0,pos=tamanho-7,i=tamanho;1<=i;i--)soma+=numeros.charAt(tamanho-i)*pos--,pos<2&&(pos=9);if((soma%11<2?0:11-soma%11)!=digitos.charAt(0))return!1;for(numeros=CNPJ.substring(0,tamanho+=1),soma=0,pos=tamanho-7,i=tamanho;1<=i;i--)soma+=numeros.charAt(tamanho-i)*pos--,pos<2&&(pos=9);return(soma%11<2?0:11-soma%11)==digitos.charAt(1)}function validCPF(CPF){if(null==CPF)return!1;if(11!=(CPF=CPF.toString().replace(/[\D]+/g,"")).length)return!1;if("00000000000"==CPF||"11111111111"==CPF||"22222222222"==CPF||"33333333333"==CPF||"44444444444"==CPF||"55555555555"==CPF||"66666666666"==CPF||"77777777777"==CPF||"88888888888"==CPF||"99999999999"==CPF)return!1;for(var resto,soma=0,i=1;i<=9;i++)soma+=parseInt(CPF.substring(i-1,i))*(11-i);if((resto=10!=(resto=10*soma%11)&&11!=resto?resto:0)!=parseInt(CPF.substring(9,10)))return!1;for(soma=0,i=1;i<=10;i++)soma+=parseInt(CPF.substring(i-1,i))*(12-i);return(resto=10!=(resto=10*soma%11)&&11!=resto?resto:0)==parseInt(CPF.substring(10,11))}this.registerTimeFormat=function(format,formatFunction){if("string"!=typeof format)throw"time format must be an string";if(timeFormats.hasOwnProperty(format.toLowerCase()))throw"time format already registered";timeFormats[format]=formatFunction},ValidationEngine.registerValidation("isValidTime",function(value,format){if(!format)throw"format is not defined";if("string"==typeof format&&timeFormats.hasOwnProperty(format.toLowerCase()))return{valid:(0,timeFormats[format.toLowerCase()])(value),message:ScreenService.i18n("Não é um tempo válido.")};throw"time format is not registered"}),this.fill=function(value,length,toRight,filler){if(value)if(value=value.toString(),filler=filler?filler.toString()[0]:"0",toRight)for(;value.length+filler.length<=length;)value+=filler;else for(;value.length+filler.length<=length;)value=filler+value;return value},this.validateCNPJ=validCNPJ,this.validateCPF=validCPF,this.inscricaoFormat=function(inscricao,force){if(null==inscricao||""===inscricao)return{parameter:"",value:"",tipo:{cod:null,desc:null},valid:!1};null==force&&(force=!1);var obj={tipo:{}};return(inscricao=inscricao.toString().replace(/[\D]+/g,"")).length<=5?(obj.tipo.cod="O",obj.tipo.desc="Código Genérico",obj.valid=!0,obj.value=this.fill(inscricao,5)):(11==inscricao.length?(obj.tipo.cod="F",obj.tipo.desc="Pessoa Física",obj.valid=this.validateCPF(inscricao),obj.value=inscricao.substr(0,3)+"."+inscricao.substr(3,3)+"."+inscricao.substr(6,3)+"-"+inscricao.substr(9,2)):14==inscricao.length?(obj.tipo.cod="J",obj.tipo.desc="Pessoa Jurídica",obj.valid=this.validateCNPJ(inscricao),obj.value=inscricao.substr(0,2)+"."+inscricao.substr(2,3)+"."+inscricao.substr(5,3)+"/"+inscricao.substr(8,4)+"-"+inscricao.substr(12,2)):force=!0,force&&!0!==obj.valid&&(obj.tipo.cod="I",obj.tipo.desc="Inscrição Internacional",inscricao.length<=20?(obj.valid=!0,obj.value=this.fill(inscricao,20)):(obj.valid=!1,obj.value=inscricao.substr(0,20)))),obj.parameter=inscricao,obj};ValidationEngine.registerValidation("CPF",function(value,validationAttrs){return{valid:validCPF(value),message:ScreenService.i18n("CPF Inválido")}});ValidationEngine.registerValidation("CNPJ",function(value,validationAttrs){return{valid:validCNPJ(value),message:ScreenService.i18n("CNPJ Inválido")}}),this.callRestEngine=function(dataSource,requestType,requestValue,disableLoader){var defer=ZHPromise.defer(),params={};switch(requestType){case"Row":params={requestType:"Row",row:requestValue,disableLoader:disableLoader};break;case"DataSet":params={requestType:"DataSet",dataset:requestValue,disableLoader:disableLoader};break;case"FilterData":params={requestType:"FilterData",filter:requestValue,disableLoader:disableLoader};break;default:return defer.reject("Erro na passagem de parâmetros para a requisição. O valor para requestType deve ser 'Row', 'DataSet' ou 'FilterData'.")}return restEngine.request(dataSource,params)},this.changeWidgetAcessibility=function(widgets,enabled){widgets.forEach(function(widget){widget.enabled=enabled}),templateManager.updateTemplate()},this.formWidgetSwitchTemplate=function(widget){return("widget/form.html"==widget.template||"widget/form-view.html"==widget.template)&&(widget.templateToForm||(widget.templateToForm="widget/form.html"),widget.templateToView||(widget.templateToView="widget/form-view.html"),widget.template==widget.templateToForm?widget.template=widget.templateToView:widget.template==widget.templateToView&&(widget.template=widget.templateToForm),templateManager.updateTemplate(),!0)},this.widgetEdit=function(widget){var widgetsToDeactivate;return!widget.editing&&(this.formWidgetSwitchTemplate(widget)&&widget.parent?(widgetsToDeactivate=widget.parent.widgets,this.changeWidgetAcessibility(widgetsToDeactivate.filter(function(subwidget){return subwidget.name!=widget.name}).concat(widget.parent),!1)):this.changeWidgetAcessibility(widget.widgets,!1),widget.backupRow=Util.clone(widget.currentRow,["__rightActions","__leftActions","_children","_parent","__groupHeaders","__index","__isSelected","__notSelectable","$$hashKey"]),widget.edit(),!0)},this.widgetCancelForm=function(widget){var widgets;this.formWidgetSwitchTemplate(widget)&&widget.parent?(widgets=widget.parent.widgets,this.changeWidgetAcessibility(widgets.concat(widget.parent),!0)):this.changeWidgetAcessibility(widget.widgets,!0),widget.currentRow.__is_new?(-1!==widget.dataSource.data.indexOf(widget.currentRow)&&widget.dataSource.data.pop(),widget.list(),ScreenService.closeSwipe()):(Object.keys(widget.backupRow).forEach(function(key){widget.currentRow[key]=widget.backupRow[key]}),widget.view())},this.widgetGoBackToList=function(widget){ScreenService.closeSwipe(),widget.list()},this.widgetGoBackToParent=function(widget){ScreenService.closeSwipe().then(function(){widget.parent.list(),widget.parent.activate()})},this.widgetNewRow=function(widget){this.changeWidgetAcessibility(widget.widgets,!1),widget.newRow()},this.widgetSave=function(widget){var deferred=ZHPromise.defer();return widget.isValid()?(widget.currentRow.changed=!0,widget.currentRow.__is_new?widget.paramsNewCode&&widget.paramsNewCode.__is_new_code&&(widget.currentRow.__using_unit=widget.paramsNewCode.__using_unit||!1,widget.currentRow.__new_code_pk=widget.paramsNewCode.__new_code_pk,widget.currentRow.__table_pk=widget.paramsNewCode.__table_pk,widget.currentRow.__new_code_interval=widget.paramsNewCode.__new_code_interval||1,widget.currentRow.__new_code_length=widget.paramsNewCode.__new_code_length||5,widget.currentRow.__new_code_column_size=widget.paramsNewCode.__new_code_column_size||10,widget.currentRow.__cast_number=widget.paramsNewCode.__cast_number||!1,!widget.currentRow.__columns_to_return)&&widget.paramsNewCode&&widget.paramsNewCode.__columns_to_return&&(widget.currentRow.__columns_to_return=widget.paramsNewCode.__columns_to_return):widget.currentRow.__is_new=!1,widget.saveRow().then(function(response){var widgets;widget.currentRow.changed=!1,delete widget.backupRow,this.formWidgetSwitchTemplate(widget)&&widget.parent?(widget.view(),widgets=widget.parent.widgets,this.changeWidgetAcessibility(widgets.concat(widget.parent),!0)):(widget.currentRow.__is_new?(ScreenService.closeSwipe(),widget.list()):widget.view(),this.changeWidgetAcessibility(widget.widgets,!0)),widget.currentRow.__is_new?widget.currentRow.__is_new=!1:widget.reload(),deferred.resolve(response)}.bind(this),function(error){var errorMessage="Timeout";error.data&&(errorMessage=error.data.error),ScreenService.showMessage(errorMessage),deferred.reject(errorMessage)})):deferred.reject("Preencha todos os campos corretamente!"),deferred};var messagesWidget={id:0,name:"messagesWidget",label:"Mensagens",messagesDataset:"",template:"widget/form.html",floatingControl:{customizationAction:{filter:!(this.checkParentContainer=function(containerProperties){(containers=templateManager.containers).hasOwnProperty(containerProperties.parentContainerName)||(angular.isFunction(containerProperties.callback)?containerProperties.callback.apply(containerProperties.scope,containerProperties.params):ScreenService.openWindow(containerProperties.parentContainerName))}),view:!1,layout:!1}},container:{},isVisible:!0,popupNoBlock:!1,fields:[],actions:[],events:[]},messagesFields=[{label:"",name:"CONTENT",readOnly:!0,template:"field/textarea.html",textRows:14,isVisible:!0,class:12,descriptionOrder:!0,showOnView:!0,showOnForm:!0,showOnList:!0}],messagesActions=[{name:"cancelar",label:"Cancelar",idVisible:!0,hideIcon:!0,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"exportar",label:"Exportar",idVisible:!0,icon:"export",showAsAction:"always",events:[{name:"ActionEvent",code:"General.generateFileByDataSet(args.owner.widget.messagesDataset);"}]}];function avoidNonDigits(e){var digitCode=e.which;[44,45,46,48,49,50,51,52,53,54,55,56,57].indexOf(digitCode)<0&&preventEvent(e)}this.showErrorMessages=function(widget,dataset,popupName){messagesWidget.container=widget.container,messagesWidget.fields=messagesFields,messagesWidget.actions=messagesActions;var widget=metaDataFactory.widgetFactory(messagesWidget),content="";void 0!==popupName&&(widget.label=popupName),(widget.messagesDataset=dataset).forEach(function(message){content+=message+"\n"}),widget.getField("CONTENT").setValue(content),ScreenService.openPopup(widget)},this.generateFileByDataSet=function(dataset,fileProperties){var content="",name="content",fileProperties=(void 0!==fileProperties&&void 0!==fileProperties.fileName&&(name=fileProperties.fileName),dataset.forEach(function(line){content+=line+"\r\n"}),document.createElement("a"));fileProperties.setAttribute("href","data:text/plain;charset=utf-8,"+encodeURIComponent(content)),fileProperties.setAttribute("download",name),fileProperties.style.display="none",document.body.appendChild(fileProperties),fileProperties.click(),document.body.removeChild(fileProperties)},this.isWidgetFiltered=function(widget){var isFiltered=!0,currentFilter=widget.hasOwnProperty("__filterPopup")?widget.__filterPopup.currentFilter:widget.appliedFilter.FILTER_ROW;return isFiltered=widget.fields.filter(function(field){return(field=>field.filterProperties&&field.filterProperties.validations&&field.filterProperties.validations.required)(field)||(field=>field.isVisible&&field.validations&&field.validations.required&&!field.filterProperties)(field)}).length&&Array.isArray(currentFilter)?!1:isFiltered},this.newRow=function(widget){this.isWidgetFiltered(widget)?widget.newRow():MessageService.showMessageByCode("lib#GEN_NOT_FILTER",null,{type:"ERROR"})},this.saveWithParent=function(widget,parents){if(Array.isArray(parents))return parents.forEach(function(parent){widget.currentRow[parent]=widget.parent.currentRow[parent]}),this.widgetSave(widget);throw"'Parents' property should be an array, "+typeof parents+" given."},this.justDigits=function(selector,retryCount){if((!retryCount||5<retryCount)&&(retryCount=5),!selector)throw{message:"Selector is not defined!"};setTimeout(function(){var elem=$(selector);if(elem[0])for(var length=selector.split(",").length,i=0;i<length;i++)elem.hasOwnProperty(i)&&(elem[i].onkeypress=avoidNonDigits,elem[i].onpaste=preventEvent);else retryCount?(retryCount--,this.justDigits(selector,retryCount)):console.error("Selector not found!")}.bind(this),500)},this.callMaskCurrency=function(field,decimal,thousands,precision){precision=precision||2;var value=field.value();field.value(this.maskCurrency(value,{decimal:decimal,thousands:thousands,precision:precision}))};var ValidationEngine=function(element,viewValue,params,callBack){},numberFormatBr=(this.maskCurrency=function(value,params){var thousands=Util.isEmptyOrBlank(params.thousands)?params.thousand:params.thousands;if(!Util.isEmptyOrBlank(value)){"."!==value[0]&&","!==value[0]||(value="0"+value);for(var dec=(value=(value=","===params.decimal?numberFormatBr(value):value).split(".").join("")).split(",")[1],mil=[],int=value.split(",")[0],counter=(void 0===dec?(dec=(dec="").padEnd(params.precision,"0"),int=value):dec.length<params.precision?dec=dec.padEnd(params.precision,"0"):dec.length>params.precision&&(dec=parseFloat("1."+dec).toFixed(params.precision).toString().split(".")[1]),angular.copy(int.length/3)),i=1;i<=counter;i++)i!=counter?mil.push(thousands+int.substr(-3)):mil.push(int.substr(-3)),int=int.substr(0,int.length-3);""!=int&&mil.push(int);value=(mil=mil.reverse().join(""))+params.decimal+dec,dec="^(^([0-9]{1,3}\\"+thousands+")((\\d{3}\\"+thousands+"{1})|(\\d{3}\\"+params.decimal+"\\d{2,}))*$)|^(\\d{0,3}\\"+params.decimal+"\\d{2,})*$";return(dec=new RegExp(dec,"g")).test(value)?value:0}},maskEngine.registerMask("maskCurrency",ValidationEngine,this.maskCurrency),this.parseFloat=function(value){if(/^(.*)(\.+).*(,+)(.*)$/gm.test(value))for(var loop=value.toString().split("."),i=0;i<loop.length-1;i++)value=value.toString().replace(".","");return/\,/g.test(value)&&(value=value.toString().replace(",",".")),parseFloat(value)},function(value){if(/^(.*)(\,+).*(\.+)(.*)$/gm.test(value))for(var loop=value.toString().split(","),i=0;i<loop.length-1;i++)value=value.toString().replace(",","");return/^\d{1,}\.{1}\d*$/g.test(value)?value=value.toString().replace(".",","):/^(\d*)([\.]*)((\d|\.)*)$/.test(value)&&((value=value.split("."))[value.length-1]=","+value[value.length-1],value=value.join("")),value.toString()});this.lengthCurrency=function(args,field){fieldValue=!field.inlineEditable||"list"!==field.widget.mode&&"inline_edit"!==field.widget.mode?field.value():field.widget.currentRow[field.name+"_inline"];var fieldValue=Util.isEmptyOrBlank(fieldValue)?"":fieldValue.toString();fieldValue.split("-").join("").split(".").join("").split(",")[0].length>=field.maxLengthCurrency&&!/^(\d+)(\,){1}(\d*)$/gm.test(fieldValue)&&([8,37,38,39,40,46,110,188,190,194].includes(args.e.keyCode)||args.e.preventDefault())};this.getCleanError=function(msg){return msg.match(/AUTH_[^\s]+/g)[0]},this.initRoutesListener=function(Authenticator){var open;open=XMLHttpRequest.prototype.open,XMLHttpRequest.prototype.open=function(method,url,async,user,pass){this.addEventListener("readystatechange",function(){try{((response,Authenticator)=>{var url=response.responseURL,responseURL=null,response=response.response;(responseURL=-1<url.indexOf("index.php/")?url.slice(url.indexOf("index.php/")+9):responseURL)&&(response=(url=JSON.parse(response)).error,Authenticator?Authenticator.run(responseURL,url,response):response&&-1<response.indexOf("AUTH_")&&(Authenticator=parent.getCleanError(response),MessageService.showMessageByCode(Authenticator)))})(this,Authenticator)}catch(e){return!1}},!1),open.call(this,method,url,async,user,pass)}},this.isValidFiliaisValuesCP=function(values){var arrValues,arrFilialValida=getLocalVar("CPFILIALVALIDA");if(arrFilialValida&&cacheLoaded)return arrValues=[],Array.isArray(values)?arrValues=values:arrValues.push(values),!arrValues.some(function(value){return!arrFilialValida.includes(value)}.bind(this));this.callRestEngine("lib#/lib_getValidOrganizationAndBranches","FilterData",[]).then(function(result){var arrayToPush;cacheLoaded=!0,result.dataset&&(arrayToPush=[],result.dataset.validBranches.forEach(function(row){arrayToPush.push(row.FILIAL)}.bind(this)),setLocalVar("CPFILIALVALIDA",arrayToPush),this.isValidFiliaisValuesCP(values))}.bind(this))},this.validateFieldFiliaisCP=function(field){var arrValues,invalids,filialValues,arrFilialValida=getLocalVar("CPFILIALVALIDA");if(arrFilialValida&&cacheLoaded)if("CDFILIAL"==field.name)field.value();else{if(!field.outData.CDFILIAL)return console.log("Não existe o campo CDFILIAL neste FIELD, usar a função validateFieldFiliaisCP(field)");(filialValues=field.widget.currentRow[field.outData.CDFILIAL])&&0<filialValues.length&&(arrValues=[],Array.isArray(filialValues)?arrValues=filialValues:arrValues.push(filialValues),filialValues=arrValues.filter(function(filial){return arrFilialValida.includes(filial)}.bind(this)),invalids=arrValues.filter(function(filial){return!arrFilialValida.includes(filial)}.bind(this)),0!=filialValues.length&&this.isValidFiliaisValuesCP(arrValues)||(MessageService.showMessageByCode("lib#CP_BRANCH_NOT_ALLOWED",null,{type:"ERROR"}),this.callRestEngine("lib#/lib_saveOrgFilial","DataSet",[{CDFILIAL:invalids}])))}else this.callRestEngine("lib#/lib_getValidOrganizationAndBranches","FilterData",[]).then(function(result){var arrayToPush;cacheLoaded=!0,result.dataset&&(arrayToPush=[],result.dataset.validBranches.forEach(function(row){arrayToPush.push(row.FILIAL)}.bind(this)),setLocalVar("CPFILIALVALIDA",arrayToPush),this.validateFieldFiliaisCP(field))}.bind(this))},this.setCurrentRowWithOutData=function(currentRow,valuesToSetOnCurrentRow,outDataValue){for(var key in outDataValue){var newArray;Array.isArray(outDataValue[key])?(newArray=[],outDataValue[key].forEach(function(value){newArray[value]=value}.bind(this)),this.setCurrentRowWithOutData(currentRow,valuesToSetOnCurrentRow,newArray)):currentRow[outDataValue[key]]=valuesToSetOnCurrentRow[key]}}});function LogDecorator(ZhuLogHelper){function updateWidgetFields(widget){var routeField=ZhuLogHelper.getField(widget,"ROUTE"),userNameField=Util.clone(routeField),routeField=Util.clone(routeField);userNameField.name="USER_NAME",userNameField.label="User Name",routeField.name="ROUTE_LABEL",routeField.label="Action",ZhuLogHelper.moveField(widget,"USER_ID",1),ZhuLogHelper.addField(widget,userNameField,2),ZhuLogHelper.moveField(widget,"TIMESTAMP",3),ZhuLogHelper.moveField(widget,"CONTAINER_NAME",4),ZhuLogHelper.moveField(widget,"WIDGET_NAME",5),ZhuLogHelper.moveField(widget,"ROUTE",6),ZhuLogHelper.addField(widget,routeField,7),ZhuLogHelper.editField(widget,"ROUTE_LABEL",{valueField:"ROUTE",descriptionField:"ROUTE_LABEL",template:"field/select-native.html",dataSource:{data:window.routesTranslate||[]},filterProperties:{template:"field/select-multiple.html",operator:"IN"},showOnList:!0,maxWidth:"12%",class:3}),ZhuLogHelper.editField(widget,"USER_ID",{showOnList:!0,maxWidth:"10%",class:4}),ZhuLogHelper.editField(widget,"USER_NAME",{showOnList:!0,maxWidth:"15%",class:4}),ZhuLogHelper.editField(widget,"CONTAINER_NAME",{showOnList:!0,maxWidth:"15%",class:3}),ZhuLogHelper.editField(widget,"WIDGET_NAME",{showOnList:!0,maxWidth:"15%",class:3}),ZhuLogHelper.editField(widget,"TIMESTAMP",{showOnList:!0,maxWidth:"10%",class:4}),ZhuLogHelper.editField(widget,"ROUTE",{showOnList:!0,maxWidth:"15%",class:3}),ZhuLogHelper.editField(widget,"TYPE",{showOnList:!0,maxWidth:"8%",class:3}),ZhuLogHelper.removeField(widget,"PRODUCT_ID"),ZhuLogHelper.removeField(widget,"ORGANIZATION_ID")}var filterFieldsInAdvancedFieldGroup=["REQ_ID","TYPE","HTTP_RESPONSE_CODE","CONTENT"],fieldsNotUpdateTemplate=["ROUTE_LABEL"];this.decorateWidget=function(gridWidget){updateWidgetFields(gridWidget),(gridWidget=>{gridWidget.fields.forEach(function(field){field.name&&-1==filterFieldsInAdvancedFieldGroup.indexOf(field.name)&&(field.fieldGroup=null),field.filterProperties&&(-1==fieldsNotUpdateTemplate.indexOf(field.name)&&(field.template=field.filterProperties.template),"field/text-edit.html"==field.filterProperties.template)&&(field.filterProperties.operator="LIKE")}),ZhuLogHelper.editField(gridWidget,"TIMESTAMP",{template:"field/datetime.html",dateFormat:"DD/MM/YYYY",timeFormat:"HH:mm:ss",displayFormat:"DD/MM/YYYY HH:mm:ss","datetime-dateFormat":"dd/mm/yy","datetime-timeFormat":"HH:ii:ss",filterProperties:{isVisible:!0,showOnForm:!0,label:"Date",template:"zh-interval-component#field/interval.html",dateFormat:"DD/MM/YYYY",displayFormat:"DD/MM/YYYY",intervals:[{label:"Última semana",period:"last-week"},{label:"Último mês",period:"last-month"}]}}),ZhuLogHelper.editField(gridWidget,"TYPE",{class:4}),ZhuLogHelper.editField(gridWidget,"HTTP_RESPONSE_CODE",{class:4,isVisible:!1,filterProperties:{isVisible:!0,operator:"LIKE"}}),ZhuLogHelper.editField(gridWidget,"REQ_ID",{class:4,isVisible:!1,filterProperties:{isVisible:!0,operator:"LIKE"}}),ZhuLogHelper.editField(gridWidget,"CONTENT",{isVisible:!1,fieldGroup:"advancedFilter",template:"field/text-edit.html",filterProperties:{isVisible:!0,operator:"LIKE",class:12}})})(gridWidget);var formWidget=gridWidget.widgets[0].widgets[0];updateWidgetFields(formWidget),(formWidget=>{ZhuLogHelper.editField(formWidget,"HTTP_RESPONSE_CODE",{class:2}),ZhuLogHelper.editField(formWidget,"REQUEST_TYPE",{class:3})})(formWidget),gridWidget.currentRowDefaultFilter={TIMESTAMP:{start:moment().add(-1,"days").format("DD/MM/YYYY"),end:moment().format("DD/MM/YYYY"),period:void 0}}},this.normalizeRows=function(rows){return rows},this.normalizeFilters=function(filters){}}Configuration(function(ContextRegister){ContextRegister.register("General",General)}),Configuration(function(ContextRegister){ContextRegister.register("LogDecorator",LogDecorator)});var MenuBuilder=function(restEngine,MessageService,templateManager,metaDataFactory,eventAggregator,$window,requestDataSourceEngine,ApplicationContext,ScreenService){function prepareMenus(response){var groupMenus=response.dataset.menu;window.routesTranslate=response.dataset.routesTranslate;(response=!!templateManager.container&&templateManager.container.getWidget("zhuLog"))&&(response.getField("ROUTE_LABEL").dataSource.data=window.routesTranslate,$(window).trigger("resize.grid")),groupMenus=orderMenus((groupMenus=>groupMenus.filter(function(group){return group.menus&&0!=group.menus.length||"zhHistory"==group.name}))(groupMenus));var response=[templateManager.project.getMenu("zhHistory")],aux=(templateManager.project.groupMenu=metaDataFactory.groupMenuFactory(groupMenus.concat(response)),{});Object.keys(templateManager.aclRules).forEach(function(ruleKey){aux[ruleKey]=templateManager.aclRules[ruleKey]}),templateManager.aclRules=aux,eventAggregator.publish("menuBuilded"),localStorage.getItem("IS_LOGGED")||(MessageService.successNotificationByCode("lib#SUC_AUTHENTICATION"),setTimeout(function(){JSON.parse(localStorage.getItem("IS_SUPPORT_OPERATOR"))?localStorage.setItem("IS_LOGGED",!0):templateManager.project.groupMenu.find(function(menu){return"zhHistory"!=menu.name&&(menu.aclIsVisible,!0===menu.aclIsVisible)})?(saveLoginData(),localStorage.setItem("IS_LOGGED",!0)):MessageService.showCustomDialogByCode("lib#EMPTY_ACCESS_RULE_LIB",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){ApplicationContext.LibLoginController.logout()}}]})},1500))}function setLocalProductMenu(){var modulesPackage;$window.modulesPackage||(modulesPackage=$window.modulesPackage||"modules",restEngine.requestMetaData(modulesPackage+"#json/containers.json").then(function(response){response=response.data;return response[Object.keys(response)[0]]}).then(function(productMenu){localProductMenu=productMenu}))}var localProductMenu,attrToReplace=["label","showMenu","showHeader","showDescriptionOrder","onRequestIdleTimeout","mainWindow","logLevel","aclEnable","showMenuSearch","userDataActions","reportServiceUrl","reportsPath","inDeveloperMode","showDevtoolsInSameWindow","shouldBackToMainWindowOnReload","shortcutKeys"],orderMenus=function(menus){return menus.map(function(menu){return menu.menus&&(menu.menus=orderMenus(menu.menus)),menu}),sortMenus(menus)},sortMenus=function(menus){return menus.sort(function(menuA,menuB){if(menuA.order&&menuB.order){if(menuA.order<menuB.order)return-1;if(menuB.order<menuA.order)return 1}return!menuA.order&&menuB.order?-1:menuA.order&&menuB.order?1:0})},saveLoginData=(window.notUseMicroservice||(eventAggregator.subscribe("loginSuccess",function(loginResponse){JSON.parse(localStorage.getItem("IS_LOGGED"))||ApplicationContext.LibUtilities.menuFavoritos(!0),eventAggregator.publish("AboutOnClick"),$window.modulesPackage||$window.keepTitle||(productMenu=localProductMenu,attrToReplace.forEach(function(attr){templateManager.project[attr]=productMenu[attr]}),templateManager.updateTitle(templateManager.project.label));var productMenu,loginResponse=[{name:"CONCATENATE_GROUP_MENU",operator:"=",value:!0},{name:"VISIBLE_ELEMENTS",operator:"=",value:loginResponse.VISIBLE_ELEMENTS||[]},{name:"EXPIRED_ELEMENTS",operator:"=",value:loginResponse.EXPIRED_ELEMENTS||[]},{name:"URL_ORIGIN",operator:"=",value:window.location.origin},{name:"CURRENT_MODULE",operator:"=",value:loginResponse=(loginResponse=window.location.hash.split("/").filter(function(_){return _.length}).pop())&&0<loginResponse.length?loginResponse.split(/_|#/)[0]:loginResponse},{name:"CURRENT_LANGUAGE",operator:"=",value:window.lang}];requestDataSourceEngine.getDataSource("lib#/lib_buildMenu",loginResponse).then(prepareMenus).catch(ApplicationContext.LibUtilities.showErrorMessage)}),setLocalProductMenu()),function(){ApplicationContext.LibUtilities.saveCollectedData(localStorage.getItem("LOGIN_USER_ID"),"LOGIN"),ApplicationContext.LibUtilities.saveCollectedData(localStorage.getItem("LOGIN_PHP_VERSION_ID"),"PHPVERSION"),ApplicationContext.LibLoginService.setLogAccess();var licenseInfo=localStorage.getItem("LICENSE_INFO");licenseInfo&&(ApplicationContext.LibLoginService.saveProductsPermission(licenseInfo),ApplicationContext.LibLoginService.saveVariableMeasure(licenseInfo))})};function LibMessages(){this.ALE_EXPIRED_SESSION="Sua sessão expirou.<br/>Você será redirecionado para efetuar login novamente.",this.ALE_MIGRATION_IS_PENDENT="ATENÇÃO!<br/><br/>Esse produto foi atualizado recentemente, com necessidade de alterações na estrutura do banco de dados, sem que essas alterações tenham sido aplicadas.<br/>A utilização do produto nessa situação poderá acarretar erros.<br/><br/>Solicite ao administrador do sistema a regularização da alteração na estrutura do bando de dados.",this.ERR_ATTEMPT_END="Tentativas esgotadas. Redirecionando...",this.ERR_ATTEMPT_PARTIAL="Senha incorreta.<br/>Tentativa %1/3",this.ERR_EXPIRED_SESSION_LOGIN="Sessão expirada. Redirecionando..."}function ReportDecorator(eventAggregator,restEngine,templateManager,ZhLogger,ScreenService,eventEngine){function buildData(containerName,fieldToChangeData){var route=(()=>{var fileName=templateManager.container.fileName;if((fileName=fileName.split("#").shift().split("_")).length){fileName=fileName.shift();if(fileName)return fileName}return"lib"})()+"#/lib_getDataReportField";restEngine.post(route,{requestType:"Row",row:[containerName.substr(0,6)]}).then(function(callback){try{var data=callback.dataset.dataReport,formattedData=((data=>{var message,errorIndex=data.findIndex(function(reportElement){return Array.isArray(reportElement)});if(-1!==errorIndex){if(1===data.length)throw message=ScreenService.i18n("Ocorreu um erro ao buscar a lista de relatórios da tela."),ScreenService.errorNotification(message),message+ScreenService.i18n("Consulte a requisição correspondente para mais detalhes.");message=-1===data[errorIndex].findIndex(function(error){return error===ScreenService.i18n("Servidor de relatórios QR2 não está parametrizado.")}),data=-1===data[errorIndex].findIndex(function(error){return error===ScreenService.i18n("Servidor de relatórios BIRT não está parametrizado.")}),(message||data)&&ScreenService.errorNotification(ScreenService.i18n("Alguns relatórios podem não estar disponíveis.")),ZhLogger.warning(ScreenService.i18n("Alguns relatórios podem não estar disponíveis. Consulte a requisição correspondente para mais detalhes."))}})(data),((fieldToChangeData,data)=>data.filter(function(reportElement){return!Array.isArray(reportElement)}).map(function(reportElement){var newElement;if(!Array.isArray(reportElement))return(newElement={})[fieldToChangeData.valueField]=reportElement.value,newElement[fieldToChangeData.descriptionField]=reportElement.description,newElement[fieldToChangeData.strategyField]=reportElement.strategy,newElement}))(fieldToChangeData,data));formattedData.forEach(function(row){row.description=ScreenService.i18n(row.description)}),((fieldToChangeData,data)=>{if(fieldToChangeData.dataSource.data&&0!=fieldToChangeData.dataSource.data.length){let valueField=fieldToChangeData.valueField,descriptionField=fieldToChangeData.descriptionField,strategyField=fieldToChangeData.strategyField;var removingDuplicatedReports=function(report,index,reports){return index===reports.findIndex(function(r){return r[valueField]===report[valueField]&&r[descriptionField]===report[descriptionField]&&r[strategyField]===report[strategyField]})},newData=fieldToChangeData.dataSource.data.concat(data);fieldToChangeData.dataSource.data=newData.filter(removingDuplicatedReports)}else fieldToChangeData.dataSource.data=data})(fieldToChangeData,formattedData),applyDefaultValue(fieldToChangeData),setTimeout(function(){clickOnSelectedOption(fieldToChangeData.name)},500),addEvent({entity:fieldToChangeData.getParent(),event:{name:"WidgetOnEnter",code:"ReportDecorator.onEnterReportWidget('"+fieldToChangeData.name+"')",bind:!0}})}catch(e){ZhLogger.warning(e)}}.bind(this),function(error){throw error.data&&error.data.error?error.data.error:ScreenService.i18n("Ocorreu um erro ao buscar a lista de relátorios da tela.")})}function applyDefaultValue(fieldToChangeData){var firstRow;fieldToChangeData.defaultValue&&"firstRow"!==fieldToChangeData.defaultValue||(firstRow=fieldToChangeData.dataSource.getFirstRow(),fieldToChangeData.defaultValue=firstRow[fieldToChangeData.valueField]),fieldToChangeData.applyDefaultValue()}function clickOnSelectedOption(fieldName){var baseSelector="#"+fieldName+" + div";if(!document.querySelector(baseSelector))return setTimeout(function(){clickOnSelectedOption(fieldName)},500);document.querySelector(baseSelector).click(),document.querySelector(baseSelector+' li[class*="selected"]').click()}function selectWidget(container,widgetName){container=container.getWidget(widgetName);if(container)return container;throw ScreenService.i18n("A widget informada não existe dentro desse container.")}function selectField(widget,fieldName){widget=widget.getField(fieldName);if(widget){if(widget.dataSource)return widget;throw ScreenService.i18n("O field informado não contém a propriedade dataSource.")}throw ScreenService.i18n("O field informado não existe na widget informada.")}function validContainer(container){if(!container)throw ScreenService.i18n("Container não existe.")}function addEvent(params){var entity=params.entity,params=params.event,name=params.name,code=params.code,events=entity.events;((events,searchedName)=>-1!==events.findIndex(function(event){return event.name===searchedName}))(events,name)?((events,searchedCode)=>0<events.filter(function(event){return-1!=event.code.indexOf(searchedCode)}).length)(events,code)||((events,eventName,eventCode,placeOn)=>{placeOn=placeOn||"right";var eventIndex=events.findIndex(function(event){return event.name===eventName}),event=events[eventIndex],endSemicolonIndex=event.code.lastIndexOf(";");-1!==endSemicolonIndex&&endSemicolonIndex===event.code.length-1||(event.code+=";"),"right"===placeOn?events[eventIndex].code+=eventCode:(endSemicolonIndex=eventCode+";"+events[eventIndex].code,events[eventIndex].code=endSemicolonIndex)})(events,name,code,params.placeOn):(events.push({name:name,code:code}),params.bind&&eventEngine.bindEvent(entity,name,code))}function getSelectedOption(fieldName){return document.querySelector("#"+fieldName+' + div li[class*="selected"]')}function beforeOpenReport(params){var params=params.reportParams,reportNameSplitted=params.__report_name.split("."),reportName=reportNameSplitted[0],reportNameSplitted=reportNameSplitted[1];params.__report_name=reportName,params.STRATEGY=reportNameSplitted}this.onContainerOpen=function(){try{var container=templateManager.container;if(validContainer(container),container.customReportsConfig){var customReportsConfig=container.customReportsConfig,config=customReportsConfig;if(!config.widgetName)throw ScreenService.i18n("A propriedade widgetName não existe dentro de customReportsConfig.");if(!config.fieldName)throw ScreenService.i18n("A propriedade fieldName não existe dentro de customReportsConfig.");var widget=selectWidget(container,customReportsConfig.widgetName),containerName=container.customReportsConfig?container.customReportsConfig.reportCodeName:container.name,fieldToChangeData=selectField(widget,customReportsConfig.fieldName);void 0===customReportsConfig.reportIsTheMainFunction||!0===customReportsConfig.reportIsTheMainFunction?buildData(containerName,fieldToChangeData):addEvent({entity:widget,event:{name:"WidgetOnEnterOnce",code:"ReportDecorator.triggerBuildData('"+containerName+"', '"+customReportsConfig.widgetName+"', '"+customReportsConfig.fieldName+"')",bind:!0}}),widget.beforeOpenReport=beforeOpenReport}}catch(e){ZhLogger.warning(e)}},eventAggregator.subscribe("onContainerOpen",this.onContainerOpen),this.triggerBuildData=function(containerName,widgetName,fieldName){var container=templateManager.container,container=(validContainer(container),selectWidget(container,widgetName)),widgetName=selectField(container,fieldName);try{buildData(containerName,widgetName)}catch(e){ZhLogger.warning(e)}},this.onEnterReportWidget=function(fieldName){var field=templateManager.container.getActiveWidget().getField(fieldName);field.value()||applyDefaultValue(field),getSelectedOption(fieldName)||setTimeout(function runClickOnSelectedOption(){return getSelectedOption(fieldName)?(fieldName=>document.querySelector("#"+fieldName+" + div > span").textContent)(fieldName)?void 0:clickOnSelectedOption(fieldName):setTimeout(runClickOnSelectedOption,500)},500)}}function ShortcutDecorator(ApplicationContext,templateManager){let defaultCRUDShortcutKeys={add:"mod+a",edit:"mod+e",delete:"mod+d"};function getShortcutKey(widget,shortcut){return Util.getNestedProperty(widget,["shortcutKeys",shortcut])||Util.getNestedProperty(templateManager,["project","shortcutKeys",shortcut])||defaultCRUDShortcutKeys[shortcut]}function applyShortcutOnAction(widgets){platform=window.navigator.platform,mod=!1,-1!==["Macintosh","MacIntel","MacPPC","Mac68K"].indexOf(platform)?mod="Command + ":-1===["Win32","Win64","Windows","WinCE"].indexOf(platform)&&!/Linux/.test(platform)||(mod="Ctrl + ");var platform,mod,modTooltip=mod;widgets.forEach(function(widget){widget.actions&&widget.actions.forEach(function(action){"plus"!==action.icon||action.skipShortcut||action.shortcutKey?"pencil"!==action.icon||action.skipShortcut||action.shortcutKey?"trash"!==action.icon||action.skipShortcut||action.shortcutKey?action.skipShortcut||action.shortcutKey||(action.shortcutKey=getShortcutKey(widget,action.icon)):action.shortcutKey=getShortcutKey(widget,"delete"):action.shortcutKey=getShortcutKey(widget,"edit"):action.shortcutKey=getShortcutKey(widget,"add"),modTooltip&&action.shortcutKey&&!action.tooltip&&!1!==templateManager.project.showShortcutKeyAsTooltip&&(action.tooltip=action.shortcutKey.toUpperCase().replace("MOD+",modTooltip))}),widget.widgets&&widget.widgets.length&&applyShortcutOnAction(widget.widgets)})}this.apply=function(containerName,container){return 1==templateManager.project.enableCRUDShortcutKeys&&applyShortcutOnAction(container.widgets),container}}function LibUtilities(ScreenService,eventAggregator,templateManager,requestDataSourceEngine,restEngine,MessageService,ZhuAclConfig,General,ZHPromise){function getCurrentModule(){var currentModule=window.location.hash.split("/").filter(function(_){return _.length}).pop();return currentModule=currentModule&&0<currentModule.length?currentModule.split(/_|#/)[0]:currentModule}var self=this,shouldAddRequestInfo=(this.authenticationContainer="login#authentication",this.expiredSessionMethod=null,((href,type)=>{var lnk=document.createElement("link");lnk.setAttribute("rel",type),"stylesheet"==type&&lnk.setAttribute("type","text/css"),lnk.setAttribute("href",href),document.getElementsByTagName("head").item(0).appendChild(lnk)})("bower_components/tek-libraries/css/favorites.min.css","stylesheet"),this.showErrorMessage=function(response){return MessageService.getMessageByCode("lib#UNEXPECTED_ERROR").then(function(defaultMessage){var params,messageCode,error;return response&&response.data&&response.data.error?(error=response.data.error,self.isJson(error)?(params=(error=JSON.parse(error)).PARAMS||null,MessageService.getMessageByCode("lib#"+(messageCode=error.CODE||"UNEXPECTED_ERROR")).then(function(message){return ScreenService.showMessage(message,"ERROR",null,params)}).catch(function(){return ScreenService.showMessage(messageCode,"ERROR",null,params)})):(error=Util.isEmptyOrBlank(error)?defaultMessage:error.split("Exception:").pop()).includes("ALE_SESSION_WILL_BE_ENDED")?void 0:ScreenService.showMessage(error,"ERROR")):ScreenService.showMessage(defaultMessage,"ERROR")})},this.redirectToLogin=function(){(window.openLoginContainerWithoutRedirect?ScreenService:self).openWindow(self.authenticationContainer)},eventAggregator.subscribe("EventOnRequestStart",function(eventData){var token,widget,keepConnected,requestConfig=eventData.requestConfig,container=(requestConfig&&requestConfig.url&&shouldAddRequestInfo(requestConfig.url)&&templateManager.container&&(requestConfig.data.origin=requestConfig.data.origin||{},widget=(container=templateManager.loadingContainerJson)?(widget=getFirstWidgetWithDataSourceRest(container.widgets))||container.widgets[0]:(container=templateManager.container).getActiveWidget(),requestConfig.data.origin.containerLabel=container.label||container.name,requestConfig.data.origin.widgetLabel=widget.label||widget.name),requestConfig.url.split("/").pop());"lib_validateExpiredSession"!=container&&factoryExpiredSessionMethods(),"lib_logout"!=container&&"login"!=container&&(token=localStorage.getItem("LOGIN_TOKEN"),widget=localStorage.getItem("LOGIN_HASH"),keepConnected=localStorage.getItem("LOGIN_KEEP_CONNECTED"),window.externalTokens&&window.externalTokens.some(function(externalToken){return!!eventData.requestConfig.url.includes(externalToken.url)&&(token=externalToken.token,keepConnected=externalToken.keepConnected||keepConnected,!0)}),token&&(requestConfig.headers["OAuth-Token"]=token),widget&&(requestConfig.headers["OAuth-Hash"]=widget,requestConfig.headers["OAuth-Project"]=window.tekLoginProjectId),"validateUser"==container&&(keepConnected="Yes"),requestConfig.headers["OAuth-KeepConnected"]=keepConnected)}),function(url){return!url.match(/.json/i)&&!url.match(/.html/i)&&!url.match(/.svg/i)}),getFirstWidgetWithDataSourceRest=function(widgets){var i=0;if(i<widgets.length)return widgets[i].dataSource&&1==widgets[i].dataSource.rest?widgets[i]:getFirstWidgetWithDataSourceRest(widgets[i])},factoryExpiredSessionMethods=function(){templateManager.project&&templateManager.project.onRequestIdleTimeout&&(self.expiredSessionMethod&&clearTimeout(self.expiredSessionMethod),self.expiredSessionMethod=Util.doAsync(validateExpiredSession,templateManager.project.onRequestIdleTimeout))},validateExpiredSession=function(){var timeout=templateManager.project.onRequestIdleTimeout;requestDataSourceEngine.getDataSource("lib#/lib_validateExpiredSession",[{name:"TIMEOUT",value:timeout,operator:"="}]).then(function(response){var expiredSessionInfo;response&&response.dataset&&response.dataset.expiredSessionInfo?(expiredSessionInfo=response.dataset.expiredSessionInfo).IS_EXPIRED?eventAggregator.publish("LibExpiredSession"):(self.expiredSessionMethod&&clearTimeout(self.expiredSessionMethod),Util.doAsync(validateExpiredSession,expiredSessionInfo.TIMEOUT)):self.showErrorMessage(response)}).catch(self.showErrorMessage)},requestModulesMetadata=(this.changeLoginResponseToOldParams=function(loginResponse){if(loginResponse)return{cdoperador:loginResponse.USER_ID,nmoperador:loginResponse.USER_NAME,dsemailoper:loginResponse.EMAIL,nrorg:loginResponse.ORGANIZATION_ID,nmorg:loginResponse.TRADING_NAME,nmrazsocialorg:loginResponse.COMPANY_NAME,perfilDeAcesso:loginResponse.ACCESS_PROFILE,cdempresa:loginResponse.CDEMPRESA||null,cdfilialselecionada:loginResponse.CDFILIAL||null,cdpictprat:loginResponse.CDPICTPRAT||null,cdpictprod:loginResponse.CDPICTPROD||null,ididioma:loginResponse.IDIDIOMA||null,nmacesso:loginResponse.NMACESSO||null,nmcomploper:loginResponse.NMCOMPLOPER||null,nmfilialselecionada:loginResponse.NMFILIAL||null,nrestruttrab:loginResponse.NRESTRUTTRAB||null,nrorgtrab:loginResponse.NRORGTRAB||null,nrparcnegocio:loginResponse.NRPARCNEGOCIO||null,logged:loginResponse.LOGGED,senhaExpirada:loginResponse.EXPIRED_PASSWORD,version:loginResponse.VERSION}},this.openMicroServiceUrl=function(args){var module,containerName=args.owner.msContainerName;containerName=-1==containerName.indexOf("#")?module="":(module=containerName.split("#")[0].split("_")[0],getCurrentModule()),module&&containerName&&module!=containerName&&(containerName=[{name:"USER",value:localStorage.getItem("LOGIN_USER"),operator:"="},{name:"IS_LOGGED",value:localStorage.getItem("IS_LOGGED")||!1,operator:"="},{name:"KEEP_CONNECTED",value:localStorage.getItem("LOGIN_KEEP_CONNECTED")||"No",operator:"="},{name:"LOGIN_LANGUAGE",value:localStorage.getItem("LOGIN_LANGUAGE")||window.lang,operator:"="},{name:"LOGIN_SEPARATOR",value:localStorage.getItem("LOGIN_SEPARATOR"),operator:"="}],ScreenService.showLoader(),requestDataSourceEngine.getDataSource(module+"#/lib_startSession",containerName).then(function(){ScreenService.hideLoader(),ScreenService.openLink(args.owner.url)}).catch(function(error){ScreenService.hideLoader(),self.showErrorMessage(error)}))},this.openLinkByMenu=function(menu){menu={owner:{msContainerName:(menu="string"==typeof menu?templateManager.project.getMenu(menu):menu).msContainerName,url:menu.url}};self.openMicroServiceUrl(menu)},this.openWindow=function(windowName,newWindow){return requestModulesMetadata().then(function(modules){var module=windowName.split("#")[0].split("_")[0],modules=window.location.origin+"/"+modules[module].baseUrl+"/#/"+windowName;ScreenService.openLink?ScreenService.openLink(modules,newWindow):ScreenService.openWindow(windowName)})},function(){var modulesPackage=window.modulesPackage||"modules";return restEngine.requestMetaData(modulesPackage+"#json/modules.json").then(function(response){return response.data})});function formatFavoritesData(result){return result.dataset.favorites[0].map(function(item){return{id:item.ID,name:item.NAME,label:ScreenService.i18n(item.LABEL)}})}eventAggregator.subscribe("AboutOnClick",function(){var filter;templateManager.versionData||(templateManager.versionData=!0,filter=[{name:"CURRENT_MODULE",operator:"=",value:getCurrentModule()}],ScreenService.showLoader(),requestDataSourceEngine.getDataSource("lib#/lib_getVersionInfo",filter).then(function(response){ScreenService.hideLoader(),templateManager.versionData=response.dataset.versionInfo,templateManager.versionData.dependencies.current=templateManager.versionData.dependencies.frontend,templateManager.versionData.dependencies.changeCurrentVersion=function(newVersion){templateManager.versionData.dependencies.current=templateManager.versionData.dependencies[newVersion]},templateManager.versionData.dependencies?localStorage.setItem("versionData",JSON.stringify(templateManager.versionData)):localStorage.setItem("versionData",JSON.stringify(!1))}).catch(function(error){ScreenService.hideLoader(),self.showErrorMessage(error)}))}),eventAggregator.subscribe("onContainerOpen",function(args){var versionData=JSON.parse(localStorage.getItem("versionData"));!args.container.isNext&&versionData&&versionData.dependencies&&templateManager.versionData&&templateManager.versionData.dependencies&&(templateManager.versionData.name=versionData.name,templateManager.versionData.version=versionData.version,templateManager.versionData.dependencies.backend=versionData.dependencies.backend,templateManager.versionData.dependencies.frontend=versionData.dependencies.frontend,templateManager.versionData.dependencies.modules=versionData.dependencies.modules,templateManager.versionData.dependencies.changeCurrentVersion("frontend"),templateManager.updateTemplate()),self.menuFavoritos(!1)}),this.menuFavoritos=function(forceExec){setTimeout(function(){var groupId=localStorage.getItem("ACCESS_PROFILE"),projectId=window.projectId,favoritesData=localStorage.getItem("LIB_FAVORITES_DATA");null!==favoritesData?eventAggregator.publish("ZhFavoritesOnLoad",favoritesData):projectId&&groupId&&(localStorage.getItem("IS_LOGGED")||forceExec)?(favoritesData=ZhuAclConfig.getDefaultDataSourceFilter([groupId],projectId),requestDataSourceEngine.getDataSource("zhuacl#/acl_zhu_acl_rules",favoritesData,1,void 0,void 0,void 0,12e4,12e4,void 0,!0).then(function(response){var dataset=response.dataset||{};dataset&&requestDataSourceEngine.getDataSource("lib#/lib_findFavorites",[],1,void 0,void 0,void 0,12e4,12e4,void 0,!0).then(function(result){result=formatFavoritesData(result);result&&((dataset,favorites)=>{var deferred=ZHPromise.defer(),pos=null,menuFavoritesIds=favorites.map(function(a){return a.id}),defaultRule=dataset.zhu_access_control_default_rule.defaultRule;return favorites.forEach(function(favorite){favorite.rule=defaultRule}),dataset.zhu_access_control_rule_login.forEach(function(acl){menuFavoritesIds.includes(acl.UNIQUE_ID)&&(pos=menuFavoritesIds.indexOf(acl.UNIQUE_ID),favorites[pos].rule=acl.RULE)}),favorites=favorites.filter(function(favorite){return"A"==favorite.rule||"R"==favorite.rule||localStorage.getItem("ACL_ADMINISTRATOR")}),deferred.resolve(favorites),deferred.promise})(dataset,result).then(function(favorites){favorites=JSON.stringify(favorites),localStorage.setItem("LIB_FAVORITES_DATA",favorites),eventAggregator.publish("ZhFavoritesOnLoad",favorites)}.bind(this))},function(){})})):(localStorage.getItem("IS_LOGGED")||forceExec)&&requestDataSourceEngine.getDataSource("lib#/lib_findFavorites",[],1,void 0,void 0,void 0,12e4,12e4,void 0,!0).then(function(result){result=formatFavoritesData(result);result&&(result=JSON.stringify(result),localStorage.setItem("LIB_FAVORITES_DATA",result),eventAggregator.publish("ZhFavoritesOnLoad",result))},function(){})},2e3)},eventAggregator.subscribe("ZhFavoritesOnChange",function(args){localStorage.setItem("LIB_FAVORITES_DATA",JSON.stringify(args.fullList)),args.changed.changed=!0,requestDataSourceEngine.setDataSource("lib#/lib_changeFavorites",[args.changed],void 0,void 0,void 0,void 0,!0)}),eventAggregator.subscribe("EventOnRequestError",function(eventData){var error;eventData.e&&eventData.e.e&&eventData.e.e.data&&eventData.e.e.data.data&&(error=eventData.e.e.data.data,eventData.e.e.data.config,101==error.errorCode||100==error.errorCode?eventAggregator.publish("LibInvalidToken",error.errorCode):102==error.errorCode?eventAggregator.publish("LibInvalidTokenSupportOperator"):20==error.errorCode?eventAggregator.publish("LibConcurrentAccess"):21!=error.errorCode&&22!=error.errorCode||eventAggregator.publish("LibAccessBlocked"))}),this.isJson=function(str){var result=null;try{result=JSON.parse(str)}catch(e){}return result},this.saveCollectedData=function(collectionIds,operationId,productId,operatorCode,operatorName,organizationId){return requestDataSourceEngine.setDataSource("lib#/lib_saveCollectedData",[{COLLECTION_IDS:collectionIds,OPERATION_ID:operationId,PRODUCT_ID:productId||null,OPERATOR_CODE:operatorCode||null,OPERATOR_NAME:operatorName||null,ORGANIZATION_ID:organizationId||null,changed:!0}],void 0,void 0,void 0,void 0,!0)},this.addTranslateButton=function(){templateManager.projectPromise.then(function(){var notification;window.hideTranslateButton||(notification={label:ScreenService.i18n("Atualizar Tradução"),tooltip:ScreenService.i18n("Atualizar Tradução"),name:"libTranslate",icon:"information",isVisible:!0,events:[{name:"NotificationEvent",code:"LibLoginController.updateTranslation();"}]},notification=Util.extend(new _Notification,notification),templateManager.project.notifications=templateManager.project.notifications||[],templateManager.project.notifications.push(notification))})}}Configuration(function(ContextRegister){ContextRegister.register("MenuBuilder",MenuBuilder)}),Configuration(function(ContextRegister){ContextRegister.register("LibMessages",LibMessages)}),Configuration(function(ContextRegister){ContextRegister.register("ReportDecorator",ReportDecorator)}),Configuration(function(ContainerDecoratorProvider,ContextRegister,ApplicationContext,templateManager){ContextRegister.register("ShortcutDecorator",ShortcutDecorator),ContainerDecoratorProvider.registerProvider(new ShortcutDecorator(ApplicationContext,templateManager))}),Configuration(function(ContextRegister){ContextRegister.register("LibUtilities",LibUtilities)});var ViewFloatMask=function(maskEngine){function viewFloatFormat(value,params){var defaultOptions=Util.clone($.currency.i18n[$.currency.lang]),valueFormated="";try{var options=Util.extend(defaultOptions,params||{},!0),valueFormated=$.currency.string(value,options)}catch(e){valueFormated=value}return valueFormated}var removeInvalidChar=function(value){var index=value.indexOf(".");return index+1===value.length?value.slice(0,index):value};this.register=maskEngine.registerMask("viewFloat",function(element,viewValue,params,callBack){element.val(viewValue||""),params.callback=callBack,params.showRound=!("showRound"in params)||params.showRound,params.showSymbol=!1,element.on("keypress",function(event){((e,element,params)=>{var isThousands=(params=Util.extend(Util.clone($.currency.i18n[$.currency.lang]),params||{},!0)).thousands.charCodeAt()===e.which,is_number=48<=e.which&&e.which<=57,is_dot=46==e.which,is_comma=44==e.which,is_minus=45==e.which,hasSeparator=-1!=element.val().indexOf(params.decimal)||-1!=element.val().indexOf(params.thousands),hasNegative=0<element.val().length||!params.allowNegative;(hasSeparator&&(is_dot||is_comma)||hasNegative&&is_minus||isThousands)&&e.preventDefault(),is_dot||is_comma||is_number||is_minus?element.data("maskOptions",params):e.preventDefault()})(event,element,params)}),element.on("keyup",function(event){((element,params)=>{var value,decimals;params.precision&&(decimals=(value=element[0].value).substring(value.indexOf(params.decimal||",")+1,value.length),value!=decimals)&&decimals.length>params.precision&&(element[0].value=value.substring(0,value.indexOf(params.decimal||",")+(params.precision+1)))})(element,params)}),element.on("blur",function(){element.text(((value,params)=>{var decimal,thousands,params=Util.extend(Util.clone($.currency.i18n[$.currency.lang]),params||{},!0),fltValue=params.allowZero&&!params.allowEmpty?0:"";return value=!Util.isEmptyOrBlank(value)&&(decimal=params.decimal,thousands=params.thousands,"string"==typeof value&&(params.showSymbol&&(value=value.replace(params.symbol,"")),value=(value=thousands?value.replace(new RegExp("\\"+thousands,"g"),""):value).replace(new RegExp("\\"+decimal,"g"),"."),value=removeInvalidChar(value)),fltValue=parseFloat(value),!params.allowZero&&0===fltValue||$.currency.isInvalidValue(fltValue,params))?"":value})(element.val(),params)),element.val(viewFloatFormat(element.val(),params)),params.callback(element.text())}),params.showRound&&element.on("focus",function(){var value=element.text(),viewValue=viewFloatFormat(element.val(),params);viewFloatFormat(element.text(),params)!==viewValue&&(value=element.val()),element.val(viewFloatFormat(value,params)),element.select()})},viewFloatFormat)};function WidgetsMetaData(){this.getExpiredSession=function(){return{name:"EXPIRED_SESSION",label:"Sessão Expirada",isVisible:!0,showDescriptionOrder:!1,showAsModal:!0,template:"widget/form.html",tekLibExpiredSession:!0,actions:[{name:"CONFIRM",label:"Confirmar",showAsAction:"never",events:[{name:"ActionEvent",code:"LibLoginController.expiredSessionActionEventConfirm(args)"}]},{name:"CANCEL",label:"Sair",showAsAction:"back",events:[{name:"ActionEvent",code:"LibLoginController.expiredSessionActionEventCancel()"}]}],events:[],dataSource:[],fields:[{name:"OPERATOR",label:"Usuário",template:"field/text-edit.html",class:12,readOnly:!0,isVisible:!0,showOnList:!0,showOnForm:!0},{name:"PASSWORD",label:"Senha",template:"field/password.html",class:12,focused:!0,validations:{required:!0},isVisible:!0,showOnList:!0,showOnForm:!0,events:[{name:"FieldOnKeyup",code:"LibLoginController.expiredSessionFieldOnKeyupPassword(args)"}]}]}}}function LibLoginService(requestDataSourceEngine){this.startSession=function(user){user=[{name:"USER",value:user,operator:"="},{name:"IS_LOGGED",value:localStorage.getItem("IS_LOGGED")||!1,operator:"="},{name:"LOGIN_TOKEN",value:localStorage.getItem("LOGIN_TOKEN"),operator:"="},{name:"LOGIN_LANGUAGE",value:localStorage.getItem("LOGIN_LANGUAGE")||window.lang,operator:"="},{name:"LOGIN_SEPARATOR",value:localStorage.getItem("LOGIN_SEPARATOR"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_startSession",user,1,void 0,void 0,void 0,12e4).then(function(data){return"string"==typeof data?{isError:!0,message:data}:!(!data||!data.dataset)&&data.dataset.system})},this.validateUser=function(cdOperator,password,isSupportOperator){return requestDataSourceEngine.getDataSource("login#/validateUser",[{name:"USER",value:cdOperator,operator:"="},{name:"PASSWORD",value:password,operator:"="},{name:"IS_SUPPORT_OPERATOR",value:isSupportOperator,operator:"="}])},this.logout=function(){var filter=[{name:"PROJECT",value:window.tekLoginProjectId,operator:"="},{name:"ERASE_HASH",value:localStorage.getItem("LOGIN_ERASE_HASH"),operator:"="},{name:"HASH",value:localStorage.getItem("LOGIN_HASH"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_logout",filter,1,void 0,void 0,void 0,12e4)},this.getModulesVersion=function(){return requestDataSourceEngine.getDataSource("lib#/lib_getModulesVersion",[])},this.generateModulesVersionFile=function(){return requestDataSourceEngine.setDataSource("lib#/lib_generateModulesVersionFile",[{changed:!0}])},this.downloadModulesVersionFile=function(fileName){var serviceUrl=window.serviceUrl;window.open(serviceUrl+"/lib_downloadModulesVersionFile?requestType=DataSet&dataset[0][FILE_NAME]="+fileName)},this.updateSession=function(user,accessProfile,otherSessionValues){user=[{name:"USER",value:user,operator:"="},{name:"ACCESS_PROFILE",value:accessProfile,operator:"="},{name:"OTHER_SESSION_VALUES",value:otherSessionValues,operator:"="},{name:"LOGIN_USER",value:localStorage.getItem("LOGIN_USER"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_updateSession",user)},this.updateTranslation=function(){return requestDataSourceEngine.getDataSource("lib#/lib_updateTranslation",[],1,void 0,void 0,void 0,3e5)},this.saveProductsPermission=function(licenseInfo){return requestDataSourceEngine.setDataSource("lib#/lib_saveProductsPermission",[{LICENSE_INFO:licenseInfo,changed:!0}],void 0,void 0,void 0,void 0,!0)},this.saveVariableMeasure=function(licenseInfo){return requestDataSourceEngine.setDataSource("lib#/lib_saveVariableMeasure",[{LICENSE_INFO:licenseInfo,changed:!0}],void 0,void 0,void 0,void 0,!0)},this.setLogAccess=function(){return requestDataSourceEngine.setDataSource("lib#/lib_setLogAccess",[{changed:!0}],void 0,void 0,void 0,void 0,!0)}}function LibCustomizationController(templateManager,LibUtilities,ScreenService,MessageService){this.customizationContainerAfterinit=function(){var route=localStorage.getItem("LIB_CUSTOMIZATION_ROUTE"),label=localStorage.getItem("LIB_CUSTOMIZATION_LABEL"),token=localStorage.getItem("LOGIN_TOKEN"),hash=localStorage.getItem("LOGIN_HASH")||"0",user=localStorage.getItem("LOGIN_USER"),languange=localStorage.getItem("LOGIN_LANGUAGE"),customURL=localStorage.getItem("LOGIN_CUSTOMIZATION_URL"),customURL=(clearTimeout(LibUtilities.expiredSessionMethod),customURL+route+"?header=0&menu=0&token="+token+"&hash="+hash+"&user="+user+"&languange="+languange+"&productId="+window.projectId+"&isZhAngular=1");templateManager.container.getWidget("customizationWidget").sourceUrl=customURL,templateManager.container.label=label+" "+ScreenService.i18n("(Customização)")},this.customizationMenuOnClick=function(menu){menu.route?(localStorage.setItem("LIB_CUSTOMIZATION_ROUTE",menu.route),localStorage.setItem("LIB_CUSTOMIZATION_LABEL",menu.label),ScreenService.openWindow("lib#customizationWindow"),ScreenService.isSideMenuOpen()&&ScreenService.toggleSideMenu()):MessageService.showMessageByCode("lib#ERR_NOT_FOUND_CUSTOM_ROUTE",null,{type:"ERROR"})}}function LibLoginController(LibLoginService,LibUtilities,localStorageEngine,templateManager,eventAggregator,ScreenService,metaDataFactory,WidgetsMetaData,ZhuAclController,ZhLogger,ZHPromise,MessageService){var loginUserId,loginUserName,loginIsSupOper,loginSupOperId,self=this,startSessionResponse=(window.tekLoginProjectId=angular.copy(window.projectId),this.authenticate=function(forceAuthenticate){templateManager.project.elementListDefaultRule=templateManager.project.elementListDefaultRule||"I",language=Util.getUrlParameter("lang")||localStorage.getItem("LOGIN_LANGUAGE")||window.lang,window.lang=language,ScreenService.setLanguage(language),localStorageEngine.setLocalVar("language",language),(language=Util.getUrlParameter("sep")||localStorage.getItem("LOGIN_SEPARATOR"))&&(localStorage.setItem("LOGIN_SEPARATOR",language),$.currency.i18n[window.lang])&&($.currency.i18n[window.lang].thousands=language[0],$.currency.i18n[window.lang].inputThousands=language[0],$.currency.i18n[window.lang].decimal=language[1],$.currency.i18n[window.lang].inputDecimal=language[1]),(language=Util.getUrlParameter("hash"))&&localStorage.setItem("LOGIN_HASH",language),(language=Util.getUrlParameter("keepConn"))&&localStorage.setItem("LOGIN_KEEP_CONNECTED",language);var language,authToken,setAclEventId,defer=ZHPromise.defer();return forceAuthenticate=!0===forceAuthenticate,window.location.hash.replace("#/","")==LibUtilities.authenticationContainer&&!forceAuthenticate||(language=localStorage.getItem("LOGIN_USER"),forceAuthenticate=localStorage.getItem("LOGIN_USE_REDIRECT"),authToken=(()=>{var authToken=Util.getUrlParameter("authToken");return authToken&&localStorage.setItem("LOGIN_TOKEN",authToken),authToken})(),!language&&!authToken||"S"==forceAuthenticate?(LibUtilities.redirectToLogin(),defer.resolve({})):(setAclEventId=eventAggregator.subscribe("onContainerOpen",function(){setAcl(defer.promise,setAclEventId)}),ScreenService.showLoader(),LibLoginService.startSession(language).then(function(response){ScreenService.hideLoader(),startSessionResponse(response,defer)}).catch(function(error){ScreenService.hideLoader(),!error.data||101!=error.data.errorCode&&100!=error.data.errorCode?20==error.data.errorCode?(localStorage.setItem("LOGIN_ERASE_HASH","Y"),MessageService.showCustomDialogByCode("lib#ALE_SESSION_WILL_BE_ENDED",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})):(defer.reject(error),LibUtilities.showErrorMessage(error)):self.logout()}))),defer.promise},function(response,defer){response.isError?defer.reject(response.message):response.USER_ID?response.SESSION_EXPIRED?logoutExpiredSession(!0):(response.LICENSE_INFO&&localStorage.setItem("LICENSE_INFO",response.LICENSE_INFO),response.LOGIN_USER&&response.LOGIN_TOKEN&&(localStorage.setItem("LOGIN_USER",response.LOGIN_USER),localStorage.setItem("LOGIN_TOKEN",response.LOGIN_TOKEN)),localStorage.setItem("IS_SUPPORT_OPERATOR",response.IS_SUPPORT_OPERATOR),localStorage.setItem("LOGIN_USER_ID",response.USER_ID),localStorage.setItem("LOGIN_PHP_VERSION_ID",response.PHP_VERSION_ID),localStorage.setItem("ACL_ADMINISTRATOR",response.ACL_ADMINISTRATOR),localStorage.setItem("ACCESS_PROFILE",response.ACCESS_PROFILE),localStorage.setItem("LOGIN_CUSTOMIZATION_URL",response.CUSTOMIZATION_URL),response.IS_SUPPORT_OPERATOR&&(loginIsSupOper=response.IS_SUPPORT_OPERATOR,loginSupOperId=response.SUPPORT_OPERATOR_ID),loginUserId=response.USER_ID,loginUserName=response.USER_NAME,response.IS_PENDENT_MIGRATION&&MessageService.showMessageByCode("lib#ALE_MIGRATION_IS_PENDENT",null,{type:"INFORMATION"}),response.VISIBLE_ELEMENTS&&localStorage.setItem("LOGIN_VISIBLE_ELEMENTS",JSON.stringify(response.VISIBLE_ELEMENTS)),response.ACL_ADMINISTRATOR&&LibUtilities.addTranslateButton(),defer.resolve(response)):self.logout()}),setAcl=(this.logout=function(){ScreenService.showLoader(),LibLoginService.logout().then(function(){ScreenService.hideLoader(),localStorage.removeItem("ACL_ADMINISTRATOR"),localStorage.removeItem("ACCESS_PROFILE"),localStorage.removeItem("IS_LOGGED"),localStorage.removeItem("LOGIN_USER"),localStorage.removeItem("LOGIN_TOKEN"),localStorage.removeItem("LICENSE_INFO"),localStorage.removeItem("LOGIN_ERASE_HASH"),localStorage.removeItem("IS_SUPPORT_OPERATOR"),localStorage.removeItem("LOGIN_USER_ID"),localStorage.removeItem("LOGIN_PHP_VERSION_ID"),localStorage.removeItem("LIB_FAVORITES_DATA"),LibUtilities.redirectToLogin()}).catch(function(error){ScreenService.hideLoader(),LibUtilities.showErrorMessage(error)})},function(loginPromise,setAclEventId){loginPromise.then(function(response){window.productApplyAcl||(ZhuAclController.setUserRules(response.ACCESS_PROFILE,window.projectId,response.USER_ID,response.ORGANIZATION_ID,{canConfigureAcl:response.ACL_ADMINISTRATOR,rules:!!response.ACL_ADMINISTRATOR&&[],defaultRule:!!response.ACL_ADMINISTRATOR&&"A"}),templateManager.project.aclDefaultRule="A"),eventAggregator.unSubscribe("onContainerOpen",setAclEventId)}).catch(LibUtilities.showErrorMessage)}),logoutExpiredSession=(eventAggregator.subscribe("LibExpiredSession",function(){var expiredSessionWidget;templateManager.container.getActiveWidget().tekLibExpiredSession||((expiredSessionWidget=metaDataFactory.widgetFactory(WidgetsMetaData.getExpiredSession(),templateManager.container)).attempts=0,expiredSessionWidget.dataSource.data=[],expiredSessionWidget.newRow(),expiredSessionWidget.currentRow.OPERATOR=loginUserId+" - "+loginUserName,ScreenService.openPopup(expiredSessionWidget),localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!0))}),eventAggregator.subscribe("LibInvalidToken",function(errorCode){101==errorCode?MessageService.showCustomDialogByCode("lib#ALE_EXPIRED_SESSION",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:self.logout}]}):100==errorCode&&self.logout()}),eventAggregator.subscribe("LibInvalidTokenSupportOperator",function(errorCode){MessageService.showCustomDialogByCode("lib#ALE_EXPIRED_SESSION_SUPPORT_OPERATOR",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:self.logout}]})}),eventAggregator.subscribe("LibConcurrentAccess",function(){localStorage.setItem("LOGIN_ERASE_HASH","Y"),MessageService.showCustomDialogByCode("lib#ALE_SESSION_WILL_BE_ENDED",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})}),eventAggregator.subscribe("LibAccessBlocked",function(errorCode){MessageService.showCustomDialogByCode("lib#ACCESS_BLOCKED_BY_TIME_OR_DAY",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})}),function(afterLogin){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),MessageService.getMessageByCode("lib#"+(afterLogin?"ERR_EXPIRED_SESSION_LOGIN":"ERR_ATTEMPT_END")).then(function(loadingMessage){ScreenService.changeLoadingMessage(ScreenService.i18n(loadingMessage)),ScreenService.showLoader(),Util.doAsync(self.logout,5e3)})}),reloadUpdateTranslation=(this.expiredSessionActionEventConfirm=function(args){var userId,expiredSessionWidget=args.owner.widget||args.owner.field.widget;expiredSessionWidget.isValid()&&(args=expiredSessionWidget.currentRow.PASSWORD,userId=loginSupOperId||loginUserId,ScreenService.showLoader(),LibLoginService.validateUser(userId,args,loginIsSupOper).then(function(){LibLoginService.getModulesVersion(),ScreenService.hideLoader(),localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),ScreenService.closePopup()}).catch(function(error){ScreenService.hideLoader(),error.data&&error.data.errorCode&&20==error.data.errorCode?(localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),eventAggregator.publish("LibConcurrentAccess")):error.data&&error.data.errorCode&&102==error.data.errorCode?(localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),eventAggregator.publish("LibInvalidTokenSupportOperator")):error.data&&error.data.errorCode&&(21==error.data.errorCode||22==error.data.errorCode)?(localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),eventAggregator.publish("LibAccessBlocked")):(error={attempts:++expiredSessionWidget.attempts},MessageService.showMessageByCode("lib#ERR_ATTEMPT_PARTIAL",error,{type:"ERROR"}),3<=expiredSessionWidget.attempts&&logoutExpiredSession())}))},this.expiredSessionActionEventCancel=function(){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",!1),self.logout()},this.expiredSessionFieldOnKeyupPassword=function(args){13==window.event.keyCode&&this.expiredSessionActionEventConfirm(args)},this.downloadModulesVersionFile=function(){return LibLoginService.generateModulesVersionFile().then(function(response){var fileName;return response&&response.dataset?(fileName=response.dataset.generatedFile[0],LibLoginService.downloadModulesVersionFile(fileName),!0):(LibUtilities.showErrorMessage(response),!1)}).catch(LibUtilities.showErrorMessage)},this.updateSession=function(user,accessProfile,otherSessionValues){var defer=ZHPromise.defer();return ScreenService.showLoader(),LibLoginService.updateSession(user,accessProfile,otherSessionValues).then(function(response){var sessionUpdated;ScreenService.hideLoader(),response&&response.dataset&&response.dataset.sessionUpdated?(sessionUpdated=response.dataset.sessionUpdated[0],localStorage.setItem("LOGIN_USER",sessionUpdated),defer.resolve()):defer.reject(response)}).catch(function(error){ScreenService.hideLoader(),defer.reject(error)}),defer.promise},this.expiredMenuOnClick=function(){MessageService.showMessageByCode("lib#ALE_EXPIRED_MENU",null,{type:"ERROR"})},this.updateTranslation=function(){MessageService.confirmMessageByCode("lib#ALE_UPDATE_TRANSLATION",null,{type:"CONFIRMATION",success:function(){ScreenService.showLoader(),LibLoginService.updateTranslation().then(function(){var widget=templateManager.container.getActiveWidget();self.checkContainerIsZhNext()&&$("iframe").length&&widget.sourceUrl?(window.libTranslateDefer=ZHPromise.defer(),widget=widget.sourceUrl.split("?")[0],$("iframe")[0].contentWindow.postMessage({type:"updateTranslation"},widget),window.libTranslateDefer.then(function(){reloadUpdateTranslation()}).catch(function(error){ScreenService.hideLoader(),LibUtilities.showErrorMessage(error)})):reloadUpdateTranslation()}).catch(function(error){ScreenService.hideLoader(),LibUtilities.showErrorMessage(error)})},fail:function(){}})},function(){MessageService.showMessageByCode("lib#SUC_UPDATE_TRANSLATION"),setTimeout(function(){window.location.reload(!0)},7e3)});this.checkContainerIsZhNext=function(){return!(!templateManager.container.widgets||!templateManager.container.widgets.length)&&"widget/iframe.html"==templateManager.container.widgets[0].template}}Configuration(function(ContextRegister){ContextRegister.register("ViewFloatMask",ViewFloatMask)}),Configuration(function(ContextRegister){ContextRegister.register("WidgetsMetaData",WidgetsMetaData)}),Configuration(function(ContextRegister){ContextRegister.register("LibLoginService",LibLoginService)}),Configuration(function(ContextRegister){ContextRegister.register("LibCustomizationController",LibCustomizationController)}),Configuration(function(ContextRegister){ContextRegister.register("LibLoginController",LibLoginController)});var ZeedhiFields=angular.module("ZeedhiFields");function LibZdNextListener(ScreenService,LibLoginService,LibUtilities,templateManager){window.addEventListener("message",function(event){{var versionInfo;"logoutByZdNext"===event.data.type?logoutByZdNext():"versionInfo"===event.data.type?(versionInfo=event.data.data.versionInfo)&&templateManager.versionData&&templateManager.versionData.dependencies&&(templateManager.versionData.name=versionInfo.name,templateManager.versionData.version=versionInfo.version,templateManager.versionData.dependencies.backend=versionInfo.backend,templateManager.versionData.dependencies.frontend=versionInfo.frontend,templateManager.versionData.dependencies.modules=versionInfo.modules,templateManager.versionData.dependencies.changeCurrentVersion("frontend"),templateManager.updateTemplate()):"updateTranslationNext"===event.data.type&&(event.data.data.isError?window.libTranslateDefer.reject(event.data.data.message):window.libTranslateDefer.resolve())}});var logoutByZdNext=function(){ScreenService.showLoader(),LibLoginService.logout().then(function(){ScreenService.hideLoader(),localStorage.removeItem("IS_LOGGED"),localStorage.removeItem("LOGIN_USER"),localStorage.removeItem("LOGIN_TOKEN"),localStorage.removeItem("LOGIN_ERASE_HASH"),LibUtilities.redirectToLogin()}).catch(function(error){ScreenService.hideLoader(),LibUtilities.showErrorMessage(error)})}}ZeedhiFields.directive("zhNavbarDefaultHeader",function(templateManager,ScreenService,eventAggregator,$compile,ApplicationContext){return{restrict:"C",link:function($scope,element){$scope.favoritesList=[],$scope.lastDeletedItem=void 0;var favoritesContainer,undoTimeout,favoritesText=ScreenService.i18n("Favoritos"),favoritesAddText=ScreenService.i18n("Adicionar aos Favoritos"),favoritesRemoveText=ScreenService.i18n("Remover dos Favoritos"),favoritesUndoText=ScreenService.i18n("Desfazer");function checkIsFavorited(containerId){var oldIsFavorited=$scope.isFavorited;$scope.isFavorited=-1!==$scope.favoritesList.findIndex(function(item){return item.id===containerId}),oldIsFavorited!==$scope.isFavorited&&templateManager.updateTemplate()}$scope.addToFavorites=function(){var item={id:templateManager.container.id,name:templateManager.container.fileName.split(".json")[0],label:ScreenService.i18n(templateManager.container.label)};$scope.favoritesList.push(item),$scope.isFavorited=!0,eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:item,status:"add"}})},$scope.removeFromFavorites=function(){var index=$scope.favoritesList.findIndex(function(item){return item.id===templateManager.container.id});-1<index&&(index=$scope.favoritesList.splice(index,1),$scope.isFavorited=!1,eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:index,status:"delete"}}))},$scope.openItem=function(item){ApplicationContext.LibUtilities.openWindow(item.name),$scope.opened=!1},$scope.deleteItem=function(item,index,event){$scope.favoritesList.splice(index,1),$scope.lastDeletedItem={item:item,index:index},clearTimeout(undoTimeout),undoTimeout=setTimeout(function(){$scope.lastDeletedItem=void 0,templateManager.updateTemplate()},1e4),eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:item,status:"delete"}}),item.id===templateManager.container.id&&($scope.isFavorited=!1),event.stopImmediatePropagation()},$scope.undo=function(){$scope.lastDeletedItem&&$scope.favoritesList.splice($scope.lastDeletedItem.index,0,$scope.lastDeletedItem.item),$scope.lastDeletedItem=void 0},$scope.toggleList=function(){$scope.opened=!$scope.opened},document.addEventListener("mousedown",function(evt){0===$(favoritesContainer).find(evt.target).length&&$scope.opened&&($scope.opened=!1,templateManager.updateTemplate())}),eventAggregator.subscribe(eventAggregator.ON_CONTAINER_OPEN,function(args){checkIsFavorited(args.container.id)}),eventAggregator.subscribe("ZhFavoritesOnLoad",function(favorites){favorites=JSON.parse(favorites),$scope.favoritesList=favorites,templateManager.container&&checkIsFavorited(templateManager.container.id)}),$(element).children()[0].style.width="calc(100% - 50px)",favoritesContainer=$('<div class="zh-favorites"></div>').appendTo(element),element=$compile('<div class="zh-favorites-button" ng-click="toggleList()">  <div class="zh-favorites-button-star" ng-if="!isFavorited">    <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">\t<style type="text/css">\t\t.st0{fill:#FFFFFF;}\t</style>\t<g>\t\t<path class="st0" d="M15,4.21l3.51,7.1l7.84,1.14l-5.67,5.53l1.34,7.81L15,22.1l-7.01,3.69l1.34-7.81l-5.67-5.53l7.84-1.14L15,4.21\t\t\t M15,2.21c-0.76,0-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05\t\t\tl4.92,4.8l-1.16,6.77c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2\t\t\tc0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8\t\t\tc0.55-0.53,0.74-1.33,0.51-2.05c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21L15,2.21z"/>\t</g></svg>  </div>  <div class="zh-favorites-button-star" ng-if="isFavorited">    <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">\t<style type="text/css">\t\t.st0{fill:#FFFFFF;}\t</style>\t<g>\t\t<path class="st0" d="M28.25,11.83c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21\t\t\ts-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05l4.92,4.8l-1.16,6.77\t\t\tc-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2\t\t\tc0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8\t\t\tC28.29,13.35,28.48,12.56,28.25,11.83z"/>\t</g></svg>  </div>  <div class="zh-favorites-button-text">'+favoritesText+"</div></div>")($scope),$(element).appendTo(favoritesContainer),element=$compile('<div class="zh-favorites-list" ng-class="{\'opened\': opened}">  <div class="zh-favorites-list-button" ng-if="!isFavorited" ng-click="addToFavorites()">'+favoritesAddText+'</div>  <div class="zh-favorites-list-button" ng-if="isFavorited" ng-click="removeFromFavorites()">'+favoritesRemoveText+'</div>  <div class="zh-favorites-list-undo" ng-show="false" ng-click="undo()">'+favoritesUndoText+'</div>  <div class="zh-favorites-list-items" ng-show="favoritesList.length > 0">\t <div class="zh-favorites-list-item" ng-repeat="item in favoritesList track by item.id" ng-click="openItem(item)">      {{ item.label }}      <span class="zh-favorites-list-item-delete" data-zh-icon="trash icon-white no-border" ng-click="deleteItem(item, $index, $event)"></span>    </div>  </div></div>')($scope),$(element).appendTo(favoritesContainer)}}}),Configuration(function(ContextRegister){ContextRegister.register("LibZdNextListener",LibZdNextListener)}),angular.module("ZeedhiApp").config(function($httpProvider){Boolean(window.applicationVersion)?$httpProvider.interceptors.push(function(){return{request:function(config){return config&&config.url&&(url=>(url=url.split("?")[0],Util.stringEndsWith(url,".json")||Util.stringEndsWith(url,".html")||Util.stringEndsWith(url,".svg")))(config.url)&&(-1!==config.url.indexOf("?")?config.url+="&":config.url+="?",config.url+="v="+window.applicationVersion),config}}}):console.warn('Missing "applicationVersion" global property for CacheBypass.')});